unit CompCadreIma2;
// Un TCompCadreIma2 est un TPanel contenant un TImage et un TLabel
// Pour afficher une image avec lgende : Affiche(NomFichier,Titre)
// Si NomFichier='' on affiche la lgende avec une Image blanche
// Si Titre='' on affiche seulement l'image
// La fonte de la lgende est la mme que celle du TPanel
//(on peut donc la modifier facilement)

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Donnees,ExtCtrls,GR32, GR32_Image,GR32_Layers,Str_Echelles;

type
  //TCliqueImage=procedure(Sender:TTCadreImage2;Picture:TPicture);
  TCadreImage2=class(TPanel)
  private
     Image:TImage32;
     FClientR:TRect;
     FTitre:TLabel;
     FSelected:boolean;
     LesLegendes:TStringList;
     X0,Y0:integer;
     procedure AjusteZoneClient;
     procedure Clique(Sender:TObject);
     procedure DoubleClique(Sender:TObject);
     procedure SourisMove(Sender: TObject;Shift: TShiftState; X, Y: Integer;
                Layer: TCustomLayer);
     procedure SourisDown(Sender: TObject; Button: TMouseButton;
                Shift: TShiftState; X, Y: Integer;Layer: TCustomLayer);
     procedure SourisUp(Sender: TObject; Button: TMouseButton;
                Shift: TShiftState; X, Y: Integer;Layer: TCustomLayer);
     procedure TitreSourisMove(Sender: TObject;Shift: TShiftState; X, Y: Integer);
     procedure TitreSourisDown(Sender: TObject; Button: TMouseButton;
                Shift: TShiftState; X, Y: Integer);
     procedure AfficheTitre(L: string);
     procedure SetSelected(Value: boolean);
     procedure AfficheEtat; // change apparence du bouton en fn de l'tat (selectionne ou non)
     procedure Copie_c_prov;
     procedure combineblend(F: TColor32; var B: TColor32; M: TColor32);
  public
     TypeTax:string;
     Echelle:TEchelle;
     Mesure:string;
     ADesLegendes:boolean;
     LegendesAffichees:boolean;
     C_trace : TBitmapLayer;
     C_prov : TBitmapLayer;
     MonZoom:Real;
     Numero:integer;
     constructor Create(AOwner: TComponent);override;
     destructor Destroy;override;
     procedure AfficheStream(LeStream:TMemoryStream;Extension,Titre:string);
     procedure Affiche(NomFichier:string;Titre:string);
     procedure RecadreImage;
     procedure AfficheLegendes;
     procedure EffaceLegendes;
     property Selected:boolean read FSelected write SetSelected;
     property GetImage:TImage32 read Image;
  end;

procedure Register;


implementation
uses Dessins,jpeg,GR32_Blend,ExtActns, IdBaseComponent, IdComponent, IdTCPConnection, IdTCPClient,
  IdHTTP,utils;
constructor TCadreImage2.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  Parent:=TWinControl(AOwner);
  Color:=clWhite; // pourrait tre fixe  l'extrieur
  Caption:='';

  Image:=TImage32.Create(Self);
  Image.Parent:=Self;
  Image.OnClick:=Clique;
  Image.OnDblClick:=DoubleClique;
  Image.OnMouseMove:=SourisMove;
  Image.OnMouseDown:=SourisDown;
  Image.OnMouseUp:=SourisUp;
  Image.ScaleMode:=smScale;

  FTitre:=TLabel.Create(Self);
  FTitre.Parent:=Self;
  FTitre.Autosize:=false;
  FTitre.Visible:=false;
  FTitre.OnClick:=Clique;
  FTitre.OnDblClick:=DoubleClique;
  FTitre.OnMouseMove:=TitreSourisMove;
  FTitre.OnMouseDown:=TitreSourisDown;
  if C_trace=nil then
    begin
      C_trace := TBitmapLayer.Create(Image.Layers);
      with C_trace do
        begin
          Bitmap.DrawMode := dmBlend;
          Bitmap.MasterAlpha := 255;
          Scaled:=True;
          Bitmap.SetSize(0,0);
          Location:=FloatRect(0,0,0,0);
        end;
    end;
  if C_prov=nil then
    begin
      C_prov := TBitmapLayer.Create(Image.Layers);
      with C_prov do
        begin
          Bitmap.DrawMode := dmBlend;
          Bitmap.MasterAlpha := 255;
          Scaled:=False;
          Bitmap.SetSize(0,0);
          Location:=FloatRect(0,0,0,0);
        end;
    end;
  LesLegendes:=TStringList.Create;
  Selected:=false;
  MonZoom:=1;
  X0:=-1;
  Y0:=-1;
  Echelle.active:=False;
  CouleurF:=clWhite32;
end;                                          //
procedure TCadreImage2.SourisMove(Sender:TObject ;Shift: TShiftState; X, Y: Integer;
  Layer: TCustomLayer);
Var
  l:real;
  XD,YD,XF,YF:integer;
begin
  if (ssleft in Shift) and Echelle.active and (MonZoom>0) then
    begin
      Mesure:='';
      l:=Sqrt(Sqr(X-X0)+Sqr(Y-Y0))*Echelle.coeff/MonZoom;
      XD:=Round(X0*MonZoom);
      YD:=Round(Y0*MonZoom);
      XF:=Round(X*MonZoom);
      YF:=Round(Y*MonZoom);
      C_Prov.Bitmap.Clear($00FFFFFF);
      //C_Prov.Bitmap.LineS(XD,YD,XF,YF,clBlack32,True);
      C_Prov.Bitmap.LineS(X0,Y0,X,Y,clBlack32,True);
      Image.Repaint;
      Mesure:=AfficheNombre(l)+' '+Echelle.unite;
    end;
  if Assigned(OnMouseMove) then Self.OnMouseMove(Self,Shift,X,Y);
end;
procedure TCadreImage2.SourisDown(Sender: TObject; Button: TMouseButton;
                         Shift: TShiftState; X, Y: Integer;Layer: TCustomLayer);
begin
  X0:=X;
  Y0:=Y;
  C_Prov.Bitmap.Clear($00FFFFFF);
  Image.Repaint;
  if Assigned(OnMouseDown) then Self.OnMouseDown(Self,Button,Shift,X,Y);
end;
procedure TCadreImage2.SourisUp(Sender: TObject; Button: TMouseButton;
                         Shift: TShiftState; X, Y: Integer;Layer: TCustomLayer);
Var
  l:real;
  XD,YD,XF,YF:integer;
begin
  if Echelle.active and (MonZoom>0) then
    begin
      l:=Sqrt(Sqr(X-X0)+Sqr(Y-Y0))*Echelle.coeff/MonZoom;
      XD:=Round(X0*MonZoom);
      YD:=Round(Y0*MonZoom);
      XF:=Round(X*MonZoom);
      YF:=Round(Y*MonZoom);
      C_Prov.Bitmap.Clear($00FFFFFF);
      //C_Prov.Bitmap.LineS(XD,YD,XF,YF,clBlack32,True);
      C_Prov.Bitmap.LineS(X0,Y0,X,Y,clBlack32,True);
      if l>0 then
        Mesure:=AfficheNombre(l)+' '+Echelle.unite
      else
        Mesure:='';
      Image.Repaint;
    end;
  X0:=-1;
  Y0:=-1;
  if Assigned(OnMouseUp) then Self.OnMouseUp(Self,Button,Shift,X,Y);
end;
procedure TCadreImage2.TitreSourisMove(Sender:TObject ;Shift: TShiftState; X, Y: Integer);
begin
  if Assigned(OnMouseMove) then Self.OnMouseMove(Self,Shift,X,Y);
end;
procedure TCadreImage2.TitreSourisDown(Sender: TObject; Button: TMouseButton;
                         Shift: TShiftState; X, Y: Integer);
Var
  YD:integer;
begin
  YD:=Image.Height;
  if Assigned(OnMouseDown) then Self.OnMouseDown(Self,Button,Shift,X,Y+YD);
end;
procedure TCadreImage2.Clique(Sender:TObject);
begin
   if Assigned(OnClick) then Self.Onclick(Self);
end;
procedure TCadreImage2.DoubleClique(Sender:TObject);
begin
   if Assigned(OnDblClick) then Self.OnDblclick(Self);
end;
procedure TCadreImage2.AjusteZoneClient;
begin
  FClientR:=ClientRect;
  //AdjustClientRect(FClientR);
end;
procedure TCadreImage2.AfficheStream(LeStream:TMemoryStream;Extension,Titre:string);
var
  ImgStream: TStream;
  MonImgStream:TFileStream;
  buffer:array[0..10] of Char;
  w,h: Integer;
  i,p:integer;
  UnDessin:TDessin;
  NomDessin,codage:String;
  nombredessins:word;
  nbc:word;
  Bitmaptp:TBitmap;
  chaineCom:string;
  JPGImage:TJPEGImage;
  EchelleCoul:TEchelleCoul;
  color:TColor32;
begin
  AjusteZoneClient;
  AfficheTitre(Titre);
  FTitre.AutoSize:=True;
  FTitre.Caption:=Titre;
  if Titre='' then
    begin
      FTitre.Height:=0;
      FTitre.Visible:=False;
    end
  else
    begin
      FTitre.Alignment:=taCenter;
      FTitre.Left:=FClientR.Left;
      FTitre.Font.Assign(Font);
      FTitre.AutoSize:=False;
      FTitre.Refresh;
      FTitre.Top:=FClientR.Bottom-FTitre.Height;//-5
      FTitre.Width:=FClientR.Right-FClientR.Left;
      FTitre.Refresh;
      FTitre.Visible:=True;
    end;
  Image.Left:=FClientR.Left;
  Image.Top:=FClientR.Top;
  Image.Width:=FClientR.Right-FClientR.Left;
  Image.Height:=FClientR.Bottom-FClientR.Top-FTitre.Canvas.TextHeight(Titre);
  C_Prov.Bitmap.Clear($00FFFFFF);
  C_trace.Bitmap.Clear($00FFFFFF);
  //Image.Center:=True;
  if (LeStream.Size = 0) then
    Image.Bitmap.SetSize(0,0)
  else
    begin
      Echelle.active:=False;
      LesLegendes.Clear;
      ADesLegendes:=False;
      nombredessins:=LesLegendes.Count;
      for i:=0 to nombredessins-1 do
        (LesLegendes.Objects[i] as Tdessin).Free;
      if UpperCase(Extension)='.MSU' then
        begin
          ImgStream := LeStream;
          try
            ImgStream.position:=1; // saute le numero de type
            Imgstream.Read(nbc,2); // lecture du commentaire ventuel
            SetString(chaineCom, nil,nbc);
            ImgStream.Read(Pointer(chaineCom)^,nbc);
            //Commentaire.Text:=chaineCom;

            Imgstream.Read(nombredessins,2); // lecture des dessins ventuels
            for i:=0 to nombredessins-1 do
              begin
                Imgstream.Read(buffer,1);
                nbc:=ord(buffer[0]);
                SetString(NomDessin, nil,nbc);
                ImgStream.Read(Pointer(NomDessin)^,nbc);
                UnDessin:=TDessin.Create;
                UnDessin.ReadFromStream(ImgStream);
                LesLegendes.AddObject(NomDessin,UnDessin);
              end;
            Echelle:=Lit_Stream_Echelle(ImgStream); // lecture de l'chelle
            if Echelle.unite='pixels' then
              Echelle.active:=false;
            EchelleCoul:=Lit_Stream_EchelleCoul(ImgStream); // lecture de l'chelle des couleurs
            Imgstream.Read(buffer,1);
            nbc:=ord(buffer[0]);
            SetString(Codage, nil,nbc);
            ImgStream.Read(Pointer(Codage)^,nbc);  //type de fond (jpg, png, bmp, non =simple couleur de fond
            {if (codage='bmp') or (codage='png') or (codage='jpg')  then
              Image.Bitmap.LoadFromStream(ImgStream)}
            if codage='bmp' then
              begin
                Image.Bitmap.LoadFromStream(ImgStream);
              end
            else if codage='jpg' then
              begin
                Bitmaptp:=TBitmap.Create;
                JPGImage:=TJPEGImage.Create;
                try
                  JPGImage.LoadFromStream(ImgStream);
                  Bitmaptp.Assign(JPGImage);
                  Image.Bitmap.Assign(Bitmaptp);
                finally
                  JPGImage.free;
                  Bitmaptp.free;
                end;
              end
            else
              begin
                ImgStream.Read(buffer,2);
                W:=ord(buffer[0])+256*ord(buffer[1]);
                Image.bitmap.Width:=w;
                ImgStream.Read(buffer,2);
                h:=ord(buffer[0])+256*ord(buffer[1]);
                Image.bitmap.Height:=h;

                ImgStream.Read(color,4);
                CouleurF:=Color;
                Image.bitmap.SetSize(w,h);
                Image.bitmap.Clear(CouleurF);
              end;
          except
            Image.Bitmap.SetSize(0,0);
          end;
          LegendesAffichees:=False;
          C_Trace.Visible:=False;
          C_Trace.Bitmap.SetSizeFrom(Image.Bitmap);
          C_Trace.Location:=FloatRect(0,0,Image.Bitmap.Width,Image.Bitmap.Height);
          C_Prov.Bitmap.SetSizeFrom(Image.Bitmap);
          C_Prov.Location:=FloatRect(0,0,Image.Bitmap.Width,Image.Bitmap.Height);
          C_Trace.Bitmap.Clear($00FFFFFF);
          C_Prov.Bitmap.Clear($00FFFFFF);
          C_Prov.Visible:=True;
          for i:=0 to LesLegendes.Count-1 do
            begin
              C_prov.Bitmap.Clear($00FFFFFF);
              UnDessin:=(LesLegendes.Objects[i] as TDessin);
              if UnDessin.cat <> ctRemplissage then
                begin
                  C_Prov.Bitmap.MasterAlpha:=UnDessin.opaciteD;
                  UnDessin.TraceSur(Image.Bitmap,C_prov.Bitmap);
                  Copie_c_prov;
                end
              else UnDessin.TraceSur(Image.Bitmap,C_trace.Bitmap);
            End;
          ADesLegendes:=(LesLegendes.Count>0);
          C_prov.Bitmap.Clear($00FFFFFF);
        end
      else
        begin
          if UpperCase(Extension)='.BMP' then
            Image.bitmap.LoadFromStream(LeStream)
          else if UpperCase(Extension)='.JPG' then
            begin
              Bitmaptp:=TBitmap.Create;
              JPGImage:=TJPEGImage.Create;
              try
                JPGImage.LoadFromStream(LeStream);
                Bitmaptp.Assign(JPGImage);
                Image.Bitmap.Assign(Bitmaptp);
              finally
                JPGImage.free;
                Bitmaptp.free;
              end;
            end;
          RecadreImage;
        end;
      RecadreImage;
    end;
end;

procedure TCadreImage2.Affiche(NomFichier:string;Titre:string);
var
  ImgStream: TStream;
  MonImgStream:TFileStream;
  LeStream : TMemoryStream;
  buffer:array[0..10] of Char;
  w,h: Integer;
  i,p:integer;
  UnDessin:TDessin;
  NomDessin,codage:String;
  nombredessins:word;
  nbc:word;
  Bitmaptp:TBitmap;
  chaineCom:string;
  JPGImage:TJPEGImage;
  EchelleCoul:TEchelleCoul;
  color:TColor32;
  //RepTemp:String;
  //NF:string;
  //ActionInternet:TDownLoadURL;
  Extension : string;
  //Internet : TIdHTTP;
begin
  AjusteZoneClient;
  AfficheTitre(Titre);
  FTitre.AutoSize:=True;
  FTitre.Caption:=Titre;
  if Titre='' then
    begin
      FTitre.Height:=0;
      FTitre.Visible:=False;
    end
  else
    begin
      FTitre.Alignment:=taCenter;
      FTitre.Left:=FClientR.Left;
      FTitre.Font.Assign(Font);
      FTitre.AutoSize:=False;
      FTitre.Refresh;
      FTitre.Top:=FClientR.Bottom-FTitre.Height;//-5
      FTitre.Width:=FClientR.Right-FClientR.Left;
      FTitre.Refresh;
      FTitre.Visible:=True;
    end;
  Image.Left:=FClientR.Left;
  Image.Top:=FClientR.Top;
  Image.Width:=FClientR.Right-FClientR.Left;
  Image.Height:=FClientR.Bottom-FClientR.Top-FTitre.Canvas.TextHeight(Titre);
  C_Prov.Bitmap.Clear($00FFFFFF);
  C_trace.Bitmap.Clear($00FFFFFF);
  //Image.Center:=True;
  if (NomFichier = '') then
    Image.Bitmap.SetSize(0,0)
  else
    begin
      Echelle.active:=False;
      LesLegendes.Clear;
      ADesLegendes:=False;
      nombredessins:=LesLegendes.Count;
      for i:=0 to nombredessins-1 do
        (LesLegendes.Objects[i] as Tdessin).Free;
      //NF := NomFichier;
      Extension := UpperCase(ExtraitExtension(NomFichier));
      if Extension='.MSU' then
        begin
          if FichierInternet(NomFichier) then  //URL
            begin
              LeStream := ChargeFichier_el(NomFichier,True);
              ImgStream := LeStream;
              //NF := LowerCase(NomFichier);
{              LeStream := TMemoryStream.Create;
              ImgStream := LeStream;
}
            end
          else
            begin
              MonImgStream:= TFileStream.Create(NomFichier,(fmOpenRead or fmShareDenyWrite));
              ImgStream:=MonImgStream;
            end;
          try
{            if pos('HTTP',UpperCase(NomFichier))>0 then  //URL
              begin
                Internet := TIdHTTP.Create(Nil);
                Try
                  Internet.Get(NF, LeStream);
                  LeStream.Seek(0, soFromBeginning);
                Finally
                  Internet.Free;
                End;
              end;
}
            if ImgStream.Size > 0 then
              begin
                ImgStream.position:=1; // saute le numero de type
                Imgstream.Read(nbc,2); // lecture du commentaire ventuel
                SetString(chaineCom, nil,nbc);
                ImgStream.Read(Pointer(chaineCom)^,nbc);
                //Commentaire.Text:=chaineCom;

                Imgstream.Read(nombredessins,2); // lecture des dessins ventuels
                for i:=0 to nombredessins-1 do
                  begin
                    Imgstream.Read(buffer,1);
                    nbc:=ord(buffer[0]);
                    SetString(NomDessin, nil,nbc);
                    ImgStream.Read(Pointer(NomDessin)^,nbc);
                    UnDessin:=TDessin.Create;
                    UnDessin.ReadFromStream(ImgStream);
                    LesLegendes.AddObject(NomDessin,UnDessin);
                  end;
                Echelle:=Lit_Stream_Echelle(ImgStream); // lecture de l'chelle
                if Echelle.unite='pixels' then
                  Echelle.active:=false;
                EchelleCoul:=Lit_Stream_EchelleCoul(ImgStream); // lecture de l'chelle des couleurs
                Imgstream.Read(buffer,1);
                nbc:=ord(buffer[0]);
                SetString(Codage, nil,nbc);
                ImgStream.Read(Pointer(Codage)^,nbc);  //type de fond (jpg, png, bmp, non =simple couleur de fond
                {if (codage='bmp') or (codage='png') or (codage='jpg')  then
                  Image.Bitmap.LoadFromStream(ImgStream)}
                if codage='bmp' then
                  begin
                    Image.Bitmap.LoadFromStream(ImgStream);
                  end
                else if codage='jpg' then
                  begin
                    Bitmaptp:=TBitmap.Create;
                    JPGImage:=TJPEGImage.Create;
                    try
                      JPGImage.LoadFromStream(ImgStream);
                      Bitmaptp.Assign(JPGImage);
                      Image.Bitmap.Assign(Bitmaptp);
                    finally
                      JPGImage.free;
                      Bitmaptp.free;
                    end;
                  end
                else
                  begin
                    ImgStream.Read(buffer,2);
                    W:=ord(buffer[0])+256*ord(buffer[1]);
                    Image.bitmap.Width:=w;
                    ImgStream.Read(buffer,2);
                    h:=ord(buffer[0])+256*ord(buffer[1]);
                    Image.bitmap.Height:=h;

                    ImgStream.Read(color,4);
                    CouleurF:=Color;
                    Image.bitmap.SetSize(w,h);
                    Image.bitmap.Clear(CouleurF);
                  end;
              end;
          finally
            ImgStream.Free;
          end;
          LegendesAffichees:=False;
          C_Trace.Visible:=False;
          C_Trace.Bitmap.SetSizeFrom(Image.Bitmap);
          C_Trace.Location:=FloatRect(0,0,Image.Bitmap.Width,Image.Bitmap.Height);
          C_Prov.Bitmap.SetSizeFrom(Image.Bitmap);
          C_Prov.Location:=FloatRect(0,0,Image.Bitmap.Width,Image.Bitmap.Height);
          C_Trace.Bitmap.Clear($00FFFFFF);
          C_Prov.Bitmap.Clear($00FFFFFF);
          C_Prov.Visible:=True;
          for i:=0 to LesLegendes.Count-1 do
            begin
              C_prov.Bitmap.Clear($00FFFFFF);
              UnDessin:=(LesLegendes.Objects[i] as TDessin);
              if UnDessin.cat <> ctRemplissage then
                begin
                  C_Prov.Bitmap.MasterAlpha:=UnDessin.opaciteD;
                  UnDessin.TraceSur(Image.Bitmap,C_prov.Bitmap);
                  Copie_c_prov;
                end
              else UnDessin.TraceSur(Image.Bitmap,C_trace.Bitmap);
            End;
          ADesLegendes:=(LesLegendes.Count>0);
          C_prov.Bitmap.Clear($00FFFFFF);
        end
      else
        begin
          if FichierInternet(NomFichier) then  //URL
            begin
              //NF := LowerCase(NomFichier);
              LeStream := ChargeFichier_el(NomFichier,True);
              try
                if LeStream.Size > 0 then
                  begin
                    if Extension='.BMP' then
                      Image.bitmap.LoadFromStream(LeStream)
                    else if Extension='.JPG' then
                      begin
                        Bitmaptp:=TBitmap.Create;
                        JPGImage:=TJPEGImage.Create;
                        try
                          JPGImage.LoadFromStream(LeStream);
                          Bitmaptp.Assign(JPGImage);
                          Image.Bitmap.Assign(Bitmaptp);
                        finally
                          JPGImage.free;
                          Bitmaptp.free;
                        end;
                      end;
                    RecadreImage;
                  end;
              finally
                LeStream.Free;
              end;
{              LeStream := TMemoryStream.Create;
              With TIdHTTP.Create(Nil) Do
              Try
                Try
                  Get(NF, LeStream);
                  LeStream.Seek(0, soFromBeginning);
                  Image.bitmap.LoadFromStream(LeStream);
                  RecadreImage;
                Except
                  MessageDlg('Erreur de chargement internet',mtError,[mbOK],0);
                End;
              Finally
                LeStream.Free;
                Free;
              End;
}
            end
          else
            Image.Bitmap.LoadFromFile(NomFichier);
        end;
      RecadreImage;
    end;
end;

procedure TCadreImage2.AfficheTitre(L: string);
begin
  AjusteZoneClient;
  FTitre.Caption:=L;
  FTitre.Alignment:=taCenter;
  if L='' then FTitre.Height:=0;
  FTitre.Left:=FClientR.Left;
  FTitre.Font.Assign(Font);
  FTitre.Refresh;
  FTitre.Top:=FClientR.Bottom-FTitre.Height;//-5
  FTitre.Width:=FClientR.Right-FClientR.Left;
  FTitre.Refresh;
  FTitre.Visible:=True;
end;
procedure TCadreImage2.RecadreImage;
Var
  RX,RY:real;
begin
  if (Image.Height>0) and (Image.Width>0) and (Image.Bitmap.Height>0)
                                            and (Image.Bitmap.Width>0) then
    begin
      MonZoom:=1;
      if (Abs(Image.Height-Image.Bitmap.Height)>5)and (Abs(Image.Width-Image.Bitmap.Width)>5) then
        begin
          RY:=Image.Height/Image.Bitmap.Height;
          RX:=Image.Width/Image.Bitmap.Width;
          if (RX<1) or (RY<1) then
            begin
              if RX<RY then
                MonZoom:=RX
              else
                MonZoom:=RY;
            end
          else
            begin
              if RX<RY then
                MonZoom:=RX
              else
                MonZoom:=RY;
            end;
        end;

      Image.Scale:=MonZoom;
      Image.Repaint;
    end;
end;
procedure TCadreImage2.AfficheLegendes;
begin
  C_trace.Visible:=Not C_trace.Visible;
  LegendesAffichees:=C_Trace.Visible;
  C_Trace.BringToFront;
  C_trace.Changed;
  Image.Repaint;
end;
procedure TCadreImage2.EffaceLegendes;
begin
  C_trace.Visible:=False;
  LegendesAffichees:=False;
  C_trace.Changed;
  Image.Repaint;
end;
procedure TCadreImage2.Copie_c_prov;
begin
  if (C_Prov=nil) or (C_trace=nil) then exit;
  C_Prov.Bitmap.DrawMode:=dmCustom;
  C_Prov.Bitmap.OnPixelCombine:=combineblend;
  C_Prov.Bitmap.DrawTo(C_trace.Bitmap);
  C_Prov.Bitmap.DrawMode:=dmBlend;
  C_Prov.Bitmap.OnPixelCombine:=nil;
  C_prov.Bitmap.Clear($00FFFFFF);
end;
{procedure TCadreImage2.CopieTransp(F: TColor32; var B: TColor32; M: TColor32);
  begin
    if F=CouleurF then B:=$00FFFFFF else B:=F;
 end;
}
procedure TCadreImage2.combineblend(F: TColor32; var B: TColor32; M: TColor32);
var
  Alp,Alp2:integer;
begin
  if (AlphaComponent(F)>0) then
    if (SetAlpha(F,M)<>B) then
    begin
      Alp:=Round(AlphaComponent(F)*M/255);
      if AlphaComponent(B)>0 then  //  revoir
        begin
          Alp2:=Alp;
          if Alphacomponent(B)>Alp then Alp:=Alphacomponent(B);
          if Wincolor(B)<>Wincolor(F) then
            begin
              BlendMemEx(F,B,M);
              EMMS;
            end;
          B:=SetAlpha(B,Alp);
        end
      else //OK
        begin
          B:=F;
          B:=SetAlpha(B,Alp);
        end;
    end;
end;

procedure Register;
begin
   RegisterComponents('Phylo',[TCadreImage2]);
end;

destructor TCadreImage2.Destroy;
begin
   C_trace.Free;
   C_prov.Free;
   Image.Free;
   FTitre.Free;
   LesLegendes.Free;
   inherited Destroy;
end;

procedure TCadreImage2.SetSelected(Value: boolean);
begin
   FSelected:=Value;
   AfficheEtat;
end;

procedure TCadreImage2.AfficheEtat;
begin
   if FSelected then
     begin
       if pos('F',TypeTax)>0 then
         begin
           FTitre.Color:=clYellow;//clAqua;//clBlue;
           FTitre.Font.Color:=clRed; //$8282FF;
         end
       else if pos('E',TypeTax)>0 then
         begin
           FTitre.Color:=clYellow;
           FTitre.Font.Color:= clBlue;
         end
       else
         begin
           FTitre.Color:=clYellow;//clBlue;
           FTitre.Font.Color:= clBlack;//clWhite;
         end;
       FTitre.Align := alBottom;
     end
   else
     begin
       if pos('F',TypeTax)>0 then
         begin
           FTitre.Color:=clWhite;
           FTitre.Font.Color:= clRed;// $8282FF;
         end
       else if pos('E',TypeTax)>0 then
         begin
           FTitre.Color:=clWhite;
           FTitre.Font.Color:= clBlue;
         end
       else
         begin
           FTitre.Color:=clWhite;
           FTitre.Font.Color:=clBlack;
         end;
     end;
end;

end.
