unit Str_Echelles;

interface
uses WinTypes,Classes,SysUtils,Graphics;
type
  TEchelle=record
    active:boolean;
    case mode:0..3 of   {mode :0 (longueur) 1 (XY) 2 (diag triangulaire) 3 (coordonnes polaires) }
      0:(
          coeff:real;
          unite:string[20];
        );
      1:(
          cadre_actif:TRect;
          zero_X:Integer;
          coeff_X:real;
          unite_X:string[20];
          nombre_Y:0..3;
          coeff_Y1:real;
          unite_Y1:string[20];
          zero_Y1:Integer;
          coeff_Y2:real;
          unite_Y2:string[20];
          zero_Y2:Integer;
          coeff_Y3:real;
          unite_Y3:string[20];
          zero_Y3:Integer;
        );
      2:(
          X_G:Integer;
          Y_G:Integer;
          longueur:Integer;
          sens:Integer;
          nom_X:string[20];
          nom_Y:string[20];
          nom_Z:string[20];
        );
      3:(
          X_C:Integer;
          Y_C:Integer;
          unite_angle:string[2];
          angle_Zero:real; {reprage de la direction de l'angle nul}
          coeff_r:real;
          unite_r:string[20];
        );
  end;
  TEchelleCoul=record
    active:boolean;
    case mode:0..4 of   {mode :0 (couleurs,fausses couleurs: 3 composantes)
                        1 (dgrad dfini par 3 couleurs);
                        2 (dgrad dfini par les 2 couleurs extrmes);
                        3 (n valeurs repres)
                        4 (3 composantes  16 intervalles reprs)}
      0:(
          valminC1:real;
          valminC2:real;
          valminC3:real;
          valmaxC1:real;
          valmaxC2:real;
          valmaxC3:real;
          signifC1:string[20];
          signifC2:string[20];
          signifC3:string[20];
          coulsymbC1:TColor;
          coulsymbC2:TColor;
          coulsymbC3:TColor;
        );
      1:(
          RVB:integer;
          couleurDeb:TColor;
          couleurMil:TColor;
          couleurFin:TColor;
          valmin3C:real;
          valmax3C:real;
          logar3C:boolean;
          signif3C:string[20];
          unite3C:string[20];
        );
      2:(
          couleurMin:TColor;
          couleurMax:TColor;
          valmin2C:real;
          valmax2C:real;
          logar2C:boolean;
          signif2C:string[20];
          unite2C:string[20];
        );
      3:(
          nombre:byte;
          signifD:string[20];
          uniteD:string[20];
          valeurs:array[0..15]of string[20];
          couleurs:array[0..15]of TColor;
        );
      4:(
          signifD1:string[20];
          uniteD1:string[20];
          signifD2:string[20];
          uniteD2:string[20];
          signifD3:string[20];
          uniteD3:string[20];
          valeur3D:array[0..2,0..15]of string[20];
        );
  end;
  procedure degrade3C(Bitmap:TBitmap;couldeb,coulmil,coulfin:Tcolor;sensH:boolean);
  procedure degrade2C(Bitmap:TBitmap;couldeb,coulfin:Tcolor;sensH:boolean);
  //Venant de Ut_echel
  procedure Lit_Gif_comment(chaines:TStrings;var Echelle:TEchelle;var Commentaire:TStringList);
  function transcrit_Echelle(Echelle:TEchelle):string;
  procedure ecrit_Echelle(Echelle:TEchelle;Stream:TStream);
  function Lit_Gif_Echelle(chaines:TStrings):TEchelle;
  function Lit_String_Echelle(chain:String):TEchelle;
  function Lit_Stream_Echelle(Stream:TStream):TEchelle;
  function Charge_Echelle(Fichier:String):TEchelle;
  procedure Sauve_Echelle(Fichier:String;Echelle:TEchelle);
  procedure Lit_Gif_Comm(chaines:TStrings;var com_temp:TStringList);
  procedure Modifie_Commentaires(ancien:TStrings;modif:Tstrings; var nouveau:TStringList);
  //Venant de Ut_echel
  function transcrit_EchelleCoul(EchelleCoul:TEchelleCoul):string;
  procedure ecrit_EchelleCoul(EchelleCoul:TEchelleCoul;Stream:TStream);
  function Lit_lignes_EchelleCoul(chaines:TStrings):TEchelleCoul;
  function Lit_String_EchelleCoul(chain:String):TEchelleCoul;
  function Lit_Stream_EchelleCoul(Stream:TStream):TEchelleCoul;
  function Charge_EchelleCoul(Fichier:String):TEchelleCoul;
  procedure Sauve_EchelleCoul(Fichier:String;EchelleCoul:TEchelleCoul);
  function decode_couleur(EchelleCoul:TEchelleCoul;couleur:TColor;var erreur:boolean):string;
  function decode_valeur(ECoul:TEchelleCoul;valeur:real;var erreur:boolean):TColor;
  function transforme_image(ECoul:TEchelleCoul;var Bitmap:TBitmap):boolean;
  function transforme_image_disc(nombre:integer;limites:Array of byte;couleurs:Array of Tcolor;var Bitmap:TBitmap):boolean;
  function aligne_image(ECoul:TEchelleCoul;CoefEr:real;var Bitmap:TBitmap):boolean;
  function Copy2Symb(const S: string; Symb: Char): string;
{ Copy2Symb returns a substring of a string S from begining to first
  character Symb. }
  function Copy2SymbDel(var S: string; Symb: Char): string;
{ Copy2SymbDel returns a substring of a string S from begining to first
  character Symb and removes this substring from S. }
  function Copy2SymbDelb(var S: string; Symb: Char): string; {ajout JF Madre 08/99}
 {Copy2SymbDelb returns a substring of a string S from begining to first
  character Symb and removes this substring and Symb from S. }
  function DelBSpace(const S: string): string;
{ DelBSpace trims leading spaces from the given string. }
  function AfficheNombre(Mesu:real):string;

implementation
uses math;  //StrUtils,
procedure degrade3C(Bitmap:TBitmap;couldeb,coulmil,coulfin:Tcolor;sensH:boolean);
var
  Scanline:PByteArray;
  x,y,i,j,vp,w,h:integer;
  Couldmf:array [0..2,0..4] of byte;
  coeffcoul:array [0..2,0..3] of real;
  val:array [0..2] of byte;
  nombre:integer;
  xd:array[0..4] of integer;
  yd:array[0..4] of integer;
  BitmapTemp:TBitmap;
begin
  Couldmf[0,0]:=GetBValue(couldeb);
  Couldmf[1,0]:=GetGValue(couldeb);
  Couldmf[2,0]:=GetRValue(couldeb);
  Couldmf[0,2]:=GetBValue(coulmil);
  Couldmf[1,2]:=GetGValue(coulmil);
  Couldmf[2,2]:=GetRValue(coulmil);
  Couldmf[0,4]:=GetBValue(coulfin);
  Couldmf[1,4]:=GetGValue(coulfin);
  Couldmf[2,4]:=GetRValue(coulfin);
  for i:=0 to 2 do
    for j:=0 to 1 do
      if (Couldmf[i,j*2]+Couldmf[i,j*2+2])<255 then
        Couldmf[i,j*2+1]:=Couldmf[i,j*2]+Couldmf[i,j*2]
      else Couldmf[i,j*2+1]:=255;
  if sensH then nombre:=Bitmap.Width else nombre:=Bitmap.Height;
  for i:=0 to 2 do
    for j:=0 to 3 do
      begin
        coeffcoul[i,j]:=(Couldmf[i,j+1]-Couldmf[i,j])/nombre*4;
      end;
  Bitmap.PixelFormat := pf24bit;
  w:=Bitmap.Width;
  h:=Bitmap.Height;
  Bitmaptemp:=TBitmap.create;
  try
    Bitmaptemp.Width:=w;
    Bitmaptemp.Height:=h;
    BitmapTemp.PixelFormat := pf24bit;
    if sensH then
      begin
        for j:=0 to 4 do xd[j]:=round(j*nombre/4);
        for y:=0 to h-1 do
          begin
            Scanline:=BitmapTemp.ScanLine[y];
              for j:=0 to 3 do
                for x:=xd[j] to xd[j+1]-1 do
                  for i:=0 to 2 do
                    begin
                      vp:=round(Couldmf[i,j]+coeffcoul[i,j]*(x-xd[j]));
                      if vp<255 then val[i]:=vp else val[i]:=255;
                      Scanline[x*3+i]:=val[i];
                    end;
          end;
      end
    else
      begin
        for j:=0 to 4 do yd[j]:=round(j*nombre/4);
        for j:=0 to 3 do
          for y:=yd[j] to yd[j+1]-1 do
            begin
              Scanline:=BitmapTemp.ScanLine[nombre-y-1];
              for i:=0 to 2 do
                begin
                  vp:=round(Couldmf[i,j]+coeffcoul[i,j]*(y-yd[j]));
                  if vp<255 then val[i]:=vp else val[i]:=255;
                end;
              for x:=0 to w-1 do
                for i:=0 to 2 do Scanline[x*3+i]:=val[i];
            end;
      end;
    Bitmap.Canvas.Draw(0,0,BitmapTemp);
  finally
    BitmapTemp.free;
  end;
end;
procedure degrade2C(Bitmap:TBitmap;couldeb,coulfin:Tcolor;sensH:boolean);
var
  Scanline:PByteArray;
  x,y,i,vp,h,w:integer;
  Couldmf:array [0..2,0..1] of byte;
  coeffcoul:array [0..2] of real;
  val:array [0..2] of byte;
  nombre:integer;
  BitmapTemp:TBitmap;
begin
  Couldmf[0,0]:=GetBValue(couldeb);
  Couldmf[1,0]:=GetGValue(couldeb);
  Couldmf[2,0]:=GetRValue(couldeb);
  Couldmf[0,1]:=GetBValue(coulfin);
  Couldmf[1,1]:=GetGValue(coulfin);
  Couldmf[2,1]:=GetRValue(coulfin);
  if sensH then nombre:=Bitmap.Width else nombre:=Bitmap.Height;
  for i:=0 to 2 do
    begin
      coeffcoul[i]:=(Couldmf[i,1]-Couldmf[i,0])/nombre;
    end;
  Bitmap.PixelFormat := pf24bit;
  w:=Bitmap.Width;
  h:=Bitmap.Height;
  Bitmaptemp:=TBitmap.create;
  try
    Bitmaptemp.Width:=w;
    Bitmaptemp.Height:=h;
    BitmapTemp.PixelFormat:=pf24bit;
    if sensH then
      begin
        for y:=0 to h-1 do
          begin
            Scanline:=BitmapTemp.ScanLine[y];
              for x:=0 to nombre-1 do
                for i:=0 to 2 do
                  begin
                    vp:=round(Couldmf[i,0]+coeffcoul[i]*x);
                    if vp<255 then val[i]:=vp else val[i]:=255;
                    Scanline[x*3+i]:=val[i];
                  end;
          end;
      end
    else
      begin
        for y:=0 to nombre-1 do
          begin
            Scanline:=BitmapTemp.ScanLine[nombre-y-1];
            for i:=0 to 2 do
              begin
                vp:=round(Couldmf[i,0]+coeffcoul[i]*y);
                if vp<255 then val[i]:=vp else val[i]:=255;
              end;
            for x:=0 to w-1 do
              for i:=0 to 2 do Scanline[x*3+i]:=val[i];
          end;
      end;
    Bitmap.Canvas.Draw(0,0,BitmapTemp);
  finally
    BitmapTemp.free;
  end;
end;
procedure ecrit_Echelle(Echelle:TEchelle;Stream:TStream);
var
  echellestring:string;
  longueurtexte:word;
  buffer:array[0..2] of Char;
begin
  if Echelle.active then echellestring:=transcrit_Echelle(Echelle)
  else echellestring:='';
  longueurtexte:=Length(echellestring);
  buffer[0]:=chr(longueurtexte and 255);
  buffer[1]:=chr(longueurtexte div 256);
  Stream.Write(Buffer,2);
  if longueurtexte>0 then Stream.Write(Pointer(echellestring)^,longueurtexte);
end;
function Lit_Stream_Echelle(Stream:TStream):TEchelle;
var
  echellestring:string;
  longueurtexte:word;
  buffer:array[0..2] of Char;
begin
  Result.active:=false;
  Result.mode:=0;
  Result.coeff:=1;
  Result.unite:='pixels';
  Stream.Read(Buffer,2);
  longueurtexte:=Ord(buffer[0])+256*Ord(buffer[1]);
  if longueurtexte>0 then
    begin
      SetString(echellestring, nil,longueurtexte);
      Stream.Read(Pointer(echellestring)^,longueurtexte);
      Result:=Lit_String_Echelle(echellestring);
    end;
end;

function Lit_Gif_Echelle(chaines:TStrings):TEchelle;
var
  chaine,chaine2,symbdec,notsymbdec:String;
  i:integer;
  Echelle:TEchelle;
begin
  try
    if 1.5=StrToFloat('1,5') then
      begin
        symbdec:=',';
        Notsymbdec:='.';
      end
    else
      begin
        symbdec:='.';
        Notsymbdec:=',';
      end;
  except
    symbdec:='.';
    Notsymbdec:=',';
  end;
  Echelle.active:=false;
  For i:=0 to chaines.Count-1 do
    begin
      chaine:=chaines.Strings[i];
      if Pos('<SCALE', UpperCase(chaine))>0 then
        begin
          chaine2:=Copy2SymbDelb(chaine,'=');
          if (pos('>',chaine)=0) and (i<chaines.Count-1) then
                                       chaine:=chaine+chaines.Strings[i+1];
          chaine:=Copy2Symb(chaine,'>');
          chaine2:=Copy2SymbDelb(chaine,';');
          try
            Echelle.mode:=StrToInt(chaine2);
            chaine2:=Copy2SymbDelb(chaine,';');
            Case Echelle.mode of
              0: begin
                   if pos(Notsymbdec,chaine2)> 0 then
                     if symbdec=',' then chaine2[pos(Notsymbdec,chaine2)]:=','
                     else chaine2[pos(Notsymbdec,chaine2)]:='.';
                   Echelle.coeff:=StrToFloat(chaine2);
                   chaine2:=Copy2SymbDelb(chaine,';');
                   Echelle.unite:=chaine2;
                   Echelle.active:=True;
                 end;
              1: begin
                   Echelle.cadre_actif.Left:=StrToInt(chaine2);
                   chaine2:=Copy2SymbDelb(chaine,';');
                   Echelle.cadre_actif.Top:=StrToInt(chaine2);
                   chaine2:=Copy2SymbDelb(chaine,';');
                   Echelle.cadre_actif.Right:=StrToInt(chaine2);
                   chaine2:=Copy2SymbDelb(chaine,';');
                   Echelle.cadre_actif.Bottom:=StrToInt(chaine2);
                   chaine2:=Copy2SymbDelb(chaine,';');
                   Echelle.zero_X:=StrToInt(chaine2);
                   chaine2:=Copy2SymbDelb(chaine,';');
                   if pos(Notsymbdec,chaine2)> 0 then
                     if symbdec=',' then chaine2[pos(Notsymbdec,chaine2)]:=','
                     else chaine2[pos(Notsymbdec,chaine2)]:='.';
                   Echelle.coeff_X:=StrToFloat(chaine2);
                   chaine2:=Copy2SymbDelb(chaine,';');
                   Echelle.unite_X:=chaine2;
                   chaine2:=Copy2SymbDelb(chaine,';');
                   Echelle.nombre_Y:=StrToInt(chaine2);
                   chaine2:=Copy2SymbDelb(chaine,';');
                   if pos(Notsymbdec,chaine2)> 0 then
                     if symbdec=',' then chaine2[pos(Notsymbdec,chaine2)]:=','
                     else chaine2[pos(Notsymbdec,chaine2)]:='.';
                   Echelle.coeff_Y1:=StrToFloat(chaine2);
                   chaine2:=Copy2SymbDelb(chaine,';');
                   Echelle.unite_Y1:=chaine2;
                   chaine2:=Copy2SymbDelb(chaine,';');
                   Echelle.zero_Y1:=StrToInt(chaine2);
                   if Echelle.nombre_Y>1 then
                     begin
                       chaine2:=Copy2SymbDelb(chaine,';');
                       if pos(Notsymbdec,chaine2)> 0 then
                         if symbdec=',' then chaine2[pos(Notsymbdec,chaine2)]:=','
                         else chaine2[pos(Notsymbdec,chaine2)]:='.';
                       Echelle.coeff_Y2:=StrToFloat(chaine2);
                       chaine2:=Copy2SymbDelb(chaine,';');
                       Echelle.unite_Y2:=chaine2;
                       chaine2:=Copy2SymbDelb(chaine,';');
                       Echelle.zero_Y2:=StrToInt(chaine2);
                     end;
                   if Echelle.nombre_Y>2 then
                     begin
                       chaine2:=Copy2SymbDelb(chaine,';');
                       if pos(Notsymbdec,chaine2)> 0 then
                         if symbdec=',' then chaine2[pos(Notsymbdec,chaine2)]:=','
                         else chaine2[pos(Notsymbdec,chaine2)]:='.';
                       Echelle.coeff_Y3:=StrToFloat(chaine2);
                       chaine2:=Copy2SymbDelb(chaine,';');
                       Echelle.unite_Y3:=chaine2;
                       chaine2:=Copy2SymbDelb(chaine,';');
                       Echelle.zero_Y3:=StrToInt(chaine2);
                     end;
                   Echelle.active:=True;
                 end;
              2: begin
                   Echelle.X_G:=StrToInt(chaine2);
                   chaine2:=Copy2SymbDelb(chaine,';');
                   Echelle.Y_G:=StrToInt(chaine2);
                   chaine2:=Copy2SymbDelb(chaine,';');
                   Echelle.longueur:=StrToInt(chaine2);
                   chaine2:=Copy2SymbDelb(chaine,';');
                   Echelle.sens:=StrToInt(chaine2);
                   chaine2:=Copy2SymbDelb(chaine,';');
                   Echelle.nom_X:=chaine2;
                   chaine2:=Copy2SymbDelb(chaine,';');
                   Echelle.nom_Y:=chaine2;
                   chaine2:=Copy2SymbDelb(chaine,';');
                   Echelle.nom_Z:=chaine2;
                   Echelle.active:=True;
                 end;
              3: begin
                   Echelle.X_C:=StrToInt(chaine2);
                   chaine2:=Copy2SymbDelb(chaine,';');
                   Echelle.Y_C:=StrToInt(chaine2);
                   chaine2:=Copy2SymbDelb(chaine,';');
                   Echelle.unite_angle:=chaine2;
                   chaine2:=Copy2SymbDelb(chaine,';');
                   if pos(Notsymbdec,chaine2)> 0 then
                     if symbdec=',' then chaine2[pos(Notsymbdec,chaine2)]:=','
                     else chaine2[pos(Notsymbdec,chaine2)]:='.';
                   Echelle.angle_Zero:=StrToFloat(chaine2);
                   chaine2:=Copy2SymbDelb(chaine,';');
                   if pos(Notsymbdec,chaine2)> 0 then
                     if symbdec=',' then chaine2[pos(Notsymbdec,chaine2)]:=','
                     else chaine2[pos(Notsymbdec,chaine2)]:='.';
                   Echelle.coeff_r:=StrToFloat(chaine2);
                   chaine2:=Copy2SymbDelb(chaine,';');
                   Echelle.unite_r:=chaine2;
                   Echelle.active:=True;
                 end;
            end;
          except
            Echelle.active:=false;
          end;
          Break;
        end;
    end;
  Result:=Echelle;
end;
procedure Lit_Gif_Comm(chaines:TStrings;var com_temp:TStringList);
var
  chaine:String;
  i,n,j:integer;
begin
  com_temp.Clear;
  For i:=0 to chaines.Count-1 do
    begin
      chaine:=chaines.Strings[i];
      if Pos('<COMMENT>', UpperCase(chaine))>0 then
        begin
          Delete(chaine,1,Pos('<COMMENT>', UpperCase(chaine))+8);
          n:=i;
          while (n<chaines.Count-1) and (Pos('</COMMENT>', UpperCase(chaine))=0) do
            begin
              if (n>i) or (chaine<>'') then j:=com_temp.Add(chaine);
              n:=n+1;
              chaine:=chaines.Strings[n];
            end;
          if (Pos('</COMMENT>', UpperCase(chaine))>0) then
            begin
              chaine:=Copy(chaine,1,Pos('</COMMENT>', UpperCase(chaine))-1);
              if chaine<>'' then
                 j:=com_temp.Add(chaine);
            end;
          Break;
        end;
    end;
end;
procedure Modifie_Commentaires(ancien:TStrings;modif:Tstrings; var nouveau:TStringList);
var
  i,j:integer;
  chaine:string;
begin
  nouveau.Clear;
  i:=0;
  if ancien.Count=0 then chaine:='' else chaine:=ancien.Strings[0];
  While (Pos('<COMMENT>', UpperCase(chaine))=0) and (i<ancien.Count) do
    begin
      nouveau.add(chaine);
      i:=i+1;
      chaine:=ancien.Strings[i];
    end;
  if Pos('<COMMENT>', UpperCase(chaine))>0 then
    begin
      if Pos('<COMMENT>', UpperCase(chaine))>1 then
        nouveau.Add(Copy(Chaine,1,Pos('<COMMENT>', UpperCase(chaine))-1));
      Delete(chaine,1,Pos('<COMMENT>', UpperCase(chaine))+8);
    end;
  if modif.Count>0 then
    begin
      nouveau.Add('<COMMENT>');
      for j:=0 to modif.Count-1 do nouveau.Add(modif.Strings[j]);
      nouveau.Add('<\COMMENT>');
    end;
  if Pos('<\COMMENT>', UpperCase(chaine))>0 then
    begin
      Delete(chaine,1,Pos('<\COMMENT>', UpperCase(chaine))+8);
      if chaine<>'' then
        nouveau.Add(chaine);
    end;
  if i<ancien.Count-1 then
    for j:=i+1 to ancien.Count-1 do nouveau.Add(ancien.Strings[j]);
end;
procedure Lit_Gif_comment(chaines:TStrings;var Echelle:TEchelle;var Commentaire:TStringList);
begin
  Echelle:=Lit_Gif_Echelle(chaines);
  Lit_Gif_Comm(chaines,Commentaire);
end;
function transcrit_Echelle(Echelle:TEchelle):string;
var
  chaine:string;
begin
  chaine:='<SCALE=';
  chaine:=chaine+IntToStr(Echelle.mode)+';';
  Case Echelle.mode of
    0: begin
         chaine:=chaine+FloatToStrF(Echelle.coeff,ffGeneral,4,1)+';';
         chaine:=chaine+Echelle.unite;
       end;
    1: begin
         chaine:=chaine+IntToStr(Echelle.cadre_actif.Left)+';';
         chaine:=chaine+IntToStr(Echelle.cadre_actif.Top)+';';
         chaine:=chaine+IntToStr(Echelle.cadre_actif.Right)+';';
         chaine:=chaine+IntToStr(Echelle.cadre_actif.Bottom)+';';
         chaine:=chaine+IntToStr(Echelle.zero_X)+';';
         chaine:=chaine+FloatToStrF(Echelle.coeff_X,ffGeneral,4,1)+';';
         chaine:=chaine+Echelle.unite_X+';';
         chaine:=chaine+IntToStr(Echelle.nombre_Y)+';';
         chaine:=chaine+FloatToStrF(Echelle.coeff_Y1,ffGeneral,4,1)+';';
         chaine:=chaine+Echelle.unite_Y1+';';
         chaine:=chaine+IntToStr(Echelle.zero_Y1);
         if Echelle.nombre_Y>1 then
           begin
             chaine:=chaine+';'+FloatToStrF(Echelle.coeff_Y2,ffGeneral,4,1)+';';
             chaine:=chaine+Echelle.unite_Y2+';';
             chaine:=chaine+IntToStr(Echelle.zero_Y2);
           end;
         if Echelle.nombre_Y>2 then
           begin
             chaine:=chaine+';'+FloatToStrF(Echelle.coeff_Y3,ffGeneral,4,1)+';';
             chaine:=chaine+Echelle.unite_Y3+';';
             chaine:=chaine+IntToStr(Echelle.zero_Y3);
           end;
       end;
    2: begin
         chaine:=chaine+IntToStr(Echelle.X_G)+';';
         chaine:=chaine+IntToStr(Echelle.Y_G)+';';
         chaine:=chaine+IntToStr(Echelle.longueur)+';';
         chaine:=chaine+IntToStr(Echelle.sens)+';';
         chaine:=chaine+Echelle.nom_X+';';
         chaine:=chaine+Echelle.nom_Y+';';
         chaine:=chaine+Echelle.nom_Z;
       end;
    3: begin
         chaine:=chaine+IntToStr(Echelle.X_C)+';';
         chaine:=chaine+IntToStr(Echelle.Y_C)+';';
         chaine:=chaine+Echelle.unite_angle+';';
         chaine:=chaine+FloatToStrF(Echelle.angle_Zero,ffGeneral,4,1)+';';
         chaine:=chaine+FloatToStrF(Echelle.coeff_r,ffGeneral,4,1)+';';
         chaine:=chaine+Echelle.unite_r;
       end;
  end;
  result:=chaine+';>';
end;
function Lit_string_Echelle(Chain:string):TEchelle;
var
  chaine,chaine2,symbdec,notsymbdec:String;
  i,j,n:integer;
  Echelle:TEchelle;
begin
  try
    if 1.5=StrToFloat('1,5') then
      begin
        symbdec:=',';
        Notsymbdec:='.';
      end
    else
      begin
        symbdec:='.';
        Notsymbdec:=',';
      end;
  except
    symbdec:='.';
    Notsymbdec:=',';
  end;
  Echelle.active:=false;
  Chaine:=Chain;
  if Pos('<SCALE', UpperCase(chaine))>0 then chaine2:=Copy2SymbDelb(chaine,'=');
          chaine:=Copy2Symb(chaine,'>');
          chaine2:=Copy2SymbDelb(chaine,';');
          try
            Echelle.mode:=StrToInt(chaine2);
            chaine2:=Copy2SymbDelb(chaine,';');
            Case Echelle.mode of
              0: begin
                   if pos(Notsymbdec,chaine2)> 0 then
                     if symbdec=',' then chaine2[pos(Notsymbdec,chaine2)]:=','
                     else chaine2[pos(Notsymbdec,chaine2)]:='.';
                   Echelle.coeff:=StrToFloat(chaine2);
                   chaine2:=Copy2SymbDelb(chaine,';');
                   Echelle.unite:=chaine2;
                   Echelle.active:=True;
                 end;
              1: begin
                   Echelle.cadre_actif.Left:=StrToInt(chaine2);
                   chaine2:=Copy2SymbDelb(chaine,';');
                   Echelle.cadre_actif.Top:=StrToInt(chaine2);
                   chaine2:=Copy2SymbDelb(chaine,';');
                   Echelle.cadre_actif.Right:=StrToInt(chaine2);
                   chaine2:=Copy2SymbDelb(chaine,';');
                   Echelle.cadre_actif.Bottom:=StrToInt(chaine2);
                   chaine2:=Copy2SymbDelb(chaine,';');
                   Echelle.zero_X:=StrToInt(chaine2);
                   chaine2:=Copy2SymbDelb(chaine,';');
                   if pos(Notsymbdec,chaine2)> 0 then
                     if symbdec=',' then chaine2[pos(Notsymbdec,chaine2)]:=','
                     else chaine2[pos(Notsymbdec,chaine2)]:='.';
                   Echelle.coeff_X:=StrToFloat(chaine2);
                   chaine2:=Copy2SymbDelb(chaine,';');
                   Echelle.unite_X:=chaine2;
                   chaine2:=Copy2SymbDelb(chaine,';');
                   Echelle.nombre_Y:=StrToInt(chaine2);
                   chaine2:=Copy2SymbDelb(chaine,';');
                   if pos(Notsymbdec,chaine2)> 0 then
                     if symbdec=',' then chaine2[pos(Notsymbdec,chaine2)]:=','
                     else chaine2[pos(Notsymbdec,chaine2)]:='.';
                   Echelle.coeff_Y1:=StrToFloat(chaine2);
                   chaine2:=Copy2SymbDelb(chaine,';');
                   Echelle.unite_Y1:=chaine2;
                   chaine2:=Copy2SymbDelb(chaine,';');
                   Echelle.zero_Y1:=StrToInt(chaine2);
                   if Echelle.nombre_Y>1 then
                     begin
                       chaine2:=Copy2SymbDelb(chaine,';');
                       if pos(Notsymbdec,chaine2)> 0 then
                         if symbdec=',' then chaine2[pos(Notsymbdec,chaine2)]:=','
                         else chaine2[pos(Notsymbdec,chaine2)]:='.';
                       Echelle.coeff_Y2:=StrToFloat(chaine2);
                       chaine2:=Copy2SymbDelb(chaine,';');
                       Echelle.unite_Y2:=chaine2;
                       chaine2:=Copy2SymbDelb(chaine,';');
                       Echelle.zero_Y2:=StrToInt(chaine2);
                     end;
                   if Echelle.nombre_Y>2 then
                     begin
                       chaine2:=Copy2SymbDelb(chaine,';');
                       if pos(Notsymbdec,chaine2)> 0 then
                         if symbdec=',' then chaine2[pos(Notsymbdec,chaine2)]:=','
                         else chaine2[pos(Notsymbdec,chaine2)]:='.';
                       Echelle.coeff_Y3:=StrToFloat(chaine2);
                       chaine2:=Copy2SymbDelb(chaine,';');
                       Echelle.unite_Y3:=chaine2;
                       chaine2:=Copy2SymbDelb(chaine,';');
                       Echelle.zero_Y3:=StrToInt(chaine2);
                     end;
                   Echelle.active:=True;
                 end;
              2: begin
                   Echelle.X_G:=StrToInt(chaine2);
                   chaine2:=Copy2SymbDelb(chaine,';');
                   Echelle.Y_G:=StrToInt(chaine2);
                   chaine2:=Copy2SymbDelb(chaine,';');
                   Echelle.longueur:=StrToInt(chaine2);
                   chaine2:=Copy2SymbDelb(chaine,';');
                   Echelle.sens:=StrToInt(chaine2);
                   chaine2:=Copy2SymbDelb(chaine,';');
                   Echelle.nom_X:=chaine2;
                   chaine2:=Copy2SymbDelb(chaine,';');
                   Echelle.nom_Y:=chaine2;
                   chaine2:=Copy2SymbDelb(chaine,';');
                   Echelle.nom_Z:=chaine2;
                   Echelle.active:=True;
                 end;
              3: begin
                   Echelle.X_C:=StrToInt(chaine2);
                   chaine2:=Copy2SymbDelb(chaine,';');
                   Echelle.Y_C:=StrToInt(chaine2);
                   chaine2:=Copy2SymbDelb(chaine,';');
                   Echelle.unite_angle:=chaine2;
                   chaine2:=Copy2SymbDelb(chaine,';');
                   if pos(Notsymbdec,chaine2)> 0 then
                     if symbdec=',' then chaine2[pos(Notsymbdec,chaine2)]:=','
                     else chaine2[pos(Notsymbdec,chaine2)]:='.';
                   Echelle.angle_Zero:=StrToFloat(chaine2);
                   chaine2:=Copy2SymbDelb(chaine,';');
                   if pos(Notsymbdec,chaine2)> 0 then
                     if symbdec=',' then chaine2[pos(Notsymbdec,chaine2)]:=','
                     else chaine2[pos(Notsymbdec,chaine2)]:='.';
                   Echelle.coeff_r:=StrToFloat(chaine2);
                   chaine2:=Copy2SymbDelb(chaine,';');
                   Echelle.unite_r:=chaine2;
                   Echelle.active:=True;
                 end;
            end;
          except
            Echelle.active:=false;
          end;
  Result:=Echelle;
end;
function Charge_Echelle(Fichier:String):TEchelle;
var
  Chaine,fic:string;
  F:TextFile;
  Echelle:TEchelle;
begin
  fic:=Copy(Fichier,1,Length(Fichier)-4)+'.sca';
  Echelle.mode:=0;
  Echelle.unite:='pixels';
  Echelle.coeff:=1;
  Echelle.active:=True;
  Result:=Echelle;
  if Not FileExists(Fic) then exit;
  try
    AssignFile(F, fic);
    Reset(F);
    Readln(F, Chaine);
    CloseFile(F);
    Echelle:=Lit_string_Echelle(Chaine);
    Echelle.active:=true;
  except
    Echelle.mode:=0;
    Echelle.unite:='pixels';
    Echelle.coeff:=1;
    Echelle.active:=True;
  end;
  Result:=Echelle;
end;
procedure Sauve_Echelle(Fichier:String;Echelle:TEchelle);
var
  Chaine,fic:string;
  F:TextFile;
begin
  Chaine:=transcrit_Echelle(Echelle);
  fic:=Copy(fichier,1,Length(fichier)-4)+'.sca';
  AssignFile(F, fic);
  Rewrite(F);
  Writeln(F, Chaine);
  CloseFile(F);
end;
//Pour Echel_C
procedure ecrit_EchelleCoul(EchelleCoul:TEchelleCoul;Stream:TStream);
var
  echelCstring:string;
  longueurtexte:word;
  buffer:array[0..2] of Char;
begin
  if EchelleCoul.active then echelCstring:=transcrit_EchelleCoul(EchelleCoul)
  else echelCstring:='';
  longueurtexte:=Length(echelCstring);
  buffer[0]:=chr(longueurtexte and 255);
  buffer[1]:=chr(longueurtexte div 256);
  Stream.Write(Buffer,2);
  if longueurtexte>0 then Stream.Write(Pointer(echelCstring)^,longueurtexte);
end;
function Lit_Stream_EchelleCoul(Stream:TStream):TEchelleCoul;
var
  echelCstring:string;
  longueurtexte:word;
  buffer:array[0..2] of Char;
begin
  with Result do
    begin
      active:=false;
      mode:=0;
      valminC1:=0;
      valminC2:=0;
      valminC3:=0;
      valmaxC1:=255;
      valmaxC2:=255;
      valmaxC3:=255;
      signifC1:='bleu';
      signifC2:='vert';
      signifC3:='rouge';
      coulsymbC1:=RGB(0,0,255);
      coulsymbC2:=RGB(0,255,0);
      coulsymbC3:=RGB(255,0,0);
    end;
  Stream.Read(Buffer,2);
  longueurtexte:=Ord(buffer[0])+256*Ord(buffer[1]);
  if longueurtexte>0 then
    begin
      SetString(echelCstring, nil,longueurtexte);
      Stream.Read(Pointer(echelCstring)^,longueurtexte);
      Result:=Lit_String_EchelleCoul(echelCstring);
    end;
end;
function aligne_image(ECoul:TEchelleCoul;CoefEr:real;var Bitmap:TBitmap):boolean;
var
  x,y,w,h,degre,i:integer;
  R,V,B,Rl,Vl,Bl,Rh,Vh,Bh,delta:byte;
  Ci:array[0..2] of byte;
  Co:array[0..2] of byte;
  ScanLine:PByteArray;
  prop:real;
  couleur:Tcolor;
  draOK:boolean;
begin
  try
    w:=Bitmap.width;
    h:=Bitmap.height;
    Bitmap.PixelFormat := pf24bit;
    result:=True;
    case ECoul.mode of
      0:begin
          Result:=False;
          Exit;
        end;
      1:begin
          delta:=round(coefer*255);
          case ECoul.RVB of
            0:begin
                Ci[0]:=0;
                Ci[1]:=1;
                Ci[2]:=2;
              end;
            1:begin
                Ci[0]:=1;
                Ci[1]:=2;
                Ci[2]:=0;
              end;
            2:begin
                Ci[0]:=2;
                Ci[1]:=0;
                Ci[2]:=1;
              end;
            3:begin
                Ci[0]:=0;
                Ci[1]:=2;
                Ci[2]:=1;
              end;
            4:begin
                Ci[0]:=1;
                Ci[1]:=0;
                Ci[2]:=2;
              end;
            5:begin
                Ci[0]:=2;
                Ci[1]:=1;
                Ci[2]:=0;
              end;
          end;
        end;
      2:begin
          Bl:=GetBValue(ECoul.couleurMin);
          Vl:=GetGValue(ECoul.couleurMin);
          Rl:=GetRValue(ECoul.couleurMin);
          Bh:=GetBValue(ECoul.couleurMax);
          Vh:=GetGValue(ECoul.couleurMax);
          Rh:=GetRValue(ECoul.couleurMax);
        end;
    end;

    for y:=0 to h-1 do
      begin
        Scanline:=Bitmap.Scanline[y];
        for x:=0 to w-1 do
          begin
            Case ECoul.mode of
              1:begin
                  for i:=0 to 2 do Co[i]:=Scanline[x*3+Ci[i]];
                  if (Co[0]+Co[1]+Co[2])<100 then
                    begin
                      Scanline[x*3]:=0;
                      Scanline[x*3+1]:=0;
                      Scanline[x*3+2]:=0;
                    end
                  else if (Co[0]+Co[1]+Co[2])>665 then
                    begin
                      Scanline[x*3]:=255;
                      Scanline[x*3+1]:=255;
                      Scanline[x*3+2]:=255;
                    end
                  else
                    begin
                      if (min(min(Co[0],Co[1]),Co[2])<delta) and (max(max(Co[0],Co[1]),Co[2])>(255-delta)) then
                        begin
                          if (max(max(Co[0],Co[1]),Co[2])=Co[0]) then
                            begin
                              if Co[2]<delta then
                                begin
                                  Scanline[x*3+Ci[0]]:=255;
                                  Scanline[x*3+Ci[2]]:=0;
                                end;
                            end
                          else if (max(max(Co[0],Co[1]),Co[2])=Co[1]) then
                            begin
                              if (min(min(Co[0],Co[1]),Co[2])=Co[2]) then
                                begin
                                  Scanline[x*3+Ci[1]]:=255;
                                  Scanline[x*3+Ci[2]]:=0;
                                end
                              else
                                begin
                                  Scanline[x*3+Ci[1]]:=255;
                                  Scanline[x*3+Ci[0]]:=0;
                                end;
                            end
                          else
                            begin
                              Scanline[x*3+Ci[2]]:=255;
                              Scanline[x*3+Ci[0]]:=0;
                            end;
                        end;
                    end;
                end;
              2:begin
                  B:=Scanline[x*3];
                  V:=Scanline[x*3+1];
                  R:=Scanline[x*3+2];
                  prop:=(((B-Bl)/(Bh-Bl))+((V-Vl)/(Vh-Vl))+((R-Rl)/(Rh-Rl)))/3;
                  if (prop>-CoefEr) and (prop<(1+CoefEr))then
                    begin
                      if prop<0 then prop:=0;
                      if prop>1 then prop:=1;
                      Scanline[x*3]:=Bl+round(prop*(Bh-Bl));
                      Scanline[x*3+1]:=Vl+round(prop*(Vh-Vl));
                      Scanline[x*3+2]:=Bl+round(prop*(Rh-Rl));
                    end
                  else
                    begin
                      if (R+V+B)<round(3*255*CoefEr) then
                        begin
                          Scanline[x*3]:=0;
                          Scanline[x*3+1]:=0;
                          Scanline[x*3+2]:=0;
                        end;
                      if (R+V+B)>(675-round(3*255*CoefEr)) then
                        begin
                          Scanline[x*3]:=255;
                          Scanline[x*3+1]:=255;
                          Scanline[x*3+2]:=255;
                        end;
                    end;
                end;
              3:begin
                  B:=Scanline[x*3];
                  V:=Scanline[x*3+1];
                  R:=Scanline[x*3+2];
                  DraOK:=false;
                  for i:=0 to ECoul.nombre-1 do
                    begin
                      couleur:=ECoul.Couleurs[i];
                      Rl:=GetRValue(Couleur)-Round(255*CoefEr);
                      Vl:=GetGValue(Couleur)-Round(255*CoefEr);
                      Bl:=GetBValue(Couleur)-Round(255*CoefEr);
                      Rh:=GetRValue(Couleur)+Round(255*CoefEr);
                      Vh:=GetGValue(Couleur)+Round(255*CoefEr);
                      Bh:=GetBValue(Couleur)+Round(255*CoefEr);
                      if (R>Rl) and (R<Rh) and (V>Vl) and (V<Vh) and(B>Bl) and (B<Bh) then
                        begin
                          DraOK:=True;
                          Scanline[x*3]:=GetBValue(Couleur);
                          Scanline[x*3+1]:=GetGValue(Couleur);
                          Scanline[x*3+2]:=GetRValue(Couleur);
                        end;
                    end;
                  if not DraOK then
                    begin
                      if (R+V+B)<round(3*255*CoefEr) then
                        begin
                          Scanline[x*3]:=0;
                          Scanline[x*3+1]:=0;
                          Scanline[x*3+2]:=0;
                        end;
                      if (R+V+B)>(675-round(3*255*CoefEr)) then
                        begin
                          Scanline[x*3]:=255;
                          Scanline[x*3+1]:=255;
                          Scanline[x*3+2]:=255;
                        end;
                    end;
                end;
            end;
          end;
      end;
  except
    result:=False;
  end;
end;

function transforme_image_disc(nombre:integer;limites:Array of byte;couleurs:Array of Tcolor;var Bitmap:TBitmap):boolean;
var
  x,y,w,h,i:integer;
  ScanLine:PByteArray;
  valeur:integer;
  couleur:Tcolor;
begin
  try
    w:=Bitmap.width;
    h:=Bitmap.height;
    Bitmap.PixelFormat := pf24bit;
    for y:=0 to h-1 do
      begin
        Scanline:=Bitmap.Scanline[y];
        for x:=0 to w-1 do
          begin
            valeur:=Scanline[x*3];
            for i:=0 to nombre-1 do
              if (valeur>=limites[i]) and (valeur<limites[i+1]) then
                begin
                  couleur:=couleurs[i];
                  Scanline[x*3]:=GetBValue(couleur);
                  Scanline[x*3+1]:=GetGValue(couleur);
                  Scanline[x*3+2]:=GetRValue(couleur);
                end;
          end;
      end;
    result:=True;
  except
    result:=False;
  end;
end;
function transforme_image(ECoul:TEchelleCoul;var Bitmap:TBitmap):boolean;
var
  x,y,w,h:integer;
  ScanLine:PByteArray;
  EchelCoul:TEchelleCoul;
  valeur:real;
  erreur:boolean;
  couleur:Tcolor;
begin
  try
    w:=Bitmap.width;
    h:=Bitmap.height;
    Bitmap.PixelFormat := pf24bit;
    EchelCoul:=ECoul;
    result:=True;
    case EchelCoul.mode of
      0:begin
          Result:=False;
          Exit;
        end;
      1:begin
          EchelCoul.valmin3C:=1;
          EchelCoul.valmax3C:=256;
        end;
      2:begin
          EchelCoul.valmin2C:=1;
          EchelCoul.valmax2C:=256;
        end;
      3:begin
          Result:=False;
          Exit;
        end;
    end;

    for y:=0 to h-1 do
      begin
        Scanline:=Bitmap.Scanline[y];
        for x:=0 to w-1 do
          begin
            valeur:=Scanline[x*3]+1;
            couleur:=decode_valeur(EchelCoul,valeur,erreur);
            Scanline[x*3]:=GetBValue(couleur);
            Scanline[x*3+1]:=GetGValue(couleur);
            Scanline[x*3+2]:=GetRValue(couleur);
          end;
      end;
  except
    result:=False;
  end;
end;

function decode_valeur(ECoul:TEchelleCoul;valeur:real;var erreur:boolean):TColor;
var
 prop:real;
 R,V,B,Rl,Vl,Bl,Rh,Vh,Bh:byte;
 degre:integer;
begin
  erreur:=false;
  result:=ClBlack;
  degre:=0;
  case ECoul.mode of
     0:erreur:=True;
     1:begin
         if ECoul.logar3C then prop:=ln(valeur/ECoul.valmin3C)/ln(ECoul.valmax3C/ECoul.valmin3C)
         else prop:=(valeur-ECoul.valmin3C)/(ECoul.valmax3C-ECoul.valmin3C);
         if prop>1 then prop:=1;
         if prop<0 then prop:=0;
         degre:=round(prop*1020);
         case degre of
           0..255:begin
               case ECoul.RVB of
                 0:begin
                     B:=255;
                     V:=degre;
                     R:=0;
                     result:=RGB(R,V,B);
                   end;
                 1:begin
                     V:=255;
                     R:=degre;
                     B:=0;
                     result:=RGB(R,V,B);
                   end;
                 2:begin
                     R:=255;
                     B:=degre;
                     V:=0;
                     result:=RGB(R,V,B);
                   end;
                 3:begin
                     B:=255;
                     R:=degre;
                     V:=0;
                     result:=RGB(R,V,B);
                   end;
                 4:begin
                     V:=255;
                     B:=degre;
                     R:=0;
                     result:=RGB(R,V,B);
                   end;
                 5:begin
                     R:=255;
                     V:=degre;
                     B:=0;
                     result:=RGB(R,V,B);
                   end;
               end;
             end;
           256..510:begin
               case ECoul.RVB of
                 0:begin
                     B:=510-degre;
                     V:=255;
                     R:=0;
                     result:=RGB(R,V,B);
                   end;
                 1:begin
                     V:=510-degre;
                     R:=255;
                     B:=0;
                     result:=RGB(R,V,B);
                   end;
                 2:begin
                     R:=510-degre;
                     B:=255;
                     V:=0;
                     result:=RGB(R,V,B);
                   end;
                 3:begin
                     B:=510-degre;
                     R:=255;
                     V:=0;
                     result:=RGB(R,V,B);
                   end;
                 4:begin
                     V:=510-degre;
                     B:=255;
                     R:=0;
                     result:=RGB(R,V,B);
                   end;
                 5:begin
                     R:=510-degre;
                     V:=255;
                     B:=0;
                     result:=RGB(R,V,B);
                   end;
               end;
             end;
           511..765:begin
               case ECoul.RVB of
                 0:begin
                     B:=0;
                     V:=255;
                     R:=degre-510;
                     result:=RGB(R,V,B);
                   end;
                 1:begin
                     V:=0;
                     R:=255;
                     B:=degre-510;
                     result:=RGB(R,V,B);
                   end;
                 2:begin
                     R:=0;
                     B:=255;
                     V:=degre-510;
                     result:=RGB(R,V,B);
                   end;
                 3:begin
                     B:=0;
                     R:=255;
                     V:=degre-510;
                     result:=RGB(R,V,B);
                   end;
                 4:begin
                     V:=0;
                     B:=255;
                     R:=degre-510;
                     result:=RGB(R,V,B);
                   end;
                 5:begin
                     R:=0;
                     V:=255;
                     B:=degre-510;
                     result:=RGB(R,V,B);
                   end;
               end;
             end;
           766..1020:begin
               case ECoul.RVB of
                 0:begin
                     B:=0;
                     V:=1020-degre;
                     R:=255;
                     result:=RGB(R,V,B);
                   end;
                 1:begin
                     V:=0;
                     R:=1020-degre;
                     B:=255;
                     result:=RGB(R,V,B);
                   end;
                 2:begin
                     R:=0;
                     B:=1020-degre;
                     V:=255;
                     result:=RGB(R,V,B);
                   end;
                 3:begin
                     B:=0;
                     R:=1020-degre;
                     V:=255;
                     result:=RGB(R,V,B);
                   end;
                 4:begin
                     V:=0;
                     B:=1020-degre;
                     R:=255;
                     result:=RGB(R,V,B);
                   end;
                 5:begin
                     R:=0;
                     V:=1020-degre;
                     B:=255;
                     result:=RGB(R,V,B);
                   end;
               end;
             end;
         end;
       end;
     2:begin
         Rl:=GetRValue(ECoul.couleurMin);
         Rh:=GetRValue(ECoul.couleurMax);
         Vl:=GetGValue(ECoul.couleurMin);
         Vh:=GetGValue(ECoul.couleurMax);
         Bl:=GetBValue(ECoul.couleurMin);
         Bh:=GetBValue(ECoul.couleurMax);
         if ECoul.logar2C then
             prop:=ln(valeur/ECoul.valmin2C)/ln(ECoul.valmax2C/ECoul.valmin2C)
         else prop:=(valeur-ECoul.valmin2C)/(ECoul.valmax2C-ECoul.valmin2C);
         R:=Rl+round(prop*(Rh-Rl));
         V:=Vl+round(prop*(Vh-Vl));
         B:=Bl+round(prop*(Bh-Bl));
         result:=RGB(R,V,B);
       end;
     3:erreur:=True;
  end;
end;

function decode_couleur(EchelleCoul:TEchelleCoul;couleur:TColor;var erreur:boolean):string;
var
 prop,res:real;
 R,V,B,Rl,Vl,Bl,Rh,Vh,Bh:byte;
 degre,i:integer;
 drap:boolean;
begin
  erreur:=false;
  result:='';
  res:=0;
  drap:=true;
  R:=GetRValue(couleur);
  V:=GetGValue(couleur);
  B:=GetBValue(couleur);
  degre:=0;
  case EchelleCoul.mode of
     0:erreur:=True;
     1:begin
         if (R=0) or (V=0) or (B=0) then
           begin
             case EchelleCoul.RVB of
               0:begin
                   if R=0 then
                     begin
                       if B=255 then
                         begin
                           degre:=V
                         end
                       else
                         begin
                           degre:=510-B;
                         end;
                     end
                   else if V=0 then
                     begin
                       if B=255 then degre:=0 else degre:=1020;
                     end
                   else if B=0 then
                     begin
                       if V=255 then degre:=510+R else degre:= 1020-V;
                     end;
                 end;
               1:begin
                   if B=0 then
                     begin
                       if V=255 then
                         begin
                           degre:=R
                         end
                       else
                         begin
                           degre:=510-V;
                         end;
                     end
                   else if R=0 then
                     begin
                       if V=255 then degre:=0 else degre:=1020;
                     end
                   else if V=0 then
                     begin
                       if R=255 then degre:=510+B else degre:= 1020-R;
                     end;
                 end;
               2:begin
                   if V=0 then
                     begin
                       if R=255 then
                         begin
                           degre:=B
                         end
                       else
                         begin
                           degre:=510-R;
                         end;
                     end
                   else if B=0 then
                     begin
                       if R=255 then degre:=0 else degre:=1020;
                     end
                   else if R=0 then
                     begin
                       if B=255 then degre:=510+V else degre:= 1020-B;
                     end;
                 end;
               3:begin
                   if V=0 then
                     begin
                       if B=255 then
                         begin
                           degre:=R
                         end
                       else
                         begin
                           degre:=510-B;
                         end;
                     end
                   else if R=0 then
                     begin
                       if B=255 then degre:=0 else degre:=1020;
                     end
                   else if B=0 then
                     begin
                       if R=255 then degre:=510+V else degre:= 1020-R;
                     end;
                 end;
               4:begin
                   if R=0 then
                     begin
                       if V=255 then
                         begin
                           degre:=B
                         end
                       else
                         begin
                           degre:=510-V;
                         end;
                     end
                   else if B=0 then
                     begin
                       if V=255 then degre:=0 else degre:=1020;
                     end
                   else if V=0 then
                     begin
                       if B=255 then degre:=510+R else degre:= 1020-B;
                     end;
                 end;
               5:begin
                   if B=0 then
                     begin
                       if R=255 then
                         begin
                           degre:=V
                         end
                       else
                         begin
                           degre:=510-R;
                         end;
                     end
                   else if V=0 then
                     begin
                       if R=255 then degre:=0 else degre:=1020;
                     end
                   else if R=0 then
                     begin
                       if V=255 then degre:=510+B else degre:= 1020-V;
                     end;
                 end;
             end;
             prop:=degre/1020;
             if EchelleCoul.logar3C then
               res:=EchelleCoul.valmin3C*exp(prop*ln(EchelleCoul.valmax3C/EchelleCoul.valmin3C))
             else
               res:=EchelleCoul.valmin3C+prop*(EchelleCoul.valmax3C-EchelleCoul.valmin3C);
             result:=FloatToStrF(res,ffGeneral,4,1);
           end
         else erreur:=True;
       end;
     2:begin
         Rl:=GetRValue(EchelleCoul.couleurMin);
         Rh:=GetRValue(EchelleCoul.couleurMax);
         Vl:=GetGValue(EchelleCoul.couleurMin);
         Vh:=GetGValue(EchelleCoul.couleurMax);
         Bl:=GetBValue(EchelleCoul.couleurMin);
         Bh:=GetBValue(EchelleCoul.couleurMax);
         if (R>max(Rl,Rh)) or (R<min(Rl,Rh)) or (V>max(Vl,Vh)) or (V<min(Vl,Vh))
             or (B>max(Bl,Bh)) or (B<min(Bl,Bh)) then
           begin
             erreur:=True;
           end
         else
           begin
             if abs(Rh-Rl)> abs(Vh-Vl) then
               begin
                 if abs(Rh-Rl)> abs(Bh-Bl) then prop:=(R-Rl)/(Rh-Rl)
                 else prop:=(B-Bl)/(Bh-Bl);
               end
             else
               begin
                 if abs(Vh-Vl)> abs(Bh-Bl) then prop:=(V-Vl)/(Vh-Vl)
                 else prop:=(B-Bl)/(Bh-Bl);
               end;
             if EchelleCoul.logar2C then
               res:=EchelleCoul.valmin2C*exp(prop*ln(EchelleCoul.valmax2C-EchelleCoul.valmin2C))
             else
               res:=EchelleCoul.valmin2C+prop*(EchelleCoul.valmax2C-EchelleCoul.valmin2C);
             result:=FloatToStrF(res,ffGeneral,4,1);
           end;
       end;
     3:begin
         for i:=0 to EchelleCoul.nombre-1  do
           if couleur=EchelleCoul.couleurs[i] then
             begin
               result:=EchelleCoul.valeurs[i];
               drap:=False;
             end;
         erreur:=drap;
       end;
  end;
end;

function Lit_lignes_EchelleCoul(chaines:TStrings):TEchelleCoul;
var
  chain:String;
  i:integer;
begin
  chain:='';
  For i:=0 to chaines.Count-1 do
      chain:=chain+chaines.Strings[i];
  Result:=Lit_String_EchelleCoul(chain);
end;
function transcrit_EchelleCoul(EchelleCoul:TEchelleCoul):string;
var
  chaine:string;
  i:integer;
begin
  chaine:='<CODE_C=';
  chaine:=chaine+IntToStr(EchelleCoul.mode)+';';
  Case EchelleCoul.mode of
    0: begin
         chaine:=chaine+FloatToStrF(EchelleCoul.valminC1,ffGeneral,4,1)+';';
         chaine:=chaine+FloatToStrF(EchelleCoul.valminC2,ffGeneral,4,1)+';';
         chaine:=chaine+FloatToStrF(EchelleCoul.valminC3,ffGeneral,4,1)+';';
         chaine:=chaine+FloatToStrF(EchelleCoul.valmaxC1,ffGeneral,4,1)+';';
         chaine:=chaine+FloatToStrF(EchelleCoul.valmaxC2,ffGeneral,4,1)+';';
         chaine:=chaine+FloatToStrF(EchelleCoul.valmaxC3,ffGeneral,4,1)+';';
         chaine:=chaine+EchelleCoul.signifC1+';';
         chaine:=chaine+EchelleCoul.signifC2+';';
         chaine:=chaine+EchelleCoul.signifC3+';';
         chaine:=chaine+IntToStr(EchelleCoul.coulsymbC1)+';';
         chaine:=chaine+IntToStr(EchelleCoul.coulsymbC2)+';';
         chaine:=chaine+IntToStr(EchelleCoul.coulsymbC3)+';';
       end;
    1: begin
         chaine:=chaine+IntToStr(EchelleCoul.RVB)+';';
         chaine:=chaine+IntToStr(EchelleCoul.couleurDeb)+';';
         chaine:=chaine+IntToStr(EchelleCoul.couleurMil)+';';
         chaine:=chaine+IntToStr(EchelleCoul.couleurFin)+';';
         chaine:=chaine+FloatToStrF(EchelleCoul.valmin3C,ffGeneral,4,1)+';';
         chaine:=chaine+FloatToStrF(EchelleCoul.valmax3C,ffGeneral,4,1)+';';
         if EchelleCoul.logar3C then chaine:=chaine+'V;' else chaine:=chaine+'F;';
         chaine:=chaine+EchelleCoul.signif3C+';';
         chaine:=chaine+EchelleCoul.unite3C+';';
       end;
    2: begin
         chaine:=chaine+IntToStr(EchelleCoul.couleurMin)+';';
         chaine:=chaine+IntToStr(EchelleCoul.couleurMax)+';';
         chaine:=chaine+FloatToStrF(EchelleCoul.valmin2C,ffGeneral,4,1)+';';
         chaine:=chaine+FloatToStrF(EchelleCoul.valmax2C,ffGeneral,4,1)+';';
         if EchelleCoul.logar2C then chaine:=chaine+'V;' else chaine:=chaine+'F;';
         chaine:=chaine+EchelleCoul.signif2C+';';
         chaine:=chaine+EchelleCoul.unite2C+';';
       end;
    3: begin
         chaine:=chaine+IntToStr(EchelleCoul.nombre)+';';
         chaine:=chaine+EchelleCoul.signifD+';';
         chaine:=chaine+EchelleCoul.uniteD+';';
         for i:=0 to EchelleCoul.nombre-1 do
           begin
             chaine:=chaine+EchelleCoul.valeurs[i]+';';
             chaine:=chaine+IntToStr(EchelleCoul.couleurs[i])+';';
           end;
       end;
  end;
  result:=chaine+'>';
end;
function Lit_string_EchelleCoul(Chain:string):TEchelleCoul;
var
  chaine,chaine2,symbdec,notsymbdec:String;
  i:integer;
  EchelleCoul:TEchelleCoul;
begin
  try
    if 1.5=StrToFloat('1,5') then
      begin
        symbdec:=',';
        Notsymbdec:='.';
      end
    else
      begin
        symbdec:='.';
        Notsymbdec:=',';
      end;
  except
    symbdec:='.';
    Notsymbdec:=',';
  end;
  EchelleCoul.active:=false;
  Chaine:=Chain;
  if Pos('<CODE_C', UpperCase(chaine))>0 then chaine2:=Copy2SymbDelb(chaine,'=');
          chaine:=Copy2Symb(chaine,'>');
          chaine2:=Copy2SymbDelb(chaine,';');
          try
            EchelleCoul.mode:=StrToInt(chaine2);
            chaine2:=Copy2SymbDelb(chaine,';');
            Case EchelleCoul.mode of
              0: begin
                   if pos(Notsymbdec,chaine2)> 0 then
                     if symbdec=',' then chaine2[pos(Notsymbdec,chaine2)]:=','
                     else chaine2[pos(Notsymbdec,chaine2)]:='.';
                   EchelleCoul.valminC1:=StrToFloat(chaine2);
                   chaine2:=Copy2SymbDelb(chaine,';');
                   if pos(Notsymbdec,chaine2)> 0 then
                     if symbdec=',' then chaine2[pos(Notsymbdec,chaine2)]:=','
                     else chaine2[pos(Notsymbdec,chaine2)]:='.';
                   EchelleCoul.valminC2:=StrToFloat(chaine2);
                   chaine2:=Copy2SymbDelb(chaine,';');
                   if pos(Notsymbdec,chaine2)> 0 then
                     if symbdec=',' then chaine2[pos(Notsymbdec,chaine2)]:=','
                     else chaine2[pos(Notsymbdec,chaine2)]:='.';
                   EchelleCoul.valminC3:=StrToFloat(chaine2);

                   chaine2:=Copy2SymbDelb(chaine,';');
                   if pos(Notsymbdec,chaine2)> 0 then
                     if symbdec=',' then chaine2[pos(Notsymbdec,chaine2)]:=','
                     else chaine2[pos(Notsymbdec,chaine2)]:='.';
                   EchelleCoul.valmaxC1:=StrToFloat(chaine2);
                   chaine2:=Copy2SymbDelb(chaine,';');
                   if pos(Notsymbdec,chaine2)> 0 then
                     if symbdec=',' then chaine2[pos(Notsymbdec,chaine2)]:=','
                     else chaine2[pos(Notsymbdec,chaine2)]:='.';
                   EchelleCoul.valmaxC2:=StrToFloat(chaine2);
                   chaine2:=Copy2SymbDelb(chaine,';');
                   if pos(Notsymbdec,chaine2)> 0 then
                     if symbdec=',' then chaine2[pos(Notsymbdec,chaine2)]:=','
                     else chaine2[pos(Notsymbdec,chaine2)]:='.';
                   EchelleCoul.valmaxC3:=StrToFloat(chaine2);

                   chaine2:=Copy2SymbDelb(chaine,';');
                   EchelleCoul.signifC1:=chaine2;
                   chaine2:=Copy2SymbDelb(chaine,';');
                   EchelleCoul.signifC2:=chaine2;
                   chaine2:=Copy2SymbDelb(chaine,';');
                   EchelleCoul.signifC3:=chaine2;

                   chaine2:=Copy2SymbDelb(chaine,';');
                   EchelleCoul.coulsymbC1:=StrToInt(chaine2);
                   chaine2:=Copy2SymbDelb(chaine,';');
                   EchelleCoul.coulsymbC2:=StrToInt(chaine2);
                   chaine2:=Copy2SymbDelb(chaine,';');
                   EchelleCoul.coulsymbC3:=StrToInt(chaine2);

                   EchelleCoul.active:=True;
                 end;
              1: begin
                   EchelleCoul.RVB:=StrToInt(chaine2);

                   chaine2:=Copy2SymbDelb(chaine,';');
                   EchelleCoul.couleurDeb:=StrToInt(chaine2);
                   chaine2:=Copy2SymbDelb(chaine,';');
                   EchelleCoul.couleurMil:=StrToInt(chaine2);
                   chaine2:=Copy2SymbDelb(chaine,';');
                   EchelleCoul.couleurFin:=StrToInt(chaine2);

                   chaine2:=Copy2SymbDelb(chaine,';');
                   if pos(Notsymbdec,chaine2)> 0 then
                     if symbdec=',' then chaine2[pos(Notsymbdec,chaine2)]:=','
                     else chaine2[pos(Notsymbdec,chaine2)]:='.';
                   EchelleCoul.valmin3C:=StrToFloat(chaine2);
                   chaine2:=Copy2SymbDelb(chaine,';');
                   if pos(Notsymbdec,chaine2)> 0 then
                     if symbdec=',' then chaine2[pos(Notsymbdec,chaine2)]:=','
                     else chaine2[pos(Notsymbdec,chaine2)]:='.';
                   EchelleCoul.valmax3C:=StrToFloat(chaine2);

                   chaine2:=Copy2SymbDelb(chaine,';');
                   if chaine2='V' then EchelleCoul.logar3C:=True else EchelleCoul.logar3C:=False;

                   chaine2:=Copy2SymbDelb(chaine,';');
                   EchelleCoul.signif3C:=chaine2;
                   chaine2:=Copy2SymbDelb(chaine,';');
                   EchelleCoul.unite3C:=chaine2;
                   EchelleCoul.active:=True;
                 end;
              2: begin
                   EchelleCoul.couleurMin:=StrToInt(chaine2);
                   chaine2:=Copy2SymbDelb(chaine,';');
                   EchelleCoul.couleurMax:=StrToInt(chaine2);

                   chaine2:=Copy2SymbDelb(chaine,';');
                   if pos(Notsymbdec,chaine2)> 0 then
                     if symbdec=',' then chaine2[pos(Notsymbdec,chaine2)]:=','
                     else chaine2[pos(Notsymbdec,chaine2)]:='.';
                   EchelleCoul.valmin2C:=StrToFloat(chaine2);
                   chaine2:=Copy2SymbDelb(chaine,';');
                   if pos(Notsymbdec,chaine2)> 0 then
                     if symbdec=',' then chaine2[pos(Notsymbdec,chaine2)]:=','
                     else chaine2[pos(Notsymbdec,chaine2)]:='.';
                   EchelleCoul.valmax2C:=StrToFloat(chaine2);

                   chaine2:=Copy2SymbDelb(chaine,';');
                   if chaine2='V' then EchelleCoul.logar2C:=True else EchelleCoul.logar2C:=False;

                   chaine2:=Copy2SymbDelb(chaine,';');
                   EchelleCoul.signif2C:=chaine2;
                   chaine2:=Copy2SymbDelb(chaine,';');
                   EchelleCoul.unite2C:=chaine2;
                   EchelleCoul.active:=True;
                 end;
              3: begin
                   EchelleCoul.nombre:=StrToInt(chaine2);
                   chaine2:=Copy2SymbDelb(chaine,';');
                   EchelleCoul.signifD:=chaine2;
                   chaine2:=Copy2SymbDelb(chaine,';');
                   EchelleCoul.uniteD:=chaine2;
                   for i:=0 to EchelleCoul.nombre-1 do
                     begin
                       chaine2:=Copy2SymbDelb(chaine,';');
                       EchelleCoul.valeurs[i]:=chaine2;
                       chaine2:=Copy2SymbDelb(chaine,';');
                       EchelleCoul.couleurs[i]:=StrToInt(chaine2);
                     end;

                   EchelleCoul.active:=True;
                 end;
            end;
          except
            EchelleCoul.active:=false;
          end;
  Result:=EchelleCoul;
end;
function Charge_EchelleCoul(Fichier:String):TEchelleCoul;
var
  Chaine,fic:string;
  F:TextFile;
  EchelleCoul:TEchelleCoul;
begin
  fic:=Copy(Fichier,1,Length(Fichier)-4)+'.ccc';
  EchelleCoul.mode:=0;
  EchelleCoul.valmaxC1:=255;
  EchelleCoul.valmaxC2:=255;
  EchelleCoul.valmaxC3:=255;
  EchelleCoul.valminC1:=0;
  EchelleCoul.valminC2:=0;
  EchelleCoul.valminC3:=0;
  EchelleCoul.signifC1:='Bleu';
  EchelleCoul.signifC2:='Vert';
  EchelleCoul.signifC3:='Rouge';
  EchelleCoul.coulsymbC1:=ClBlue;
  EchelleCoul.coulsymbC2:=ClLime;
  EchelleCoul.coulsymbC3:=ClRed;
  EchelleCoul.active:=True;
  Result:=EchelleCoul;
  if Not FileExists(Fic) then exit;
  try
    AssignFile(F, fic);
    Reset(F);
    Readln(F, Chaine);
    CloseFile(F);
    EchelleCoul:=Lit_string_EchelleCoul(Chaine);
    EchelleCoul.active:=true;
  except
    EchelleCoul.mode:=0;
    EchelleCoul.valmaxC1:=255;
    EchelleCoul.valmaxC2:=255;
    EchelleCoul.valmaxC3:=255;
    EchelleCoul.valminC1:=0;
    EchelleCoul.valminC2:=0;
    EchelleCoul.valminC3:=0;
    EchelleCoul.signifC1:='Bleu';
    EchelleCoul.signifC2:='Vert';
    EchelleCoul.signifC3:='Rouge';
    EchelleCoul.coulsymbC1:=ClBlue;
    EchelleCoul.coulsymbC2:=ClLime;
    EchelleCoul.coulsymbC3:=ClRed;
    EchelleCoul.active:=True;
  end;
  Result:=EchelleCoul;
end;
procedure Sauve_EchelleCoul(Fichier:String;EchelleCoul:TEchelleCoul);
var
  Chaine,fic:string;
  F:TextFile;
begin
  Chaine:=transcrit_EchelleCoul(EchelleCoul);
  fic:=Copy(fichier,1,Length(fichier)-4)+'.ccc';
  AssignFile(F, fic);
  Rewrite(F);
  Writeln(F, Chaine);
  CloseFile(F);
end;
function Copy2SymbDel(var S: string; Symb: Char): string;
begin
  Result := Copy2Symb(S, Symb);
  S := DelBSpace(Copy(S, Length(Result) + 1, Length(S)));
end;
function Copy2SymbDelb(var S: string; Symb: Char): string;
begin
  Result := Copy2Symb(S, Symb);
  S := DelBSpace(Copy(S, Length(Result) + 2, Length(S)));
end;
function Copy2Symb(const S: string; Symb: Char): string;
var
  P: Integer;
begin
  P := Pos(Symb, S);
  if P = 0 then P := Length(S) + 1;
  Result := Copy(S, 1, P - 1);
end;
function DelBSpace(const S: string): string;
var
  I, L: Integer;
begin
  L := Length(S);
  I := 1;
  while (I <= L) and (S[I] = ' ') do Inc(I);
  Result := Copy(S, I, MaxInt);
end;
function AfficheNombre(Mesu:real):string;
begin
  if mesu<1000 then Result:=FloatToStrF(mesu,ffGeneral,3,2)
  else if mesu<10000 then Result:=FloatToStrF(mesu,ffGeneral,4,2)
  else if mesu<100000 then Result:=FloatToStrF(mesu,ffGeneral,5,2)
  else Result:=FloatToStrF(mesu,ffGeneral,6,2);
end;end.
