unit Ut_echel_C;

interface
uses WinTypes,Classes,SysUtils,Str_ech_C,Graphics;

function transcrit_EchelleCoul(EchelleCoul:TEchelleCoul):string;
procedure ecrit_EchelleCoul(EchelleCoul:TEchelleCoul;Stream:TStream);

function Lit_lignes_EchelleCoul(chaines:TStrings):TEchelleCoul;

function Lit_String_EchelleCoul(chain:String):TEchelleCoul;

function Lit_Stream_EchelleCoul(Stream:TStream):TEchelleCoul;

function Charge_EchelleCoul(Fichier:String):TEchelleCoul;

procedure Sauve_EchelleCoul(Fichier:String;EchelleCoul:TEchelleCoul);

function decode_couleur(EchelleCoul:TEchelleCoul;couleur:TColor;var erreur:boolean):string;
function decode_valeur(ECoul:TEchelleCoul;valeur:real;var erreur:boolean):TColor;
function transforme_image(ECoul:TEchelleCoul;var Bitmap:TBitmap):boolean;
function transforme_image_disc(nombre:integer;limites:Array of byte;couleurs:Array of Tcolor;var Bitmap:TBitmap):boolean;
function aligne_image(ECoul:TEchelleCoul;CoefEr:real;var Bitmap:TBitmap):boolean;

implementation
uses StrUtils,math;

procedure ecrit_EchelleCoul(EchelleCoul:TEchelleCoul;Stream:TStream);
var
  echelCstring:string;
  longueurtexte:word;
  buffer:array[0..2] of Char;
begin
  if EchelleCoul.active then echelCstring:=transcrit_EchelleCoul(EchelleCoul)
  else echelCstring:='';
  longueurtexte:=Length(echelCstring);
  buffer[0]:=chr(longueurtexte and 255);
  buffer[1]:=chr(longueurtexte div 256);
  Stream.Write(Buffer,2);
  if longueurtexte>0 then Stream.Write(Pointer(echelCstring)^,longueurtexte);
end;
function Lit_Stream_EchelleCoul(Stream:TStream):TEchelleCoul;
var
  echelCstring:string;
  longueurtexte:word;
  buffer:array[0..2] of Char;
begin
  with Result do
    begin
      active:=false;
      mode:=0;
      valminC1:=0;
      valminC2:=0;
      valminC3:=0;
      valmaxC1:=255;
      valmaxC2:=255;
      valmaxC3:=255;
      signifC1:='bleu';
      signifC2:='vert';
      signifC3:='rouge';
      coulsymbC1:=RGB(0,0,255);
      coulsymbC2:=RGB(0,255,0);
      coulsymbC3:=RGB(255,0,0);
    end;
  Stream.Read(Buffer,2);
  longueurtexte:=Ord(buffer[0])+256*Ord(buffer[1]);
  if longueurtexte>0 then
    begin
      SetString(echelCstring, nil,longueurtexte);
      Stream.Read(Pointer(echelCstring)^,longueurtexte);
      Result:=Lit_String_EchelleCoul(echelCstring);
    end;
end;
function aligne_image(ECoul:TEchelleCoul;CoefEr:real;var Bitmap:TBitmap):boolean;
var
  x,y,w,h,degre,i:integer;
  R,V,B,Rl,Vl,Bl,Rh,Vh,Bh,delta:byte;
  Ci:array[0..2] of byte;
  Co:array[0..2] of byte;
  ScanLine:PByteArray;
  prop:real;
  couleur:Tcolor;
  draOK:boolean;
begin
  try
    w:=Bitmap.width;
    h:=Bitmap.height;
    Bitmap.PixelFormat := pf24bit;
    result:=True;
    case ECoul.mode of
      0:begin
          Result:=False;
          Exit;
        end;
      1:begin
          delta:=round(coefer*255);
          case ECoul.RVB of
            0:begin
                Ci[0]:=0;
                Ci[1]:=1;
                Ci[2]:=2;
              end;
            1:begin
                Ci[0]:=1;
                Ci[1]:=2;
                Ci[2]:=0;
              end;
            2:begin
                Ci[0]:=2;
                Ci[1]:=0;
                Ci[2]:=1;
              end;
            3:begin
                Ci[0]:=0;
                Ci[1]:=2;
                Ci[2]:=1;
              end;
            4:begin
                Ci[0]:=1;
                Ci[1]:=0;
                Ci[2]:=2;
              end;
            5:begin
                Ci[0]:=2;
                Ci[1]:=1;
                Ci[2]:=0;
              end;
          end;
        end;
      2:begin
          Bl:=GetBValue(ECoul.couleurMin);
          Vl:=GetGValue(ECoul.couleurMin);
          Rl:=GetRValue(ECoul.couleurMin);
          Bh:=GetBValue(ECoul.couleurMax);
          Vh:=GetGValue(ECoul.couleurMax);
          Rh:=GetRValue(ECoul.couleurMax);
        end;
    end;

    for y:=0 to h-1 do
      begin
        Scanline:=Bitmap.Scanline[y];
        for x:=0 to w-1 do
          begin
            Case ECoul.mode of
              1:begin
                  for i:=0 to 2 do Co[i]:=Scanline[x*3+Ci[i]];
                  if (Co[0]+Co[1]+Co[2])<100 then
                    begin
                      Scanline[x*3]:=0;
                      Scanline[x*3+1]:=0;
                      Scanline[x*3+2]:=0;
                    end
                  else if (Co[0]+Co[1]+Co[2])>665 then
                    begin
                      Scanline[x*3]:=255;
                      Scanline[x*3+1]:=255;
                      Scanline[x*3+2]:=255;
                    end
                  else
                    begin
                      if (min(min(Co[0],Co[1]),Co[2])<delta) and (max(max(Co[0],Co[1]),Co[2])>(255-delta)) then
                        begin
                          if (max(max(Co[0],Co[1]),Co[2])=Co[0]) then
                            begin
                              if Co[2]<delta then
                                begin
                                  Scanline[x*3+Ci[0]]:=255;
                                  Scanline[x*3+Ci[2]]:=0;
                                end;
                            end
                          else if (max(max(Co[0],Co[1]),Co[2])=Co[1]) then
                            begin
                              if (min(min(Co[0],Co[1]),Co[2])=Co[2]) then
                                begin
                                  Scanline[x*3+Ci[1]]:=255;
                                  Scanline[x*3+Ci[2]]:=0;
                                end
                              else
                                begin
                                  Scanline[x*3+Ci[1]]:=255;
                                  Scanline[x*3+Ci[0]]:=0;
                                end;
                            end
                          else
                            begin
                              Scanline[x*3+Ci[2]]:=255;
                              Scanline[x*3+Ci[0]]:=0;
                            end;
                        end;
                    end;
                end;
              2:begin
                  B:=Scanline[x*3];
                  V:=Scanline[x*3+1];
                  R:=Scanline[x*3+2];
                  prop:=(((B-Bl)/(Bh-Bl))+((V-Vl)/(Vh-Vl))+((R-Rl)/(Rh-Rl)))/3;
                  if (prop>-CoefEr) and (prop<(1+CoefEr))then
                    begin
                      if prop<0 then prop:=0;
                      if prop>1 then prop:=1;
                      Scanline[x*3]:=Bl+round(prop*(Bh-Bl));
                      Scanline[x*3+1]:=Vl+round(prop*(Vh-Vl));
                      Scanline[x*3+2]:=Bl+round(prop*(Rh-Rl));
                    end
                  else
                    begin
                      if (R+V+B)<round(3*255*CoefEr) then
                        begin
                          Scanline[x*3]:=0;
                          Scanline[x*3+1]:=0;
                          Scanline[x*3+2]:=0;
                        end;
                      if (R+V+B)>(675-round(3*255*CoefEr)) then
                        begin
                          Scanline[x*3]:=255;
                          Scanline[x*3+1]:=255;
                          Scanline[x*3+2]:=255;
                        end;
                    end;
                end;
              3:begin
                  B:=Scanline[x*3];
                  V:=Scanline[x*3+1];
                  R:=Scanline[x*3+2];
                  DraOK:=false;
                  for i:=0 to ECoul.nombre-1 do
                    begin
                      couleur:=ECoul.Couleurs[i];
                      Rl:=GetRValue(Couleur)-Round(255*CoefEr);
                      Vl:=GetGValue(Couleur)-Round(255*CoefEr);
                      Bl:=GetBValue(Couleur)-Round(255*CoefEr);
                      Rh:=GetRValue(Couleur)+Round(255*CoefEr);
                      Vh:=GetGValue(Couleur)+Round(255*CoefEr);
                      Bh:=GetBValue(Couleur)+Round(255*CoefEr);
                      if (R>Rl) and (R<Rh) and (V>Vl) and (V<Vh) and(B>Bl) and (B<Bh) then
                        begin
                          DraOK:=True;
                          Scanline[x*3]:=GetBValue(Couleur);
                          Scanline[x*3+1]:=GetGValue(Couleur);
                          Scanline[x*3+2]:=GetRValue(Couleur);
                        end;
                    end;
                  if not DraOK then
                    begin
                      if (R+V+B)<round(3*255*CoefEr) then
                        begin
                          Scanline[x*3]:=0;
                          Scanline[x*3+1]:=0;
                          Scanline[x*3+2]:=0;
                        end;
                      if (R+V+B)>(675-round(3*255*CoefEr)) then
                        begin
                          Scanline[x*3]:=255;
                          Scanline[x*3+1]:=255;
                          Scanline[x*3+2]:=255;
                        end;
                    end;
                end;
            end;
          end;
      end;
  except
    result:=False;
  end;
end;

function transforme_image_disc(nombre:integer;limites:Array of byte;couleurs:Array of Tcolor;var Bitmap:TBitmap):boolean;
var
  x,y,w,h,i:integer;
  ScanLine:PByteArray;
  valeur:integer;
  couleur:Tcolor;
begin
  try
    w:=Bitmap.width;
    h:=Bitmap.height;
    Bitmap.PixelFormat := pf24bit;
    for y:=0 to h-1 do
      begin
        Scanline:=Bitmap.Scanline[y];
        for x:=0 to w-1 do
          begin
            valeur:=Scanline[x*3];
            for i:=0 to nombre-1 do
              if (valeur>=limites[i]) and (valeur<limites[i+1]) then
                begin
                  couleur:=couleurs[i];
                  Scanline[x*3]:=GetBValue(couleur);
                  Scanline[x*3+1]:=GetGValue(couleur);
                  Scanline[x*3+2]:=GetRValue(couleur);
                end;
          end;
      end;
    result:=True;
  except
    result:=False;
  end;
end;
function transforme_image(ECoul:TEchelleCoul;var Bitmap:TBitmap):boolean;
var
  x,y,w,h:integer;
  ScanLine:PByteArray;
  EchelCoul:TEchelleCoul;
  valeur:real;
  erreur:boolean;
  couleur:Tcolor;
begin
  try
    w:=Bitmap.width;
    h:=Bitmap.height;
    Bitmap.PixelFormat := pf24bit;
    EchelCoul:=ECoul;
    result:=True;
    case EchelCoul.mode of
      0:begin
          Result:=False;
          Exit;
        end;
      1:begin
          EchelCoul.valmin3C:=1;
          EchelCoul.valmax3C:=256;
        end;
      2:begin
          EchelCoul.valmin2C:=1;
          EchelCoul.valmax2C:=256;
        end;
      3:begin
          Result:=False;
          Exit;
        end;
    end;

    for y:=0 to h-1 do
      begin
        Scanline:=Bitmap.Scanline[y];
        for x:=0 to w-1 do
          begin
            valeur:=Scanline[x*3]+1;
            couleur:=decode_valeur(EchelCoul,valeur,erreur);
            Scanline[x*3]:=GetBValue(couleur);
            Scanline[x*3+1]:=GetGValue(couleur);
            Scanline[x*3+2]:=GetRValue(couleur);
          end;
      end;
  except
    result:=False;
  end;
end;

function decode_valeur(ECoul:TEchelleCoul;valeur:real;var erreur:boolean):TColor;
var
 prop:real;
 R,V,B,Rl,Vl,Bl,Rh,Vh,Bh:byte;
 degre:integer;
begin
  erreur:=false;
  result:=ClBlack;
  degre:=0;
  case ECoul.mode of
     0:erreur:=True;
     1:begin
         if ECoul.logar3C then prop:=ln(valeur/ECoul.valmin3C)/ln(ECoul.valmax3C/ECoul.valmin3C)
         else prop:=(valeur-ECoul.valmin3C)/(ECoul.valmax3C-ECoul.valmin3C);
         if prop>1 then prop:=1;
         if prop<0 then prop:=0;
         degre:=round(prop*1020);
         case degre of
           0..255:begin
               case ECoul.RVB of
                 0:begin
                     B:=255;
                     V:=degre;
                     R:=0;
                     result:=RGB(R,V,B);
                   end;
                 1:begin
                     V:=255;
                     R:=degre;
                     B:=0;
                     result:=RGB(R,V,B);
                   end;
                 2:begin
                     R:=255;
                     B:=degre;
                     V:=0;
                     result:=RGB(R,V,B);
                   end;
                 3:begin
                     B:=255;
                     R:=degre;
                     V:=0;
                     result:=RGB(R,V,B);
                   end;
                 4:begin
                     V:=255;
                     B:=degre;
                     R:=0;
                     result:=RGB(R,V,B);
                   end;
                 5:begin
                     R:=255;
                     V:=degre;
                     B:=0;
                     result:=RGB(R,V,B);
                   end;
               end;
             end;
           256..510:begin
               case ECoul.RVB of
                 0:begin
                     B:=510-degre;
                     V:=255;
                     R:=0;
                     result:=RGB(R,V,B);
                   end;
                 1:begin
                     V:=510-degre;
                     R:=255;
                     B:=0;
                     result:=RGB(R,V,B);
                   end;
                 2:begin
                     R:=510-degre;
                     B:=255;
                     V:=0;
                     result:=RGB(R,V,B);
                   end;
                 3:begin
                     B:=510-degre;
                     R:=255;
                     V:=0;
                     result:=RGB(R,V,B);
                   end;
                 4:begin
                     V:=510-degre;
                     B:=255;
                     R:=0;
                     result:=RGB(R,V,B);
                   end;
                 5:begin
                     R:=510-degre;
                     V:=255;
                     B:=0;
                     result:=RGB(R,V,B);
                   end;
               end;
             end;
           511..765:begin
               case ECoul.RVB of
                 0:begin
                     B:=0;
                     V:=255;
                     R:=degre-510;
                     result:=RGB(R,V,B);
                   end;
                 1:begin
                     V:=0;
                     R:=255;
                     B:=degre-510;
                     result:=RGB(R,V,B);
                   end;
                 2:begin
                     R:=0;
                     B:=255;
                     V:=degre-510;
                     result:=RGB(R,V,B);
                   end;
                 3:begin
                     B:=0;
                     R:=255;
                     V:=degre-510;
                     result:=RGB(R,V,B);
                   end;
                 4:begin
                     V:=0;
                     B:=255;
                     R:=degre-510;
                     result:=RGB(R,V,B);
                   end;
                 5:begin
                     R:=0;
                     V:=255;
                     B:=degre-510;
                     result:=RGB(R,V,B);
                   end;
               end;
             end;
           766..1020:begin
               case ECoul.RVB of
                 0:begin
                     B:=0;
                     V:=1020-degre;
                     R:=255;
                     result:=RGB(R,V,B);
                   end;
                 1:begin
                     V:=0;
                     R:=1020-degre;
                     B:=255;
                     result:=RGB(R,V,B);
                   end;
                 2:begin
                     R:=0;
                     B:=1020-degre;
                     V:=255;
                     result:=RGB(R,V,B);
                   end;
                 3:begin
                     B:=0;
                     R:=1020-degre;
                     V:=255;
                     result:=RGB(R,V,B);
                   end;
                 4:begin
                     V:=0;
                     B:=1020-degre;
                     R:=255;
                     result:=RGB(R,V,B);
                   end;
                 5:begin
                     R:=0;
                     V:=1020-degre;
                     B:=255;
                     result:=RGB(R,V,B);
                   end;
               end;
             end;
         end;
       end;
     2:begin
         Rl:=GetRValue(ECoul.couleurMin);
         Rh:=GetRValue(ECoul.couleurMax);
         Vl:=GetGValue(ECoul.couleurMin);
         Vh:=GetGValue(ECoul.couleurMax);
         Bl:=GetBValue(ECoul.couleurMin);
         Bh:=GetBValue(ECoul.couleurMax);
         if ECoul.logar2C then
             prop:=ln(valeur/ECoul.valmin2C)/ln(ECoul.valmax2C/ECoul.valmin2C)
         else prop:=(valeur-ECoul.valmin2C)/(ECoul.valmax2C-ECoul.valmin2C);
         R:=Rl+round(prop*(Rh-Rl));
         V:=Vl+round(prop*(Vh-Vl));
         B:=Bl+round(prop*(Bh-Bl));
         result:=RGB(R,V,B);
       end;
     3:erreur:=True;
  end;
end;

function decode_couleur(EchelleCoul:TEchelleCoul;couleur:TColor;var erreur:boolean):string;
var
 prop,res:real;
 R,V,B,Rl,Vl,Bl,Rh,Vh,Bh:byte;
 degre,i:integer;
 drap:boolean;
begin
  erreur:=false;
  result:='';
  res:=0;
  drap:=true;
  R:=GetRValue(couleur);
  V:=GetGValue(couleur);
  B:=GetBValue(couleur);
  degre:=0;
  case EchelleCoul.mode of
     0:erreur:=True;
     1:begin
         if (R=0) or (V=0) or (B=0) then
           begin
             case EchelleCoul.RVB of
               0:begin
                   if R=0 then
                     begin
                       if B=255 then
                         begin
                           degre:=V
                         end
                       else
                         begin
                           degre:=510-B;
                         end;
                     end
                   else if V=0 then
                     begin
                       if B=255 then degre:=0 else degre:=1020;
                     end
                   else if B=0 then
                     begin
                       if V=255 then degre:=510+R else degre:= 1020-V;
                     end;
                 end;
               1:begin
                   if B=0 then
                     begin
                       if V=255 then
                         begin
                           degre:=R
                         end
                       else
                         begin
                           degre:=510-V;
                         end;
                     end
                   else if R=0 then
                     begin
                       if V=255 then degre:=0 else degre:=1020;
                     end
                   else if V=0 then
                     begin
                       if R=255 then degre:=510+B else degre:= 1020-R;
                     end;
                 end;
               2:begin
                   if V=0 then
                     begin
                       if R=255 then
                         begin
                           degre:=B
                         end
                       else
                         begin
                           degre:=510-R;
                         end;
                     end
                   else if B=0 then
                     begin
                       if R=255 then degre:=0 else degre:=1020;
                     end
                   else if R=0 then
                     begin
                       if B=255 then degre:=510+V else degre:= 1020-B;
                     end;
                 end;
               3:begin
                   if V=0 then
                     begin
                       if B=255 then
                         begin
                           degre:=R
                         end
                       else
                         begin
                           degre:=510-B;
                         end;
                     end
                   else if R=0 then
                     begin
                       if B=255 then degre:=0 else degre:=1020;
                     end
                   else if B=0 then
                     begin
                       if R=255 then degre:=510+V else degre:= 1020-R;
                     end;
                 end;
               4:begin
                   if R=0 then
                     begin
                       if V=255 then
                         begin
                           degre:=B
                         end
                       else
                         begin
                           degre:=510-V;
                         end;
                     end
                   else if B=0 then
                     begin
                       if V=255 then degre:=0 else degre:=1020;
                     end
                   else if V=0 then
                     begin
                       if B=255 then degre:=510+R else degre:= 1020-B;
                     end;
                 end;
               5:begin
                   if B=0 then
                     begin
                       if R=255 then
                         begin
                           degre:=V
                         end
                       else
                         begin
                           degre:=510-R;
                         end;
                     end
                   else if V=0 then
                     begin
                       if R=255 then degre:=0 else degre:=1020;
                     end
                   else if R=0 then
                     begin
                       if V=255 then degre:=510+B else degre:= 1020-V;
                     end;
                 end;
             end;
             prop:=degre/1020;
             if EchelleCoul.logar3C then
               res:=EchelleCoul.valmin3C*exp(prop*ln(EchelleCoul.valmax3C/EchelleCoul.valmin3C))
             else
               res:=EchelleCoul.valmin3C+prop*(EchelleCoul.valmax3C-EchelleCoul.valmin3C);
             result:=FloatToStrF(res,ffGeneral,4,1);
           end
         else erreur:=True;
       end;
     2:begin
         Rl:=GetRValue(EchelleCoul.couleurMin);
         Rh:=GetRValue(EchelleCoul.couleurMax);
         Vl:=GetGValue(EchelleCoul.couleurMin);
         Vh:=GetGValue(EchelleCoul.couleurMax);
         Bl:=GetBValue(EchelleCoul.couleurMin);
         Bh:=GetBValue(EchelleCoul.couleurMax);
         if (R>max(Rl,Rh)) or (R<min(Rl,Rh)) or (V>max(Vl,Vh)) or (V<min(Vl,Vh))
             or (B>max(Bl,Bh)) or (B<min(Bl,Bh)) then
           begin
             erreur:=True;
           end
         else
           begin
             if abs(Rh-Rl)> abs(Vh-Vl) then
               begin
                 if abs(Rh-Rl)> abs(Bh-Bl) then prop:=(R-Rl)/(Rh-Rl)
                 else prop:=(B-Bl)/(Bh-Bl);
               end
             else
               begin
                 if abs(Vh-Vl)> abs(Bh-Bl) then prop:=(V-Vl)/(Vh-Vl)
                 else prop:=(B-Bl)/(Bh-Bl);
               end;
             if EchelleCoul.logar2C then
               res:=EchelleCoul.valmin2C*exp(prop*ln(EchelleCoul.valmax2C-EchelleCoul.valmin2C))
             else
               res:=EchelleCoul.valmin2C+prop*(EchelleCoul.valmax2C-EchelleCoul.valmin2C);
             result:=FloatToStrF(res,ffGeneral,4,1);
           end;
       end;
     3:begin
         for i:=0 to EchelleCoul.nombre-1  do
           if couleur=EchelleCoul.couleurs[i] then
             begin
               result:=EchelleCoul.valeurs[i];
               drap:=False;
             end;
         erreur:=drap;
       end;
  end;
end;

function Lit_lignes_EchelleCoul(chaines:TStrings):TEchelleCoul;
var
  chain:String;
  i:integer;
begin
  chain:='';
  For i:=0 to chaines.Count-1 do
      chain:=chain+chaines.Strings[i];
  Result:=Lit_String_EchelleCoul(chain);
end;
function transcrit_EchelleCoul(EchelleCoul:TEchelleCoul):string;
var
  chaine:string;
  i:integer;
begin
  chaine:='<CODE_C=';
  chaine:=chaine+IntToStr(EchelleCoul.mode)+';';
  Case EchelleCoul.mode of
    0: begin
         chaine:=chaine+FloatToStrF(EchelleCoul.valminC1,ffGeneral,4,1)+';';
         chaine:=chaine+FloatToStrF(EchelleCoul.valminC2,ffGeneral,4,1)+';';
         chaine:=chaine+FloatToStrF(EchelleCoul.valminC3,ffGeneral,4,1)+';';
         chaine:=chaine+FloatToStrF(EchelleCoul.valmaxC1,ffGeneral,4,1)+';';
         chaine:=chaine+FloatToStrF(EchelleCoul.valmaxC2,ffGeneral,4,1)+';';
         chaine:=chaine+FloatToStrF(EchelleCoul.valmaxC3,ffGeneral,4,1)+';';
         chaine:=chaine+EchelleCoul.signifC1+';';
         chaine:=chaine+EchelleCoul.signifC2+';';
         chaine:=chaine+EchelleCoul.signifC3+';';
         chaine:=chaine+IntToStr(EchelleCoul.coulsymbC1)+';';
         chaine:=chaine+IntToStr(EchelleCoul.coulsymbC2)+';';
         chaine:=chaine+IntToStr(EchelleCoul.coulsymbC3)+';';
       end;
    1: begin
         chaine:=chaine+IntToStr(EchelleCoul.RVB)+';';
         chaine:=chaine+IntToStr(EchelleCoul.couleurDeb)+';';
         chaine:=chaine+IntToStr(EchelleCoul.couleurMil)+';';
         chaine:=chaine+IntToStr(EchelleCoul.couleurFin)+';';
         chaine:=chaine+FloatToStrF(EchelleCoul.valmin3C,ffGeneral,4,1)+';';
         chaine:=chaine+FloatToStrF(EchelleCoul.valmax3C,ffGeneral,4,1)+';';
         if EchelleCoul.logar3C then chaine:=chaine+'V;' else chaine:=chaine+'F;';
         chaine:=chaine+EchelleCoul.signif3C+';';
         chaine:=chaine+EchelleCoul.unite3C+';';
       end;
    2: begin
         chaine:=chaine+IntToStr(EchelleCoul.couleurMin)+';';
         chaine:=chaine+IntToStr(EchelleCoul.couleurMax)+';';
         chaine:=chaine+FloatToStrF(EchelleCoul.valmin2C,ffGeneral,4,1)+';';
         chaine:=chaine+FloatToStrF(EchelleCoul.valmax2C,ffGeneral,4,1)+';';
         if EchelleCoul.logar2C then chaine:=chaine+'V;' else chaine:=chaine+'F;';
         chaine:=chaine+EchelleCoul.signif2C+';';
         chaine:=chaine+EchelleCoul.unite2C+';';
       end;
    3: begin
         chaine:=chaine+IntToStr(EchelleCoul.nombre)+';';
         chaine:=chaine+EchelleCoul.signifD+';';
         chaine:=chaine+EchelleCoul.uniteD+';';
         for i:=0 to EchelleCoul.nombre-1 do
           begin
             chaine:=chaine+EchelleCoul.valeurs[i]+';';
             chaine:=chaine+IntToStr(EchelleCoul.couleurs[i])+';';
           end;
       end;
  end;
  result:=chaine+'>';
end;
function Lit_string_EchelleCoul(Chain:string):TEchelleCoul;
var
  chaine,chaine2,symbdec,notsymbdec:String;
  i:integer;
  EchelleCoul:TEchelleCoul;
begin
  try
    if 1.5=StrToFloat('1,5') then
      begin
        symbdec:=',';
        Notsymbdec:='.';
      end
    else
      begin
        symbdec:='.';
        Notsymbdec:=',';
      end;
  except
    symbdec:='.';
    Notsymbdec:=',';
  end;
  EchelleCoul.active:=false;
  Chaine:=Chain;
  if Pos('<CODE_C', UpperCase(chaine))>0 then chaine2:=Copy2SymbDelb(chaine,'=');
          chaine:=Copy2Symb(chaine,'>');
          chaine2:=Copy2SymbDelb(chaine,';');
          try
            EchelleCoul.mode:=StrToInt(chaine2);
            chaine2:=Copy2SymbDelb(chaine,';');
            Case EchelleCoul.mode of
              0: begin
                   if pos(Notsymbdec,chaine2)> 0 then
                     if symbdec=',' then chaine2[pos(Notsymbdec,chaine2)]:=','
                     else chaine2[pos(Notsymbdec,chaine2)]:='.';
                   EchelleCoul.valminC1:=StrToFloat(chaine2);
                   chaine2:=Copy2SymbDelb(chaine,';');
                   if pos(Notsymbdec,chaine2)> 0 then
                     if symbdec=',' then chaine2[pos(Notsymbdec,chaine2)]:=','
                     else chaine2[pos(Notsymbdec,chaine2)]:='.';
                   EchelleCoul.valminC2:=StrToFloat(chaine2);
                   chaine2:=Copy2SymbDelb(chaine,';');
                   if pos(Notsymbdec,chaine2)> 0 then
                     if symbdec=',' then chaine2[pos(Notsymbdec,chaine2)]:=','
                     else chaine2[pos(Notsymbdec,chaine2)]:='.';
                   EchelleCoul.valminC3:=StrToFloat(chaine2);

                   chaine2:=Copy2SymbDelb(chaine,';');
                   if pos(Notsymbdec,chaine2)> 0 then
                     if symbdec=',' then chaine2[pos(Notsymbdec,chaine2)]:=','
                     else chaine2[pos(Notsymbdec,chaine2)]:='.';
                   EchelleCoul.valmaxC1:=StrToFloat(chaine2);
                   chaine2:=Copy2SymbDelb(chaine,';');
                   if pos(Notsymbdec,chaine2)> 0 then
                     if symbdec=',' then chaine2[pos(Notsymbdec,chaine2)]:=','
                     else chaine2[pos(Notsymbdec,chaine2)]:='.';
                   EchelleCoul.valmaxC2:=StrToFloat(chaine2);
                   chaine2:=Copy2SymbDelb(chaine,';');
                   if pos(Notsymbdec,chaine2)> 0 then
                     if symbdec=',' then chaine2[pos(Notsymbdec,chaine2)]:=','
                     else chaine2[pos(Notsymbdec,chaine2)]:='.';
                   EchelleCoul.valmaxC3:=StrToFloat(chaine2);

                   chaine2:=Copy2SymbDelb(chaine,';');
                   EchelleCoul.signifC1:=chaine2;
                   chaine2:=Copy2SymbDelb(chaine,';');
                   EchelleCoul.signifC2:=chaine2;
                   chaine2:=Copy2SymbDelb(chaine,';');
                   EchelleCoul.signifC3:=chaine2;

                   chaine2:=Copy2SymbDelb(chaine,';');
                   EchelleCoul.coulsymbC1:=StrToInt(chaine2);
                   chaine2:=Copy2SymbDelb(chaine,';');
                   EchelleCoul.coulsymbC2:=StrToInt(chaine2);
                   chaine2:=Copy2SymbDelb(chaine,';');
                   EchelleCoul.coulsymbC3:=StrToInt(chaine2);

                   EchelleCoul.active:=True;
                 end;
              1: begin
                   EchelleCoul.RVB:=StrToInt(chaine2);

                   chaine2:=Copy2SymbDelb(chaine,';');
                   EchelleCoul.couleurDeb:=StrToInt(chaine2);
                   chaine2:=Copy2SymbDelb(chaine,';');
                   EchelleCoul.couleurMil:=StrToInt(chaine2);
                   chaine2:=Copy2SymbDelb(chaine,';');
                   EchelleCoul.couleurFin:=StrToInt(chaine2);

                   chaine2:=Copy2SymbDelb(chaine,';');
                   if pos(Notsymbdec,chaine2)> 0 then
                     if symbdec=',' then chaine2[pos(Notsymbdec,chaine2)]:=','
                     else chaine2[pos(Notsymbdec,chaine2)]:='.';
                   EchelleCoul.valmin3C:=StrToFloat(chaine2);
                   chaine2:=Copy2SymbDelb(chaine,';');
                   if pos(Notsymbdec,chaine2)> 0 then
                     if symbdec=',' then chaine2[pos(Notsymbdec,chaine2)]:=','
                     else chaine2[pos(Notsymbdec,chaine2)]:='.';
                   EchelleCoul.valmax3C:=StrToFloat(chaine2);

                   chaine2:=Copy2SymbDelb(chaine,';');
                   if chaine2='V' then EchelleCoul.logar3C:=True else EchelleCoul.logar3C:=False;

                   chaine2:=Copy2SymbDelb(chaine,';');
                   EchelleCoul.signif3C:=chaine2;
                   chaine2:=Copy2SymbDelb(chaine,';');
                   EchelleCoul.unite3C:=chaine2;
                   EchelleCoul.active:=True;
                 end;
              2: begin
                   EchelleCoul.couleurMin:=StrToInt(chaine2);
                   chaine2:=Copy2SymbDelb(chaine,';');
                   EchelleCoul.couleurMax:=StrToInt(chaine2);

                   chaine2:=Copy2SymbDelb(chaine,';');
                   if pos(Notsymbdec,chaine2)> 0 then
                     if symbdec=',' then chaine2[pos(Notsymbdec,chaine2)]:=','
                     else chaine2[pos(Notsymbdec,chaine2)]:='.';
                   EchelleCoul.valmin2C:=StrToFloat(chaine2);
                   chaine2:=Copy2SymbDelb(chaine,';');
                   if pos(Notsymbdec,chaine2)> 0 then
                     if symbdec=',' then chaine2[pos(Notsymbdec,chaine2)]:=','
                     else chaine2[pos(Notsymbdec,chaine2)]:='.';
                   EchelleCoul.valmax2C:=StrToFloat(chaine2);

                   chaine2:=Copy2SymbDelb(chaine,';');
                   if chaine2='V' then EchelleCoul.logar2C:=True else EchelleCoul.logar2C:=False;

                   chaine2:=Copy2SymbDelb(chaine,';');
                   EchelleCoul.signif2C:=chaine2;
                   chaine2:=Copy2SymbDelb(chaine,';');
                   EchelleCoul.unite2C:=chaine2;
                   EchelleCoul.active:=True;
                 end;
              3: begin
                   EchelleCoul.nombre:=StrToInt(chaine2);
                   chaine2:=Copy2SymbDelb(chaine,';');
                   EchelleCoul.signifD:=chaine2;
                   chaine2:=Copy2SymbDelb(chaine,';');
                   EchelleCoul.uniteD:=chaine2;
                   for i:=0 to EchelleCoul.nombre-1 do
                     begin
                       chaine2:=Copy2SymbDelb(chaine,';');
                       EchelleCoul.valeurs[i]:=chaine2;
                       chaine2:=Copy2SymbDelb(chaine,';');
                       EchelleCoul.couleurs[i]:=StrToInt(chaine2);
                     end;

                   EchelleCoul.active:=True;
                 end;
            end;
          except
            EchelleCoul.active:=false;
          end;
  Result:=EchelleCoul;
end;
function Charge_EchelleCoul(Fichier:String):TEchelleCoul;
var
  Chaine,fic:string;
  F:TextFile;
  EchelleCoul:TEchelleCoul;
begin
  fic:=Copy(Fichier,1,Length(Fichier)-4)+'.ccc';
  EchelleCoul.mode:=0;
  EchelleCoul.valmaxC1:=255;
  EchelleCoul.valmaxC2:=255;
  EchelleCoul.valmaxC3:=255;
  EchelleCoul.valminC1:=0;
  EchelleCoul.valminC2:=0;
  EchelleCoul.valminC3:=0;
  EchelleCoul.signifC1:='Bleu';
  EchelleCoul.signifC2:='Vert';
  EchelleCoul.signifC3:='Rouge';
  EchelleCoul.coulsymbC1:=ClBlue;
  EchelleCoul.coulsymbC2:=ClLime;
  EchelleCoul.coulsymbC3:=ClRed;
  EchelleCoul.active:=True;
  Result:=EchelleCoul;
  if Not FileExists(Fic) then exit;
  try
    AssignFile(F, fic);
    Reset(F);
    Readln(F, Chaine);
    CloseFile(F);
    EchelleCoul:=Lit_string_EchelleCoul(Chaine);
    EchelleCoul.active:=true;
  except
    EchelleCoul.mode:=0;
    EchelleCoul.valmaxC1:=255;
    EchelleCoul.valmaxC2:=255;
    EchelleCoul.valmaxC3:=255;
    EchelleCoul.valminC1:=0;
    EchelleCoul.valminC2:=0;
    EchelleCoul.valminC3:=0;
    EchelleCoul.signifC1:='Bleu';
    EchelleCoul.signifC2:='Vert';
    EchelleCoul.signifC3:='Rouge';
    EchelleCoul.coulsymbC1:=ClBlue;
    EchelleCoul.coulsymbC2:=ClLime;
    EchelleCoul.coulsymbC3:=ClRed;
    EchelleCoul.active:=True;
  end;
  Result:=EchelleCoul;
end;
procedure Sauve_EchelleCoul(Fichier:String;EchelleCoul:TEchelleCoul);
var
  Chaine,fic:string;
  F:TextFile;
begin
  Chaine:=transcrit_EchelleCoul(EchelleCoul);
  fic:=Copy(fichier,1,Length(fichier)-4)+'.ccc';
  AssignFile(F, fic);
  Rewrite(F);
  Writeln(F, Chaine);
  CloseFile(F);
end;
end.

