unit GrapheBoite;

interface

uses
  Windows, Messages, SysUtils, Classes,Controls,Gr32,Gr32_Layers,GR32_Image,graphics,
  GestionTextes,Forms;

type
  TTableauDentiers=Array of integer;
  TGrapheBoite = class;
  TBoiteLayer = class;
  TTaxonLayer = class(TPositionedLayer)
  public
    { Dclarations publiques }
    Proprietaire:TGrapheBoite;
    Support:TRubberbandLayer;
    Nom:String; // Nom pour les comparaisons
    EtiqTaxon:String;//Nom  afficher (avec ventuellement l'ge);
    Parent:TBoiteLayer;
    Encadre:Boolean;
    CouleurCadre:TColor32;
    CouleurFond:TColor32;
    CouleurTexte:TColor32;
    Largeur:integer;
    Hauteur:integer;
    MargeTexte:integer;
    MargeHautTexte:integer;
    LargeurTexte:integer;
    Caracteres:TStringList;
    Etats:TStringList;
    Procedure Paint(Buffer: TBitmap32); override;
    Procedure DessineSur(LeBitMap:TBitmap32);
    procedure DeplaceTexte(Sender: TObject;const OldLocation: TFloatRect;var NewLocation: TFloatRect;
              DragState: TDragState;Shift: TShiftState);
    Procedure Positionne(X,Y:integer);
    function EstIncluDans(LaBoite:TBoiteLayer):Boolean;
    Constructor CreateBoite(LeProprietaire:TGrapheBoite);
    Destructor Destroy; override;
    Function CalculeTaille:Boolean;
    Procedure MetEnAvant;
  end;
  TBoiteLayer = class(TPositionedLayer)
  private
    { Dclarations prives }
  protected
    { Dclarations protges }
  public
    { Dclarations publiques }
    Proprietaire:TGrapheBoite;
    Support:TRubberbandLayer;
    Nom:String;
    NomGroupe:string;
    Niveau:integer;
    Inclus:Array of TBoiteLayer;
    TaxonsExe:Array of TTaxonLayer;
    ListeTaxonsExe:TStringList;
    //Taxons:TStringList; // Noms pour les comparaisons
    EtiqTaxons:TStringList;//Noms  afficher (avec ventuellement l'ge);
    ListeComplete:TStringList;
    ListeEtiqComplete:TStringList;
    Caracteres:TStringList;
    Etats:TStringList;
    Parent:TBoiteLayer;
    Encadre:Boolean;
    SurEncadre:Boolean;
    CouleurCadre:TColor32;
    CouleurSurCadre:TColor32;
    CouleurBandeau:TColor32;
    Largeur:integer;
    Hauteur:integer;
    MargeTexte:integer;
    MargeHautTexte:integer;
    HauteurBandeau:integer;
    HauteurGroupe:integer;
    HauteurTaxonsExe:integer;
    HauteurTaxons:integer;
    LargeurTexte:integer;
    StructureA:string; //chaine de structure correspondant  l'arbre;
    StructureB:string; //chaine de structure de bote;
    StructureBV:string; //chaine de structure de bote vide (sans les taxons);
    StructureBComp:string; //chaine de structure de bote complte par le nom de groupe s'il n'y a pas de taxon);
    //AffichEtat:Boolean;
    Procedure Paint(Buffer: TBitmap32); override;
    Procedure DessineSur(LeBitMap:TBitmap32);
    procedure DeplaceBoite(Sender: TObject;const OldLocation: TFloatRect;var NewLocation: TFloatRect;
              DragState: TDragState;Shift: TShiftState);
    Procedure Positionne(X,Y:integer);
    procedure RetireDInclus(LaBoite:TBoiteLayer;Vider:Boolean);
    procedure AjouteInclus(LaBoite:TBoiteLayer);
    function ManqueInclus:Boolean;
    function ManqueInclusCorr(Var BoiteInc,BoiteCont:TBoiteLayer):Boolean;
    function EstIncluDans(LaBoite:TBoiteLayer):Boolean;
    Constructor CreateBoite(LeProprietaire:TGrapheBoite);
    Destructor Destroy; override;
    Function CalculeTaille:Boolean;
    Procedure MetEnAvant;
    Procedure AjouteTaxonExe(NomTaxon:string);
    Function NombreNiveaux:integer;
  published
    { Dclarations publies }
  end;
  TGrapheBoite = class(TImage32)
  private
    { Dclarations prives }
    FAffichEtat:Boolean;
  protected
    { Dclarations protges }
    Attente:boolean;
  public
    { Dclarations publiques }
    Boites:Array of TBoiteLayer;
    Taxons:Array of TTaxonLayer;
    Fossiles:TStringList;

    //BoitesSansInclus:TList; // de TBoiteLayer;
    MargeBoitesH:integer;
    MargeBoitesV:integer;
    Fige:Boolean;
    PanelSupport:TScrollBox;
    Procedure CalculeTailles;
    Procedure AjusteTaille;
    //Procedure Paint; override;
    Procedure DessineSur(LeBitMap:TBitmap32);
    Function CreeBoite(LesTaxons,LesCaracteres,LesEtats,LesnomsAffich:TStringList;Couleur:TColor32):integer;
    procedure SepareBoites(Car1:string;ListeCar2:TStringList;NouvCouleur:TColor32);
    Procedure RaZBoites;
    procedure RaZSurEncadre;
    Function CreeTaxon(Nom,EtiqTaxon:string;LesCaracteres:TStringList;LesEtats:TStringList;Couleur:TColor32):integer;
    //Function Fusionne(BoiteOrg:TboiteLayer;X,Y:integer):Boolean;
    Function Fusionne(BoiteOrg,BoiteCible:TboiteLayer):Boolean;
    Function FusionneBNum(NOrg,NCible:integer):Boolean;
    Function InclutDans(BoiteOrg,BoiteCible:TboiteLayer;var NumO,NumC:integer):Boolean;
    Procedure DeplaceVers(BoiteOrg:TboiteLayer;X,Y:integer;var NumO,NumC:integer;Var NomCarC:string;Var Fusion,ChangeCol:Boolean);
    Function DeplaceTaxonVers(LeTaxonClique:TTaxonLayer;X,Y:integer;Var CouleurFeu:Tcolor):Boolean;
    Function NumeroBoiteSuiv(X:integer):integer;
    Procedure PositionneBoites;
    Procedure Redessine;
    Procedure ChangeOrdreBoite(PosOrg,PosFin:integer);
    procedure MouseDown (Button: TMouseButton; Shift: TShiftState; X, Y: Integer; Layer: TCustomLayer); override;
    procedure MouseMove (Shift: TShiftState; X, Y: Integer; Layer: TCustomLayer); override;
    Function BoiteAPosition(LayerOrg:TPositionedLayer;X,Y:integer):TboiteLayer;
    Function NumBoite(LaBoite:TBoiteLayer):integer;
    Procedure MetEnAvantBoites;
    Function AjouteBoite(LaBoite:TBoiteLayer):integer; //renvoie le numro
    Function AjouteTaxon(LeTaxon:TTaxonLayer):integer; //renvoie le numro
    Procedure RetireBoite(p:integer);
    Function CreeEtPlaceBoites(LeCaractere:string;SesTaxons,SesEtats,SesnomsAffich,SesGroupes:TStringList;Couleurs:Array of TColor32):Boolean;
    Function CherchePlaceBoite(ListeTaxons:TStringList;var identique:boolean;var NumBoiteParente:integer;var NumBoiteIncluse:TTableauDentiers):boolean;
    Procedure RetireBoiteContenant(Nomcar:string);
    Procedure RetireBoitesContenant(Nomcar:string);
    Procedure SupprimeBoite(LaBoite:TBoiteLayer);
    procedure RetireTaxon(TaxE:TTaxonLayer);
    procedure SupprimeTaxon(LeTaxon:TTaxonLayer);
    Procedure SupprimeSupport(Layer:TRubberbandLayer);
    Function ErreurInclusion:Boolean;
    Function ExisteBoiteAvecExcl(NomCar:string;BoiteExclue:TBoiteLayer):integer;
    Function ExisteBoite(NomCar:string):integer;
    Function ExisteTaxon(NomTaxon:string):integer;
    Procedure ReclasseBoites(ListeCar:TStringList);
    procedure RazListesTaxonsExe;
    function ExisteTaxonsLibres:Boolean;
    Function StructArbre:String;
    Function StructBoite:String;
    Function StructBoiteVide:String;
    Function StructBoiteComp:String;
    Function LaBoite(NomCar,NomEtat:string):TBoiteLayer;
    Procedure SetAffichEtat(Etat:Boolean);
    Procedure CreeBoitesDApresStructure(BoiteParente:TBoiteLayer;ChaineStruct:string;limG,limD:string);
    Function NouvelleBoiteDApresStructure(BoiteParente:TBoiteLayer;ChaineStruct:string):TBoiteLayer;
    Procedure EmboiteTout;
    Function NombreNiveaux:integer;
    Procedure VerifieListesAffichees;
    procedure Inclure(BoiteInc,BoiteParente:TBoiteLayer);
    Constructor Create(AOwner: TComponent);override;
    Destructor Destroy; override;
    Property AffichEtat:Boolean read FAffichEtat write SetAffichEtat;


  published
    { Dclarations publies }
  end;
  function ListeIncluseDans(Liste,ListeConteneur:TStringList):Boolean;
procedure Register;

implementation
uses Dialogs;
//***** TTaxonLayer ******
Constructor TTaxonLayer.CreateBoite(LeProprietaire:TGrapheBoite);
begin
  Proprietaire:=LeProprietaire;
  Create(LeProprietaire.Layers);
  Scaled:=True;
  Encadre:=False;
  CouleurCadre:=clBlack32;
  CouleurFond:=clWhite32;
  Hauteur:=0;
  Largeur:=0;
  Support:=TRubberbandLayer.Create(LeProprietaire.Layers);
  Support.ChildLayer:=Self;
  support.Visible:=False;
  Support.Scaled:=True;
  Support.Handles:=[rhCenter];
  Nom:=''; // Nom pour les comparaisons
  EtiqTaxon:='';//Nom  afficher (avec ventuellement l'ge);
  Caracteres:=TStringList.Create;
  Etats:=TStringList.Create;
  Parent:=Nil;
  MargeTexte:=2;
  MargeHautTexte:=2;
  LargeurTexte:=0;
  Support.OnResizing:=DeplaceTexte;
end;

Destructor TTaxonLayer.Destroy;
begin
  inherited Destroy;
end;
Procedure TTaxonLayer.MetEnAvant;
begin
  Support.BringToFront;
end;

Procedure TTaxonLayer.Positionne(X,Y:integer);
Var
  Position:TFloatRect;
begin
  Position:=Support.Location;
  Position.Left:=X;
  Position.Top:=Y;
  Position.Bottom:=Position.Top+Hauteur;
  Position.Right:=Position.Left+Largeur;
  Support.Location:=Position;
end;
procedure TTaxonLayer.DeplaceTexte(Sender: TObject;const OldLocation: TFloatRect;var NewLocation: TFloatRect;
              DragState: TDragState;Shift: TShiftState);
Var
  emplacement:TFloatRect;
  X,Y:Integer;
begin
  emplacement:=NewLocation;
  if emplacement.Left<0 then
    begin
      emplacement.Left:=0;
      emplacement.Right:=emplacement.Left+(OldLocation.Right-OldLocation.Left);
    end;
  if emplacement.Right>(Proprietaire.Bitmap.Width-1) then
    begin
      emplacement.Right:=Proprietaire.Bitmap.Width-1;
      emplacement.Left:=emplacement.Right-(OldLocation.Right-OldLocation.Left);
    end;
  if emplacement.Top<0 then
    begin
      emplacement.Top:=0;
      emplacement.Bottom:=emplacement.Top+(OldLocation.Bottom-OldLocation.Top);
    end;
  if emplacement.Bottom>(Proprietaire.Bitmap.Height-1) then
    begin
      emplacement.Bottom:=Proprietaire.Bitmap.Height-1;
      emplacement.Top:=emplacement.Bottom-(OldLocation.Bottom-OldLocation.Top);
    end;
  NewLocation:=emplacement;
  Support.Location:=Emplacement;
  X:=Round(emplacement.Left);
  Y:=Round(emplacement.Top);
  Positionne(X,Y);
end;
Procedure TTaxonLayer.Paint(Buffer: TBitmap32);
begin
  if (Self<>Nil) and (Buffer<>Nil) then DessineSur(Buffer);
end;
Procedure TTaxonLayer.DessineSur(LeBitMap:TBitmap32);
Var
  X0,Y0:integer;
  X,Y:integer;
  //decalY:integer;
  anccouleur:TColor;
begin
  X0:=Round(Location.Left);
  Y0:=Round(Location.Top);
  LeBitMap.Font.color:=0;
  //decalY:=Proprietaire.Buffer.TextHeight('T');
  if (Hauteur<1) or (Largeur<1) then
    if Not CalculeTaille then exit;
  if Encadre then
    begin
      LeBitMap.FrameRectS(X0+2, Y0+2, X0+Largeur-2, Y0+Hauteur-2, CouleurCadre);
      LeBitMap. FillRect(X0+3, Y0+3, X0+Largeur-3, Y0+Hauteur-1,CouleurFond);
    end;
  X:=X0+3+(MargeTexte div 2);
  Y:=Y0+3+(MargeTexte div 2);
  anccouleur:=LeBitMap.Font.Color;
  LeBitMap.Font.Color:=WinColor(CouleurTexte);
  LeBitMap.TextOut(X,Y,EtiqTaxon);
  LeBitMap.Font.Color:=anccouleur;
end;
Function TTaxonLayer.CalculeTaille:Boolean;
Var
  //LargeurBandeau:integer;
  HauteurTexte:integer;
  cadre:TFloatRect;
begin
  Result:=True;
  Largeur:=0;
  Hauteur:=0;
  Largeur:=Largeur+6+MargeTexte*2;
  LargeurTexte:=Proprietaire.Buffer.TextWidth(EtiqTaxon);
  Largeur:=Largeur+LargeurTexte;
  HauteurTexte:=(Proprietaire.Buffer.TextHeight('T')+MargeTexte);
  if Hauteur<HauteurTexte then
    Hauteur:=HauteurTexte;
  //Hauteur:=Hauteur+2;
  cadre:=Support.Location;
  Cadre.Bottom:=Cadre.Top+Hauteur;
  Cadre.Right:=Cadre.Left+Largeur;
  LargeurTexte:=LargeurTexte+3+2*MargeTexte;
  Support.Location:=Cadre;
end;
function TTaxonLayer.EstIncluDans(LaBoite:TBoiteLayer):Boolean;
Var
  i,n:integer;
  AutreListe:TStringList;
begin
{  Result:=(LaBoite.ListeTaxonsExe.IndexOf(Nom)>=0);}

  Result:=True;
  AutreListe:=LaBoite.Caracteres;
  if AutreListe.Count>Caracteres.Count then //>=
    Begin
      Result:=False;
      Exit;
    end;
  For i:=0 to AutreListe.Count-1 do
    begin
      n:=Caracteres.IndexOf(AutreListe[i]);
      if n<0 then
        begin
          Result:=False;
          Exit;
        end;
    end; 
end;


//***** TBoiteLayer ******
Constructor TBoiteLayer.CreateBoite(LeProprietaire:TGrapheBoite);
begin
  Proprietaire:=LeProprietaire;
  Create(LeProprietaire.Layers);
  Scaled:=True;
  Encadre:=False;
  SurEncadre:=False;
  CouleurCadre:=clBlack32;
  CouleurSurCadre:=clWhite32;
  CouleurBandeau:=clWhite32;
  Hauteur:=0;
  Largeur:=0;
  HauteurBandeau:=0;
  HauteurGroupe:=0;
  HauteurTaxons:=0;
  HauteurTaxonsExe:=0;
  Niveau:=0;
  //OnPaint:=Paint;
  Support:=TRubberbandLayer.Create(LeProprietaire.Layers);
  Support.ChildLayer:=Self;
  support.Visible:=False;
  Support.Scaled:=True;
  SetLength(Inclus,0);
  SetLength(TaxonsExe,0);
  //Taxons:=TStringList.Create; // Noms pour les comparaisons
  EtiqTaxons:=TStringList.Create;//Noms  afficher (avec ventuellement l'ge);
  Caracteres:=TStringList.Create;
  Etats:=TStringList.Create;
  ListeComplete:=TStringList.Create;
  ListeEtiqComplete:=TStringList.Create;
  ListeTaxonsExe:=TStringList.Create;
  NomGroupe:='';
  Parent:=Nil;
  MargeTexte:=2;
  MargeHautTexte:=2;
  LargeurTexte:=0;
  Support.OnResizing:=DeplaceBoite;
  Support.Handles:=[rhCenter];
end;

Destructor TBoiteLayer.Destroy;
begin
  inherited Destroy;
end;
Procedure TBoiteLayer.MetEnAvant;
Var
  i:integer;
begin
  Support.BringToFront;
  For i:=0 to Length(Inclus)-1 do
    begin
      Inclus[i].MetEnAvant;
    end;
end;
Function TBoiteLayer.NombreNiveaux:integer;
Var
  i,n,p:integer;
Begin
  Niveau:=0;
  p:=Length(Inclus);  //Self.
  For i:=0 to p-1 do
    begin
      if (Inclus[i]<>Nil) and (Inclus[i].Parent<>Nil) then
        begin
          n:=Inclus[i].NombreNiveaux;
          if n>Niveau then
            Niveau:=n;
        end;
    end;
  if Length(Inclus)>0 then inc(Niveau);
  Result:=Niveau;
end;

Procedure TBoiteLayer.Positionne(X,Y:integer);
Var
  i:integer;
  Position:TFloatRect;
  Xi,Yi:integer;
  HauteurLigne:integer;
begin
  Yi:=Y+HauteurBandeau+HauteurGroupe+MargeTexte;
  Xi:=X+LargeurTexte;
  Position:=Support.Location;
  Position.Left:=X;
  Position.Top:=Y;
  Position.Bottom:=Position.Top+Hauteur;
  Position.Right:=Position.Left+Largeur;
  Support.Location:=Position;
  HauteurLigne:=Proprietaire.Buffer.TextHeight('T')+MargeTexte;
  For i:=0 to Length(Inclus)-1 do
    begin
      Inclus[i].Positionne(Xi,Yi);
      Xi:=Xi+Inclus[i].Largeur+MargeTexte;
    end;
  Yi:=Y+HauteurBandeau+HauteurGroupe+2*MargeTexte+HauteurTaxons;
  For i:=0 to Length(TaxonsExe)-1 do
    begin
      TaxonsExe[i].Positionne(X,Yi);
      Yi:=Yi+HauteurLigne;
    end;
end;
procedure TBoiteLayer.DeplaceBoite(Sender: TObject;const OldLocation: TFloatRect;var NewLocation: TFloatRect;
              DragState: TDragState;Shift: TShiftState);
Var
  emplacement:TFloatRect;
  X,Y:Integer;
begin
  if (Not (ssleft in Shift)) or Proprietaire.Fige then
    begin
      NewLocation:=OldLocation;
      exit;
    end;
  emplacement:=NewLocation;
  if emplacement.Left<0 then
    begin
      emplacement.Left:=0;
      emplacement.Right:=emplacement.Left+(OldLocation.Right-OldLocation.Left);
    end;
  if emplacement.Right>(Proprietaire.Bitmap.Width-1) then
    begin
      emplacement.Right:=Proprietaire.Bitmap.Width-1;
      emplacement.Left:=emplacement.Right-(OldLocation.Right-OldLocation.Left);
    end;
  if emplacement.Top<0 then
    begin
      emplacement.Top:=0;
      emplacement.Bottom:=emplacement.Top+(OldLocation.Bottom-OldLocation.Top);
    end;
  if emplacement.Bottom>(Proprietaire.Bitmap.Height-1) then
    begin
      emplacement.Bottom:=Proprietaire.Bitmap.Height-1;
      emplacement.Top:=emplacement.Bottom-(OldLocation.Bottom-OldLocation.Top);
    end;
  NewLocation:=emplacement;
  Support.Location:=Emplacement;
  X:=Round(emplacement.Left);
  Y:=Round(emplacement.Top);
  Positionne(X,Y);
end;
Procedure TBoiteLayer.Paint(Buffer: TBitmap32);
begin
  if (Self<>Nil) and (Buffer<>Nil) then DessineSur(Buffer);
end;
Procedure TBoiteLayer.DessineSur(LeBitMap:TBitmap32);
Var
  X0,Y0,i:integer;
  X,Y:integer;
  decalY:integer;
  TexteCarac:string;
begin
  if Self=Nil then exit;
  X0:=Round(Location.Left);
  Y0:=Round(Location.Top);
  LeBitMap.Font.color:=0;
  decalY:=Proprietaire.Buffer.TextHeight('T');
  if (Hauteur<1) or (Largeur<1) then
    if Not CalculeTaille then exit;
  if SurEnCadre then
    begin
      LeBitMap.FrameRectS(X0, Y0, X0+Largeur, Y0+Hauteur, CouleurSurCadre);
      LeBitMap.FrameRectS(X0+1, Y0+1, X0+Largeur-1, Y0+Hauteur-1, CouleurSurCadre);
    end;
  if Encadre then
    begin
      LeBitMap.FrameRectS(X0+2, Y0+2, X0+Largeur-2, Y0+Hauteur-2, CouleurCadre);
      if HauteurGroupe<>0 then
        begin
          LeBitMap.FrameRectS(X0+2, Y0+2, X0+Largeur-2, Y0+HauteurGroupe, CouleurCadre);
          LeBitMap. FillRect(X0+3, Y0+3, X0+Largeur-3, Y0+HauteurGroupe-1,CouleurBandeau);
        end;
      LeBitMap.FrameRectS(X0+2, Y0+2+HauteurGroupe, X0+Largeur-2, Y0+HauteurBandeau+HauteurGroupe, CouleurCadre);
      LeBitMap. FillRect(X0+3, Y0+3+HauteurGroupe, X0+Largeur-3, Y0+HauteurBandeau+HauteurGroupe-1,CouleurBandeau);
    end;
  //X:=X0+3+(MargeTexte div 2);
  Y:=Y0+2+(MargeTexte div 2);
  LeBitMap.Font.Style:=[fsbold];
  if NomGroupe<>'' then
    begin
      X:=X0+((Largeur-LeBitMap.TextWidth(NomGroupe)) div 2);
      LeBitMap.TextOut(X,Y,NomGroupe);
    end;
  LeBitMap.Font.Style:=[];
  Y:=Y0+2+(MargeTexte div 2)+HauteurGroupe;
  For i:=0 to Caracteres.Count-1 do
    begin
      //centrer
      TexteCarac:=Caracteres[i];
      if Proprietaire.AffichEtat then TexteCarac:=TexteCarac+' = '+Etats[i];
      X:=X0+((Largeur-LeBitMap.TextWidth(TexteCarac)) div 2);
      LeBitMap.TextOut(X,Y,TexteCarac);
      Y:=Y+MargeTexte+decalY;
    end;
  X:=X0+3+(MargeTexte div 2);
  Y:=Y0+3+(MargeTexte div 2)+HauteurBandeau+HauteurGroupe;
  For i:=0 to EtiqTaxons.Count-1 do
    begin
      LeBitMap.TextOut(X,Y,EtiqTaxons[i]);
      Y:=Y+MargeTexte+decalY;
    end;
end;
Function TBoiteLayer.CalculeTaille:Boolean;
Var
  i,NbCaracteres:integer;
  LargeurBandeau:integer;
  HauteurTexte:integer;
  HauteurInclus:integer;
  cadre:TFloatRect;
  Fonte:TFont;
  StructureAInclus:string;
  StructureBInclus:string;
  StructureBVInclus:string;
  StructureBCompInclus:string;
  StringListB:TStringList;
  TexteCarac:string;
begin
  if Self=nil then
    begin
      result:=False;
      exit;
    end;
  try
    Result:=True;
    Largeur:=0;
    Hauteur:=0;
    HauteurInclus:=0;
    if (proprietaire=Nil) or
         (Proprietaire.Buffer=Nil) or
           (Proprietaire.Buffer.Font=Nil) then
      Fonte:=TFont.create
    else Fonte:=Proprietaire.Buffer.Font;
    StructureAInclus:='';
    StructureBInclus:='';
    StructureBVInclus:='';
    StructureBCompInclus:='';
    StructureA:='}:1,';
    For i:=0 to Length(Inclus)-1 do
      begin
        if (Inclus[i].Largeur<1) or (Inclus[i].Hauteur<1) then
          begin
            Result:=False;
            Exit;
          end;
        Largeur:=Largeur+Inclus[i].Largeur+Proprietaire.MargeBoitesH;
        if HauteurInclus<Inclus[i].Hauteur then
          HauteurInclus:=Inclus[i].Hauteur;
        StructureAInclus:=Inclus[i].StructureA+StructureAInclus;
        StructureBInclus:=Inclus[i].StructureB+StructureBInclus;
        StructureBVInclus:=Inclus[i].StructureBV+StructureBVInclus;
        StructureBCompInclus:=Inclus[i].StructureBComp+StructureBCompInclus;
      end;
    Hauteur:=HauteurInclus;
    Largeur:=Largeur+6+MargeTexte*2;
    LargeurTexte:=0;
    For i:=EtiqTaxons.Count-1 downto 0 do
      begin
        if LargeurTexte<Proprietaire.Buffer.TextWidth(EtiqTaxons[i]) then
          LargeurTexte:=Proprietaire.Buffer.TextWidth(EtiqTaxons[i]);
        StructureA:=','+EtiqTaxons[i]+':0'+StructureA;
      end;
    ListeTaxonsExe.Clear;
    HauteurTaxonsExe:=0;
    For i:=0 to Length(TaxonsExe)-1 do
      begin
        TaxonsExe[i].CalculeTaille;
        ListeTaxonsExe.Add(TaxonsExe[i].EtiqTaxon);
        HauteurTaxonsExe:=HauteurTaxonsExe+TaxonsExe[i].Hauteur;
        if LargeurTexte<6+MargeTexte*2+TaxonsExe[i].Largeur then
          LargeurTexte:=6+MargeTexte*2+TaxonsExe[i].Largeur;
        StructureA:=','+TaxonsExe[i].EtiqTaxon+':0'+StructureA;
      end;
    if (EtiqTaxons.Count>0) or (Length(TaxonsExe)>0) then Delete(StructureA,1,1);
    Largeur:=Largeur+LargeurTexte;
    Proprietaire.Buffer.Font.Style:=[fsbold];
    Proprietaire.Buffer.Font.Name:='Arial';
    if NomGroupe='' then LargeurBandeau:=0
    else LargeurBandeau:=Proprietaire.Buffer.TextWidth(NomGroupe);
    Proprietaire.Buffer.Font:=Fonte;
    NbCaracteres:=Caracteres.Count;
    For i:=0 to NbCaracteres-1 do
      begin
        TexteCarac:=Caracteres[i];
        if Proprietaire.AffichEtat then TexteCarac:=TexteCarac+' = '+Etats[i];
        if LargeurBandeau<Proprietaire.Buffer.TextWidth(TexteCarac) then
          LargeurBandeau:=Proprietaire.Buffer.TextWidth(TexteCarac);
      end;
    LargeurBandeau:=LargeurBandeau+6+MargeTexte*2;
    if Largeur<LargeurBandeau
      then Largeur:=LargeurBandeau;
    HauteurBandeau:=NbCaracteres*(Proprietaire.Buffer.TextHeight('T')+MargeTexte)+MargeTexte;
    if NomGroupe<>'' then HauteurGroupe:=Proprietaire.Buffer.TextHeight('T')+2*MargeTexte
    else HauteurGroupe:=0;
    HauteurTexte:=EtiqTaxons.Count*(Proprietaire.Buffer.TextHeight('T')+MargeTexte);
    HauteurTaxons:=HauteurTexte;
    HauteurTexte:=HauteurTexte+HauteurTaxonsExe;
    if Hauteur<HauteurTexte then
      Hauteur:=HauteurTexte;
    Hauteur:=HauteurBandeau+HauteurGroupe+Hauteur+6+MargeTexte*2;
    cadre:=Support.Location;
    Cadre.Bottom:=Cadre.Top+Hauteur;
    Cadre.Right:=Cadre.Left+Largeur;
    LargeurTexte:=LargeurTexte+3+2*MargeTexte;
    Support.Location:=Cadre;
    StructureA:='('+StructureAInclus+StructureA;
    StructureA:='('+StructureAInclus+StructureA;

    //ajouter les noms de caractres et les tats
    StringListB:=TStringList.Create;
    StringListB.Add(Nom);
    StringListB.Add(NomGroupe);
    StringListB.Add(ListeTaxonsExe.CommaText);
    StringListB.Add(EtiqTaxons.CommaText);
    StringListB.Add(ListeComplete.CommaText);
    StringListB.Add(Caracteres.CommaText);
    StringListB.Add(Etats.CommaText);
    StringListB.Add(ListeEtiqComplete.CommaText);
    StructureB:='<'+StringListB.CommaText+StructureBInclus+'>';
    if trim(StringListB[2])<>'' then
       if StringListB[3]<>'' then
         StringListB[3]:=StringListB[3]+','+trim(StringListB[2])
       else
         StringListB[3]:=trim(StringListB[2]);
    if (StringListB[3]='')and(Length(Inclus)=0) then
      begin
        if NomGroupe<>'' then
          StringListB[3]:=NomGroupe
        else
          StringListB[3]:='"'+M_Groupenonnomm+'"';
      end;
    StructureBComp:='<'+StringListB.CommaText+StructureBCompInclus+'>';
    StringListB[2]:='';
    StringListB[3]:='';
    StringListB[4]:='';
    StringListB[7]:='';
    StructureBV:='<'+StringListB.CommaText+StructureBVInclus+'>';
    StringListB.Clear;
    if Parent<>Nil then Parent.CalculeTaille;
  except
    Result:=False;
  end;
end;
procedure TBoiteLayer.RetireDInclus(LaBoite:TBoiteLayer;Vider:Boolean);
Var
  n,i,p,nbi,j,q:integer;
  LesInclus:Array of TBoiteLayer;
  LesTaxonsInclus:Array of TTaxonLayer;
Begin
  n:=Length(Inclus)-1;
  p:=-1;
  For i:=0 to n do
    if Inclus[i]=LaBoite then
      begin
        p:=i;
        if Vider then
          begin
            nbi:=Length(LaBoite.Inclus);
            if nbi>0 then
              begin
                SetLength(LesInclus,nbi);
                for j:=0 to nbi-1 do
                  LesInclus[j]:=LaBoite.Inclus[j];
              end;
            nbi:=Length(LaBoite.TaxonsExe);
            if nbi>0 then
              begin
                SetLength(LesTaxonsInclus,nbi);
                for j:=0 to nbi-1 do
                  LesTaxonsInclus[j]:=LaBoite.TaxonsExe[j];
              end;
          end
        else
          begin
            SetLength(LesInclus,0);
            SetLength(LesTaxonsInclus,0);
          end;
        break;
      end;
  if p>=0 then
    begin
      for i:=p to n-1 do
        Inclus[i]:=Inclus[i+1];
      Inclus[n]:=Nil;
      nbi:=Length(LesInclus);
      SetLength(Inclus,n+nbi);
      if Vider then
        begin
          EtiqTaxons.Clear;
          EtiqTaxons.AddStrings(ListeEtiqComplete);
          for i:=n to n+nbi-1 do
            begin
              Inclus[i]:=LesInclus[i-n];
              Inclus[i].Parent:=Self;
{              for j:=0 to Inclus[i].ListeEtiqComplete.Count-1 do
                begin
                  q:=EtiqTaxons.IndexOf(Inclus[i].ListeEtiqComplete[j]);
                  if q>-1 then EtiqTaxons.Delete(q);
                end;}
            end;
      //Ajuster la liste des Taxons
          for i:=0 to Length(Inclus)-1 do
            for j:=0 to Inclus[i].ListeEtiqComplete.Count-1 do
              begin
                q:=EtiqTaxons.IndexOf(Inclus[i].ListeEtiqComplete[j]);
                if q>-1 then EtiqTaxons.Delete(q);
              end;
          n:=Length(TaxonsExe);
          nbi:=Length(LesTaxonsInclus);
          SetLength(TaxonsExe,n+nbi);
          for i:=n to n+nbi-1 do
            begin
              TaxonsExe[i]:=LesTaxonsInclus[i-n];
              TaxonsExe[i].Parent:=Self;
            end;
        end;
    end;
end;
Procedure TBoiteLayer.AjouteTaxonExe(NomTaxon:string);
begin
  ListeTaxonsExe.Add(NomTaxon);
  if Parent<>Nil then Parent.AjouteTaxonExe(NomTaxon);
end;
procedure TBoiteLayer.AjouteInclus(LaBoite:TBoiteLayer);
Var
  n:integer;
Begin
  n:=Length(Inclus);
  SetLength(Inclus,n+1);
  Inclus[n]:=LaBoite;
end;
function TBoiteLayer.EstIncluDans(LaBoite:TBoiteLayer):Boolean;   //inclus sans tre gal
Var
  i,n:integer;
  AutreListe:TStringList;
begin
  Result:=True;
  AutreListe:=LaBoite.ListeComplete;
  if ListeComplete.Count>=AutreListe.Count then
    Begin
      Result:=False;
      Exit;
    end;
  For i:=0 to Listecomplete.Count-1 do
    begin
      n:=AutreListe.IndexOf(ListeComplete[i]);
      if n<0 then
        begin
          Result:=False;
          Exit;
        end;
    end;
  AutreListe:=LaBoite.ListeTaxonsExe;
  if (ListeTaxonsExe.Count>0) or (AutreListe.Count>0) then
    begin
      For i:=0 to ListeTaxonsExe.Count-1 do
        begin
          n:=AutreListe.IndexOf(ListeTaxonsExe[i]);
          if n<0 then
            begin
              Result:=False;
              Exit;
            end;
        end;
    end;
end;
function TBoiteLayer.ManqueInclusCorr(Var BoiteInc,BoiteCont:TBoiteLayer):Boolean;
Var
  i,j,n:integer;
  Boite1:TBoiteLayer;
  Boite2:TBoiteLayer;
begin
  n:=Length(inclus);
  Result:=False;
  For i:=0 to n-1 do
    begin
      for j:=0 to n-1 do
        begin
          if (i<>j) and Inclus[i].EstIncluDans(Inclus[j]) then
            begin
              BoiteInc:=Inclus[i];
              BoiteCont:=Inclus[j];
              //MessageDlg(Inclus[i].Nom+' est inclu dans '+ Inclus[j].Nom,mtWarning,[mbOK],0);
              Result:=True;
              Exit;
            end;
        end;
    end;
  For i:=0 to n-1 do
    begin
      if Inclus[i].ManqueInclusCorr(Boite1,Boite2) then
        begin
          BoiteInc:=Boite1;
          BoiteCont:=Boite2;
          Result:=True;
          break;
        end;
    end;
end;

function TBoiteLayer.ManqueInclus:Boolean;
Var
  i,j,n:integer;
begin
  n:=Length(inclus);
  Result:=False;
  For i:=0 to n-1 do
    begin
      for j:=0 to n-1 do
        begin
          if (i<>j) and Inclus[i].EstIncluDans(Inclus[j]) then
            begin
              //MessageDlg(Inclus[i].Nom+' est inclu dans '+ Inclus[j].Nom,mtWarning,[mbOK],0);
              Result:=True;
              Exit;
            end;
        end;
    end;
  For i:=0 to n-1 do
    begin
      if Inclus[i].ManqueInclus then
        begin
          Result:=True;
          break;
        end;
    end;
end;
//******** TGrapheBoite *****************
Constructor TGrapheBoite.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  Parent:=TWinControl(AOwner);
  FAffichEtat:=False;
  SetLength(Boites,0);
  MargeBoitesH:=8;
  MargeBoitesV:=4;
  BitMap.Width:=ClientWidth;
  BitMap.Height:=ClientHeight;
  BitMap.Clear($FFFFFFFF);
  Fossiles:=TStringList.Create;
  Attente:=False;
  Fige:=False;
end;
Destructor TGrapheBoite.Destroy;
begin
  Layers.Clear;
  inherited Destroy;
end;
Procedure TGrapheBoite.CalculeTailles;
Var
  i:integer;
  LaBoite:TBoiteLayer;
  LeTaxon:TTaxonLayer;
begin
  For i:=0 to Length(Boites)-1 do
    begin
      LaBoite:=Boites[i];
      if LaBoite<>Nil then
        begin
          LaBoite.Hauteur:=0;
          LaBoite.Largeur:=0;
        end;
    end;
  For i:=0 to Length(Taxons)-1 do
    begin
      LeTaxon:=Taxons[i];
      if LeTaxon<>Nil then
        begin
          LeTaxon.Hauteur:=0;
          LeTaxon.Largeur:=0;
        end;
    end;
  For i:=0 to Length(Taxons)-1 do
    begin
      LeTaxon:=Taxons[i];
      if LeTaxon<>Nil then
        LeTaxon.CalculeTaille;
    end;
  For i:=0 to Length(Boites)-1 do
    begin
      LaBoite:=Boites[i];
      if Laboite<>Nil then
        if Length(LaBoite.Inclus)=0 then
          begin
            LaBoite.CalculeTaille;
          end;
    end;
end;
Procedure TGrapheBoite.AjusteTaille;
Var
  i:integer;
  Largeur,hauteur:integer;
  LaBoite:TBoiteLayer;
  LeTaxon:TTaxonLayer;
begin
  CalculeTailles;
  Largeur:=0;
  hauteur:=0;
  For i:=0 to Length(Boites)-1 do
    begin
      LaBoite:=Boites[i];
      if LaBoite<>Nil then
        begin
          if LaBoite.Parent=Nil then
            begin
              Largeur:=Largeur+LaBoite.Largeur+MargeboitesH;
              if LaBoite.Hauteur>Hauteur then Hauteur:=LaBoite.Hauteur;
            end;
        end;
    end;
  For i:=0 to Length(Taxons)-1 do
    begin
      LeTaxon:=Taxons[i];
      if (LeTaxon<>Nil)and (LeTaxon.Parent=Nil) then
        begin
          Largeur:=Largeur+LeTaxon.Largeur+MargeboitesH;
        end;
    end;
  Hauteur:=Hauteur+MargeboitesV;
  if Largeur>ClientWidth then
    begin
      Bitmap.Width:=Largeur;
      ClientWidth:=Largeur;
    end
  else Bitmap.Width:=ClientWidth;
  if Hauteur>ClientHeight then
    begin
      Bitmap.Height:=Hauteur;
      ClientHeight:=Hauteur;
    end
  else BitMap.Height:=ClientHeight;
  BitMap.Clear($FFFFFFFF);
  RePaint;
end;
Procedure TGrapheBoite.DessineSur(LebitMap:TBitmap32);
begin
end;
Function TGrapheBoite.CreeTaxon(Nom,EtiqTaxon:string;LesCaracteres:TStringList;LesEtats:TStringList;Couleur:TColor32):integer;
Var
  LeTaxon:TTaxonLayer;
begin
  LeTaxon:=TTaxonLayer.CreateBoite(Self);
  LeTaxon.Nom:=Nom;
  LeTaxon.EtiqTaxon:=EtiqTaxon;
  LeTaxon.Caracteres.AddStrings(LesCaracteres);
  LeTaxon.Etats.AddStrings(LesEtats);
  LeTaxon.CouleurTexte:=Couleur;
  Result:=AjouteTaxon(LeTaxon);
end;
procedure TGrapheBoite.SepareBoites(Car1:string;ListeCar2:TStringList;NouvCouleur:TColor32);
Var
  n,i,p:integer;
  ListeEtat2:TStringList;
begin
  n:=ExisteBoite(Car1);
  if n>=0 then
    begin
      ListeEtat2:=TStringList.Create;
      i:=0;
      While i<ListeCar2.Count-1 do
        begin
          p:=Boites[n].Caracteres.IndexOf(ListeCar2[i]);
          if p>-1 then
            begin
              ListeEtat2.Add(Boites[n].Etats[p]);
              inc(i);
            end
          else ListeCar2.Delete(i);
        end;
{      For i:=0 to ListeCar2.Count-1 do
        begin
          p:=Boites[n].Caracteres.IndexOf(ListeCar2[i]);
          if p>-1 then ListeEtat2.Add(Boites[n].Etats[p])
          else ListeEtat2.Add('');
        end;
}
      i:=0;
      While i<Boites[n].Caracteres.Count do
        begin
          if ListeCar2.IndexOf(Boites[n].Caracteres[i])>-1 then
            begin
              Boites[n].Caracteres.Delete(i);
              Boites[n].Etats.Delete(i);
            end
          else inc(i);
        end;
      Boites[n].NomGroupe:='';
      CreeBoite(Boites[n].ListeComplete,ListeCar2,ListeEtat2,Boites[n].ListeEtiqComplete,NouvCouleur);
      ListeEtat2.Free;
    end;
end;
Function TGrapheBoite.CreeBoite(LesTaxons,LesCaracteres,LesEtats,LesNomsAffich:TStringList;Couleur:TColor32):integer;
Var
  LaBoite:TBoiteLayer;
begin
  LaBoite:=TBoiteLayer.CreateBoite(Self);
  LaBoite.ListeComplete.AddStrings(LesTaxons);
  LaBoite.Caracteres.AddStrings(LesCaracteres);
  LaBoite.Etats.AddStrings(LesEtats);
  LaBoite.EtiqTaxons.AddStrings(LesNomsAffich);
  LaBoite.ListeEtiqComplete.AddStrings(LesNomsAffich);
  if LaBoite.Caracteres.Count>0 then
    LaBoite.Nom:=LaBoite.Caracteres[0];
  LaBoite.Encadre:=True;
  LaBoite.CouleurBandeau:=Couleur;
  Result:=AjouteBoite(LaBoite);
end;
Procedure TGrapheBoite.RaZBoites;
Begin
  Layers.Clear;
  SetLength(Boites,0);
  SetLength(Taxons,0);
end;
Function TGrapheBoite.BoiteAPosition(LayerOrg:TPositionedLayer;X,Y:integer):TboiteLayer;
Var
  Point:Tpoint;
  Valeur:integer;
  UneBoite,BoiteOrg:TBoiteLayer;
  i:integer;
  position:TRect;
Begin
  Result:=Nil;
  Point.X:=X;
  Point.Y:=Y;
  Valeur:=BitMap.Width;
  BoiteOrg:=Nil;
  if (LayerOrg is TBoiteLayer) then BoiteOrg:=(LayerOrg as TBoiteLayer);
  For i:=0 to Length(Boites)-1 do
    begin
      UneBoite:=Boites[i];
      if (BoiteOrg<>Nil) and (UneBoite=BoiteOrg) then Continue
      else
        begin
          position:=MakeRect(UneBoite.Location);
          if PtInRect(position,Point) then
            begin
              if UneBoite.Largeur<Valeur then
                begin
                  {if Not UneBoite.EstIncluDans(BoiteOrg) then
                    begin }
                      Result:=UneBoite;
                      Valeur:=UneBoite.Largeur;
                    //end;
                end
            end;
        end;
    end;
end;
Function TGrapheBoite.FusionneBNum(NOrg,NCible:integer):Boolean;
Var
  n:integer;
  BoiteOrg,BoiteCible:TboiteLayer;
begin
  Result:=False;
  n:=Length(Boites);
  if (NOrg>-1) and (NOrg<n) and (NCible>-1) and (NCible<n) then
    begin
      BoiteOrg:=Boites[NOrg];
      BoiteCible:=Boites[NCible];
      Result:=Fusionne(BoiteOrg,BoiteCible);
    end;
end;
Function TGrapheBoite.Fusionne(BoiteOrg,BoiteCible:TBoiteLayer):Boolean;
Var
  i:integer;
  NbTEbO:integer;
  NomTaxon:string;
begin
  Result:=False;
  if (BoiteOrg<>Nil) and (BoiteCible<>Nil) then
    begin
      //vrification de l'identit des tiquettes de taxons d'exercice
      if (BoiteOrg.ListeTaxonsExe.Count>0) or (BoiteCible.ListeTaxonsExe.Count>0) then
        begin
          For i:=0 to BoiteOrg.ListeTaxonsExe.Count-1 do
            begin
              NomTaxon:=BoiteOrg.ListeTaxonsExe[i];
              if BoiteCible.ListeTaxonsExe.IndexOf(NomTaxon)<0 then
                exit;
            end;
          For i:=0 to BoiteCible.ListeTaxonsExe.Count-1 do
            begin
              NomTaxon:=BoiteCible.ListeTaxonsExe[i];
              if BoiteOrg.ListeTaxonsExe.IndexOf(NomTaxon)<0 then
                  exit;
            end;
        end;
      For i:=0 to BoiteOrg.ListeComplete.Count-1 do
        begin
          if BoiteCible.Listecomplete.IndexOf(BoiteOrg.ListeComplete[i])<0 then
            begin
              exit;
            end;
        end;
      For i:=0 to BoiteCible.ListeComplete.Count-1 do
        begin
          if BoiteOrg.ListeComplete.IndexOf(BoiteCible.ListeComplete[i])<0 then
            begin
              exit;
            end;
        end;
      Attente:=True;
      For i:=0 to BoiteOrg.Caracteres.Count-1 do
        BoiteCible.Caracteres.Add(BoiteOrg.Caracteres[i]);
      For i:=0 to BoiteOrg.Etats.Count-1 do
        BoiteCible.Etats.Add(BoiteOrg.Etats[i]);
      if (BoiteCible.NomGroupe='') and (BoiteOrg.NomGroupe<>'') then
        BoiteCible.NomGroupe:=BoiteOrg.NomGroupe;

      NbTEbO:=Length(BoiteOrg.TaxonsExe);
      for i:=0 to NbTEbO-1 do
        begin
          RetireTaxon(BoiteOrg.TaxonsExe[i]);
        end;
      SetLength(BoiteOrg.TaxonsExe,0);
      For i:=0 to Length(BoiteOrg.Inclus)-1 do
        begin
          BoiteCible.AjouteInclus(BoiteOrg.Inclus[i]);
          BoiteOrg.Inclus[i].Parent:=BoiteCible;
          BoiteOrg.Inclus[i]:=Nil;
          //BoiteOrg.RetireDInclus(LaBoite:TBoiteLayer;Vider:Boolean);
        end;
      SetLength(BoiteOrg.Inclus,0);
      RetireBoite(NumBoite(BoiteOrg));
      //PositionneBoites;
      Result:=True;
    end;
end;
Function TGrapheBoite.NumBoite(LaBoite:TBoiteLayer):integer;
Var
  i:integer;
begin
  Result:=-1;
  For i:=0 to Length(Boites)-1 do
    if Boites[i]=LaBoite then
      begin
        Result:=i;
        Break;
      end;
end;
Function TGrapheBoite.NumeroBoiteSuiv(X:integer):integer;
Var
  i:integer;
Begin
  Result:=Length(Boites)-1;
  For i:=0 to Length(Boites)-1 do
    if X<Boites[i].Location.Left then
      begin
        Result:=i;
        Break;
      end;
end;
Function TGrapheBoite.DeplaceTaxonVers(LeTaxonClique:TTaxonLayer;X,Y:integer;Var CouleurFeu:Tcolor):Boolean;
Var
  BoiteCible,LaBoite:TBoiteLayer;
  i,n,p,j:integer;
  Trouve:Boolean;
begin
  Result:=False;
  CouleurFeu:=$00C0FF;
  BoiteCible:=BoiteAPosition(LeTaxonClique,X,Y);
  if (BoiteCible<>Nil) and (LeTaxonClique<>Nil) then
    begin
      if LeTaxonClique.Caracteres.IndexOf(BoiteCible.Caracteres[0])=-1 then
        begin
//          MessageDlg('L''espce n''appartient pas  cette bote',mtError,[mbOK],0);
          MessageDlg(M_Lespcenappartientp,mtError,[mbOK],0);
          CouleurFeu:=clRed;
          RaZSurEncadre;
          PositionneBoites;
          exit;
        end
      else if Length(BoiteCible.Inclus)>0 then
        begin
          For i:=0 to Length(BoiteCible.Inclus)-1 do
            begin
              if LeTaxonClique.Caracteres.IndexOf(BoiteCible.Inclus[i].Caracteres[0])>-1 then
                begin
//                  MessageDlg('L''espce appartient aussi  une plus petite bote',mtError,[mbOK],0);
                  MessageDlg(M_Lespceappartientau,mtError,[mbOK],0);
                  RaZSurEncadre;
                  PositionneBoites;
                  exit;
                end;
            end;
        end;
       //vrifier qu'il est bien dans toutes les botes qui incluent la bote cible
      LaBoite:=BoiteCible.Parent;
      While LaBoite<>Nil do
        begin
          if LeTaxonClique.Caracteres.IndexOf(LaBoite.Caracteres[0])=-1 then
            begin
              CouleurFeu:=clRed;
//              MessageDlg('Il y a un problme avec les caractres de cette espce. Vrifier',mtError,[mbOK],0);
              MessageDlg(M_Ilyaunproblmeavecl,mtError,[mbOK],0);
              RaZSurEncadre;
              PositionneBoites;
              exit;
            end;
          LaBoite:=LaBoite.Parent;
        end;
      // vrifier qu'il n'est pas dans une autre bote incluse dans la bote cible
      For i:=0 to Length(Boites)-1 do
        begin
          LaBoite:=Boites[i];
          if LaBoite<>Nil then
            begin
              if (LaBoite<>BoiteCible)and(LeTaxonClique.Caracteres.IndexOf(LaBoite.Caracteres[0])>-1) then
                begin
                  if LaBoite.EstIncluDans(BoiteCible) then
                    begin
                      CouleurFeu:=clRed;
//                      MessageDlg('Il y a un problme avec les caractres de cette espce. Vrifier',mtError,[mbOK],0);
                      MessageDlg(M_Ilyaunproblmeavecl,mtError,[mbOK],0);
                      RaZSurEncadre;
                      PositionneBoites;
                      exit;
                    end;
                end;
            end;
        end;
//      MessageDlg('Bravo !',mtInformation,[mbOK],0);
      CouleurFeu:=clLime;
      Result:=True;
      n:=Length(BoiteCible.TaxonsExe);
      SetLength(BoiteCible.TaxonsExe,n+1);
      BoiteCible.TaxonsExe[n]:=LeTaxonClique;
      LeTaxonClique.Parent:=BoiteCible;
      //BoiteCible.AjouteTaxonExe(LeTaxonClique.Nom);  liste construite a priori
      //Rechercher d'autres inclusions dans des boites libres ou d'un autre emboitement
      // et alors cloner le TaxonExe
      For i:=0 to LeTaxonClique.Caracteres.Count-1 do
        begin
          p:=ExisteBoiteAvecExcl(LeTaxonClique.Caracteres[i],BoiteCible);
          if p>=0 then
            begin
              if (Boites[p]<>Nil) and (Boites[p]<>BoiteCible) then
                begin
                  n:=Length(Boites[p].Inclus);
                  if (n>0) then
                    begin
                      Trouve:=False;
                      For j:=0 to n-1 do
                        begin
                          LaBoite:=Boites[p].Inclus[j];
                          if LeTaxonClique.EstIncluDans(LaBoite) then
                            Trouve:=True;
                        end;
                      if Not Trouve then    //vrifier aussi qu'il n'y a pas dj un clone du taxon dans la boite
                        begin
                          if (Length(Boites[p].TaxonsExe)>0) then
                            begin
                              for j:=0 to Length(Boites[p].TaxonsExe)-1 do
                                begin
                                  if Boites[p].TaxonsExe[j].Nom=LeTaxonClique.Nom then
                                    begin
                                      Trouve:=True;
                                      Break;
                                    end;
                                end;
                            end;
                        end;
                      if Not Trouve then
                        begin
                          CreeTaxon(LeTaxonClique.Nom,LeTaxonClique.EtiqTaxon,LeTaxonClique.Caracteres,LeTaxonClique.Etats,LeTaxonClique.CouleurTexte);
                          CouleurFeu:=$00C0FF;
                          RaZSurEncadre;
                          PositionneBoites;
                          Exit;
                        end;
                    end
                  else
                    begin
                      Trouve:=False;
                      if (Length(Boites[p].TaxonsExe)>0) then
                        begin
                          for j:=0 to Length(Boites[p].TaxonsExe)-1 do
                            begin
                              if Boites[p].TaxonsExe[j].Nom=LeTaxonClique.Nom then
                                begin
                                  Trouve:=True;
                                  Break;
                                end;
                            end;
                        end;
                      if Not Trouve then
                        begin
                          CreeTaxon(LeTaxonClique.Nom,LeTaxonClique.EtiqTaxon,LeTaxonClique.Caracteres,LeTaxonClique.Etats,LeTaxonClique.CouleurTexte);
                          CouleurFeu:=$00C0FF;
                          RaZSurEncadre;
                          PositionneBoites;
                          Exit;
                        end;
                    end;
                end;
            end;
        end;
      RaZSurEncadre;
      PositionneBoites;
    end;
end;
function TGrapheBoite.ExisteTaxonsLibres:Boolean;
Var
  i:integer;
begin
  Result:=False;
  For i:=0 to Length(Taxons)-1 do
    if (Taxons[i]<>Nil) and (Taxons[i].Parent=Nil) then
      begin
        Result:=True;
        exit;
      end;
end;
Procedure TGrapheBoite.DeplaceVers(BoiteOrg:TboiteLayer;X,Y:integer;var NumO,NumC:integer;Var NomCarC:string;Var Fusion,ChangeCol:Boolean);
Var
  BoiteCible:TBoiteLayer;
begin
  Fusion:=False;
  ChangeCol:=False;
  if Attente then exit;
  NomCarC:='';
  if ExisteTaxonsLibres then
    begin
//      MessageDlg('Finir de classer les tiquettes des espces'+#10+#13+'avant de dplacer les botes',mtWarning,[mbOK],0);
      MessageDlg(M_Finirdeclasserlest+#10+#13+M_avantdedplacerlesb,mtWarning,[mbOK],0);
      PositionneBoites;
      exit;
    end;
  BoiteCible:=BoiteAPosition(BoiteOrg,X,Y);
  if (BoiteCible=Nil) and (BoiteOrg.Parent=Nil) then
    begin
      NumC:=NumeroBoiteSuiv(X);
      NumO:= NumBoite(BoiteOrg);
      if NumO>=0 then
        ChangeCol:=True;
      if NumC=NumO then PositionneBoites;
    end
  else
    begin
      if BoiteCible<>Nil then NomCarC:=Boitecible.Caracteres[0];
      Fusion:=InclutDans(BoiteOrg,BoiteCible,NumO,NumC);
    end;
end;
Function TGrapheBoite.InclutDans(BoiteOrg,BoiteCible:TboiteLayer;var NumO,NumC:integer):Boolean;
Var
  i,j,k,n:integer;
  LeParentInitial:TBoiteLayer;
  LeTaxonExe:TTaxonLayer;
begin
  Result:=False;
  if (BoiteCible<>Nil) then        
    begin
      if ((Length(BoiteOrg.TaxonsExe)=0) or (Length(BoiteCible.TaxonsExe)=0)) and
        ((BoiteOrg.ListeComplete.Count=0) or (BoiteCible.ListeComplete.Count=0)) then
        begin
//          MessageDlg('Il y a au moins une bote vide, elle ne peut tre classe',mtError,[mbOK],0);
          MessageDlg(M_Ilyaaumoinsunebote,mtError,[mbOK],0);
          RaZSurEncadre;
          PositionneBoites;
          exit;
        end;
      NumO:=NumBoite(BoiteOrg);
      NumC:=NumBoite(BoiteCible);
      Result:=Fusionne(BoiteOrg,BoiteCible);
      If Result then exit;
      LeParentInitial:=BoiteOrg.Parent;
      if LeParentInitial<>BoiteCible then
        begin
          For i:=0 to BoiteOrg.ListeComplete.Count-1 do
            begin
              if BoiteCible.ListeComplete.IndexOf(BoiteOrg.ListeComplete[i])<0 then
                begin
//                  MessageDlg('La bote dplace n''est pas contenue dans la boite d''accueil',mtError,[mbOK],0);
                  MessageDlg(M_Labotedplacenestpa,mtError,[mbOK],0);
                  RaZSurEncadre;
                  PositionneBoites;
                  exit;
                end;
            end;
          //verifier aussi avec les taxons d'exercice
          For i:=0 to BoiteOrg.ListeTaxonsExe.Count-1 do
            begin
              j:=BoiteCible.ListeTaxonsExe.IndexOf(BoiteOrg.ListeTaxonsExe[i]);
              if j<0 then
                begin
//                  MessageDlg('La bote d''accueil ne contient pas toutes les espces de la bote dplace',mtError,[mbOK],0);
                  MessageDlg(M_Labotedaccueilneco,mtError,[mbOK],0);
                  RaZSurEncadre;
                  PositionneBoites;
                  exit;
                end;
            end;
          if LeParentInitial<>Nil then
            begin
              LeParentInitial.RetireDInclus(BoiteOrg,false);
            end;
          BoiteCible.AjouteInclus(BoiteOrg);
          BoiteOrg.Parent:=BoiteCible;
          //Supprimer les TaxonsExe Inclus Communs de la boite Cible  ou de ses inclus
          //For i:=0 to Length(BoiteOrg.TaxonsExe)-1 do
          For i:=0 to BoiteOrg.ListeTaxonsExe.Count-1 do
            For j:=0 to Length(BoiteCible.TaxonsExe)-1 do
              //if BoiteOrg.TaxonsExe[i].Nom=BoiteCible.TaxonsExe[j].Nom then
              if BoiteOrg.ListeTaxonsExe[i]=BoiteCible.TaxonsExe[j].Nom then
                begin
                  LeTaxonExe:=BoiteCible.TaxonsExe[j];
                  For k:=j to Length(BoiteCible.TaxonsExe)-2 do
                    BoiteCible.TaxonsExe[k]:=BoiteCible.TaxonsExe[k+1];
                  SetLength(BoiteCible.TaxonsExe,Length(BoiteCible.TaxonsExe)-1);
                  RetireTaxon(LeTaxonExe);
                  Break;
                end;
          For i:=0 to BoiteOrg.ListeEtiqComplete.Count-1 do
            begin
              n:=BoiteCible.EtiqTaxons.IndexOf(BoiteOrg.ListeEtiqComplete[i]);
              if n>-1 then
                begin
                  BoiteCible.EtiqTaxons.Delete(n);
                end;
            end;
        end;
    end;
  VerifieListesAffichees;
  RaZSurEncadre;
  PositionneBoites;
end;
Procedure TGrapheBoite.Redessine;
begin
  PositionneBoites;
end;


Procedure TGrapheBoite.PositionneBoites;
Var
  i,X,Y:integer;
  LaBoite:TBoiteLayer;
  LeTaxon:TTaxonLayer;
begin
  AjusteTaille;
  Y:=2;
  X:=MargeBoitesH;
  For i:=0 to Length(Boites)-1 do
    begin
      LaBoite:=Boites[i];
      if (LaBoite<>Nil) and (LaBoite.Parent=Nil) then
        begin
          LaBoite.Positionne(X,Y);
          X:=X+LaBoite.Largeur+MargeBoitesH;
          LaBoite.MetEnAvant;
        end;
    end;
  For i:=0 to Length(Taxons)-1 do
    begin
      LeTaxon:=Taxons[i];
      if (LeTaxon<>Nil) then
        if (LeTaxon.Parent=Nil) then
          begin
            LeTaxon.Positionne(X,Y);
            X:=X+LeTaxon.Largeur+MargeBoitesH;
            LeTaxon.MetEnAvant;
          end;
    end;
  Repaint;
end;
procedure TGrapheBoite.RaZSurEncadre;
Var
  i:integer;
begin
  For i:=0 to Length(Boites)-1 do Boites[i].SurEncadre:=false;
end;
procedure TGrapheBoite.MouseMove (Shift: TShiftState; X, Y: Integer; Layer: TCustomLayer);
Var
  LaBoite:TPositionedLayer;
  LaBoiteFond:TBoiteLayer;
  LeSupport:TRubberbandLayer;
begin
  if (PanelSupport<>Nil) and (X<PanelSupport.HorzScrollBar.Position+3) then
    begin
      if PanelSupport.HorzScrollBar.Visible and (PanelSupport.HorzScrollBar.Position > 0) then
        PanelSupport.HorzScrollBar.Position:=PanelSupport.HorzScrollBar.Position-1;
    end
  else  if (PanelSupport<>Nil) and (X>(PanelSupport.Width+PanelSupport.HorzScrollBar.Position-25)) then
    begin
      if PanelSupport.HorzScrollBar.Visible and (PanelSupport.HorzScrollBar.Position <PanelSupport.HorzScrollBar.Range) then
        PanelSupport.HorzScrollBar.Position:=PanelSupport.HorzScrollBar.Position+1;
    end;
  if (PanelSupport<>Nil) and (Y<PanelSupport.VertScrollBar.Position+3) then
    begin
      if PanelSupport.VertScrollBar.Visible and (PanelSupport.VertScrollBar.Position > 0) then
        PanelSupport.VertScrollBar.Position:=PanelSupport.VertScrollBar.Position-1;
    end
  else  if (PanelSupport<>Nil) and (Y>(PanelSupport.Height+PanelSupport.VertScrollBar.Position-25)) then
    begin
      if PanelSupport.VertScrollBar.Visible and (PanelSupport.VertScrollBar.Position <(PanelSupport.VertScrollBar.Range)) then
        PanelSupport.VertScrollBar.Position:=PanelSupport.VertScrollBar.Position+1;
    end;
  if Fige then
    begin
      inherited MouseMove(Shift, X, Y, Layer);
      exit;
    end;
  RaZSurEncadre;
  If Attente then
    exit;
  if (ssleft in Shift)and (Layer<>Nil) then
    begin
      LaBoite:=Nil;
      LeSupport:=Nil;
      if (Layer is TRubberbandLayer) then LeSupport:=(Layer as TRubberbandLayer);
      if LeSupport<>Nil then
        begin
          if (LeSupport.ChildLayer is TBoiteLayer) then
            LaBoite:=(LeSupport.ChildLayer as TPositionedLayer)
          else if (LeSupport.ChildLayer is TTaxonLayer) then
            LaBoite:=(LeSupport.ChildLayer as TPositionedLayer);
        end
      else if (Layer is TBoiteLayer) then LaBoite:=(Layer as TPositionedLayer)
      else if (Layer is TTaxonLayer) then LaBoite:=(Layer as TPositionedLayer);
      LaBoiteFond:=BoiteAPosition(LaBoite,X,Y);
      If LaBoiteFond<>Nil then
        begin
          LaBoiteFond.SurEncadre:=True;
          LaBoiteFond.CouleurSurCadre:=clblue32;
        end;
    end;
  if (ssleft in Shift) then
    inherited MouseMove(Shift, X, Y, Layer);
  Refresh;
end;
procedure TGrapheBoite.MouseDown (Button: TMouseButton; Shift: TShiftState; X, Y: Integer; Layer: TCustomLayer);
Var
  LaBoite:TBoiteLayer;
  LeSupport:TRubberbandLayer;
  LeLayer:TCustomLayer;
  LayerOrg:TPositionedLayer;
begin
  if Fige then
    begin
      inherited MouseDown(Button,Shift, X, Y, BoiteAPosition(Nil,X,Y));
      exit;
    end;
  if Attente then
    exit;
  LeLayer:=Layer;
  if (Layer is TBoiteLayer) then
    begin
      LaBoite:=(Layer as TBoiteLayer);
      if LaBoite<>Nil then
        LeLayer:=BoiteAPosition(Nil,X,Y);
    end
  else if (Layer is TRubberbandLayer) and ((Layer as TRubberbandLayer).ChildLayer is TBoiteLayer) then
    begin
      LaBoite:=BoiteAPosition(Nil,X,Y);
      If LaBoite<>Nil then
        begin
          LeSupport:=LaBoite.Support;
          LeLayer:=LeSupport;
        end;
    end;
  if LeLayer=Nil then LeLayer:= Layer
  else LeLayer.BringToFront;
  inherited MouseDown(Button,Shift, X, Y, LeLayer);
end;

Procedure TGrapheBoite.ChangeOrdreBoite(PosOrg,PosFin:integer);
Var
  i,n:integer;
  LaBoite:TBoiteLayer;
begin
  Attente:=True;
  n:=Length(Boites);
  if (PosOrg<0) or (PosOrg>=n) or (PosFin<0) or (PosFin>=n) then exit;
  if PosOrg<PosFin then
    begin
      LaBoite:=Boites[PosOrg];
      For i:=PosOrg to PosFin-1 do
        Boites[i]:=Boites[i+1];
      Boites[PosFin]:=LaBoite;
    end
  else if PosOrg>PosFin then
    begin
      LaBoite:=Boites[PosOrg];
      For i:=PosOrg Downto PosFin+1 do
        Boites[i]:=Boites[i-1];
      Boites[PosFin]:=LaBoite;
    end;
  Attente:=False;
end;
Procedure TGrapheBoite.MetEnAvantBoites;
Var
  i:integer;
Begin
  Attente:=True;
  For i:=0 to Length(Boites)-1 do
    if Boites[i].Parent=Nil then Boites[i].MetEnAvant;
  Attente:=False;
end;
Function TGrapheBoite.LaBoite(NomCar,NomEtat:string):TBoiteLayer;
Var
  i,n,p:integer;
  UneBoite:TBoiteLayer;
begin
  Result:=Nil;
  n:=Length(Boites);
  For i:=0 to n-1 do
    begin
      UneBoite:=Boites[i];
      if UneBoite<>Nil then
        begin
          p:=UneBoite.Caracteres.IndexOf(NomCar);
          if (p>-1)and (UneBoite.Etats.IndexOf(NomEtat)=p) then
            begin
              Result:=UneBoite;
              exit;
            end;
        end;
    end;
end;
Function TGrapheBoite.ExisteBoiteAvecExcl(NomCar:string;BoiteExclue:TBoiteLayer):integer;
Var
  i,n:integer;
  LaBoite:TBoiteLayer;
begin
  Result:=-1;
  n:=Length(Boites);
  For i:=0 to n-1 do
    begin
      LaBoite:=Boites[i];
      if (LaBoite<>Nil)and (LaBoite<>BoiteExclue) then
        if LaBoite.Caracteres.IndexOf(NomCar)>-1 then
          begin
            Result:=i;
            Exit;
          end;
    end;
end;
Function TGrapheBoite.ExisteBoite(NomCar:string):integer;
Var
  i,n:integer;
  LaBoite:TBoiteLayer;
begin
  Result:=-1;
  n:=Length(Boites);
  For i:=0 to n-1 do
    begin
      LaBoite:=Boites[i];
      if (LaBoite<>Nil) then
        if LaBoite.Caracteres.IndexOf(NomCar)>-1 then
          begin
            Result:=i;
            Exit;
          end;
    end;
end;
Function TGrapheBoite.ExisteTaxon(NomTaxon:string):integer;
Var
  i,n:integer;
  LeTaxon:TTaxonLayer;
begin
  Result:=-1;
  n:=Length(Taxons);
  For i:=0 to n-1 do
    begin
      LeTaxon:=Taxons[i];
      if LeTaxon<>Nil then
        if LeTaxon.Nom=NomTaxon then
          begin
            Result:=i;
            Exit;
          end;
    end;
end;
function ListeIncluseDans(Liste,ListeConteneur:TStringList):Boolean;
Var
  i,j:integer;
begin
  Result:=ListeConteneur.Count>Liste.Count;
  if Result then
    For i:=0 to Liste.Count-1 do
      begin
        if ListeConteneur.IndexOf(Liste[i])=-1 then
          begin
            Result:=False;
            break;
          end;
      end;
end;
Procedure TGrapheBoite.EmboiteTout;
Var
  i,j,pr,n,comp:integer;   //k,p,num,,NumO,NumC
  //erreur:boolean;
  BoiteParente:TBoiteLayer;
  //NonInclus:Array of TBoiteLayer;
  //BoiteInc,BoiteCont:TBoiteLayer;
begin
  n:=Length(Boites);
  if n>0 then
    begin
      //Remettre les inclusions  zro
      For i:=0 to n-1 do
        begin
          Boites[i].Parent:=Nil;
          For j:=0 to Length(Boites[i].Inclus)-1 do
            Boites[i].Inclus[j]:=Nil;
          SetLength(Boites[i].Inclus,0);
        end;
      // faire les inclusions
      For i:=0 to n-1 do
        begin
          BoiteParente:=Nil;
          pr:=10000;
          For j:=0 to n-1 do
            begin
              comp:=Boites[j].Listecomplete.Count-Boites[i].Listecomplete.Count;
              if (j<>i) and (comp>0) and (comp<pr) then
                begin
                  {erreur:=Not ListeIncluseDans(Boites[i].Listecomplete,Boites[j].Listecomplete);
                  if erreur then break
                  else}
                  if ListeIncluseDans(Boites[i].Listecomplete,Boites[j].Listecomplete) then
                    begin
                      BoiteParente:=Boites[j];
                      pr:=comp;                   
                    end;
                end;
            end;
          if BoiteParente<>Nil then
            Inclure(Boites[i],BoiteParente);
        end;
{//Vrification
      p:=0;
      SetLength(NonInclus,p);
      For i:=0 to n-1 do
        if (Boites[i].parent=nil)and (Boites[i].ListeComplete.Count>0) then
          begin
            SetLength(NonInclus,p+1);
            NonInclus[p]:=Boites[i];
            inc(p);
          end;
      For i:=0 to p-1 do
        if NonInclus[i].ManqueInclusCorr(BoiteInc,BoiteCont) then
          begin
            InclutDans(BoiteInc,BoiteCont, NumO,NumC);
          end;
      SetLength(NonInclus,0);
}
      PositionneBoites;
    end;
end;
procedure TGrapheBoite.Inclure(BoiteInc,BoiteParente:TBoiteLayer);
Var
  i,p:integer;
begin
  BoiteInc.Parent:=BoiteParente;
  p:=Length(BoiteParente.Inclus);
  SetLength(BoiteParente.Inclus,p+1);
  BoiteParente.Inclus[p]:=BoiteInc;
  For i:=0 to BoiteInc.ListeComplete.Count-1 do
    begin
      p:=BoiteParente.EtiqTaxons.IndexOf(BoiteInc.ListeEtiqComplete[i]);
      if p>-1 then BoiteParente.EtiqTaxons.Delete(p);
    end;
end;
Function TGrapheBoite.ErreurInclusion:Boolean;
Var
  i,j,p,n:integer;
  NonInclus:Array of TBoiteLayer;
begin
  Result:=True;
  n:=Length(Boites);
  if n>0 then
    begin
      Result:=False;
      p:=0;
      SetLength(NonInclus,p);
      For i:=0 to n-1 do
        if (Boites[i].parent=nil)and (Boites[i].ListeComplete.Count>0) then
          begin
            SetLength(NonInclus,p+1);
            NonInclus[p]:=Boites[i];
            inc(p);
          end;
      For i:=0 to p-1 do
        begin
          for j:=0 to p-1 do
            begin
              if (i<>j) and NonInclus[i].EstIncluDans(NonInclus[j]) then
                begin
                  Result:=True;
                  SetLength(NonInclus,0);
                  Exit;
                end;
            end;
        end;
      For i:=0 to p-1 do
        if NonInclus[i].ManqueInclus then
          begin
            Result:=True;
            SetLength(NonInclus,0);
            exit;
          end;
    end;
  SetLength(NonInclus,0);
end;
Function TGrapheBoite.AjouteTaxon(LeTaxon:TTaxonLayer):integer; //renvoie le numro
Var
  n:integer;
begin
  n:=Length(Taxons);
  SetLength(Taxons,n+1);
  Result:=n;
  Taxons[n]:=LeTaxon;
  PositionneBoites;
end;

Function TGrapheBoite.AjouteBoite(LaBoite:TBoiteLayer):integer; //renvoie le numro
Var
  n:integer;
begin
  Attente:=True;
  n:=Length(Boites);
  SetLength(Boites,n+1);
  Result:=n;
  Boites[n]:=LaBoite;
  PositionneBoites;
  Attente:=False;
end;
Procedure TGrapheBoite.RetireBoite(p:integer);
Var
  i,n:integer;
  LaBoite:TBoiteLayer;
begin
  n:=Length(Boites);
  if p<n then
    begin
      LaBoite:=Boites[p];
      For i:=p to n-2 do
        Boites[i]:=Boites[i+1];
      For i:=0 to n-2 do  //Retirer LaBoite des inclusions;
        Boites[i].RetireDInclus(LaBoite,true);
      SetLength(Boites,n-1);
      if LaBoite<>Nil then
        begin
          SupprimeSupport(Laboite.Support);
          SupprimeBoite(LaBoite);
        end;
      PositionneBoites;
    end;
  Attente:=False;
end;
Procedure TGrapheBoite.SupprimeBoite(LaBoite:TBoiteLayer);
Var
  i:integer;
begin
  For i:=0 to Layers.Count-1 do
    if Layers[i]=LaBoite then
      begin
        Layers.Delete(i);
        exit;
      end;
end;

Procedure TGrapheBoite.SupprimeSupport(Layer:TRubberbandLayer);
Var
  i:integer;
begin
  For i:=0 to Layers.Count-1 do
    if Layers[i]=Layer then
      begin
        Layers.Delete(i);
        exit;
      end;
end;
procedure TGrapheBoite.SupprimeTaxon(LeTaxon:TTaxonLayer);
Var
  i:integer;
  Tax:TTaxonLayer;
begin
  if LeTaxon=Nil then  exit;
  For i:=0 to Layers.Count-1 do
    begin
    if (Layers[i] is TTaxonLayer) then
      begin
        Tax:=(Layers[i] as TTaxonLayer);
        if (Tax<>Nil)and (Tax=LeTaxon) then
          begin
            Layers.Delete(i);
            exit;
          end;
      end;
    end;
end;
procedure TGrapheBoite.RetireTaxon(TaxE:TTaxonLayer);
Var
  i,j,k,n,numE:integer;
  LaBoite:TBoiteLayer;
begin
  if TaxE=Nil then exit;
  n:=Length(Taxons);
  for i:=0 to n-1 do
    if TaxE=Taxons[i] then
      begin
        LaBoite:=TaxE.Parent;
        if LaBoite<>Nil then
          begin
            numE:=Length(LaBoite.TaxonsExe);
            For j:=0 to numE-1 do
              if LaBoite.TaxonsExe[j]=TaxE then
                begin
                  For k:=j to numE-2 do
                    LaBoite.TaxonsExe[k]:=LaBoite.TaxonsExe[k+1];
                  SetLength(LaBoite.TaxonsExe,numE-1);
                  break;
                end;
            numE:=LaBoite.ListeTaxonsExe.IndexOf(TaxE.Nom);
            if numE>-1 then
              LaBoite.ListeTaxonsExe.Delete(numE);
          end;
        For j:=i to n-2 do
          Taxons[j]:=Taxons[j+1];
        SetLength(Taxons,n-1);
        SupprimeSupport(TaxE.Support);
        SupprimeTaxon(TaxE);
        //PositionneBoites;
        break;
      end;
end;

Procedure TGrapheBoite.RetireBoiteContenant(Nomcar:string);
Var
  p:integer;
begin
  p:=ExisteBoite(NomCar);
  if p>-1 then RetireBoite(p);
end;
Procedure TGrapheBoite.RetireBoitesContenant(Nomcar:string);
Var
  i,j,n,p:integer;
  LaBoite:TBoiteLayer;
begin
  i:=0;
  While i<Length(Boites) do
    begin
      LaBoite:=Boites[i];
      if LaBoite<>Nil then
        begin
          p:=LaBoite.Caracteres.IndexOf(NomCar);
          if p>-1 then
            begin
              LaBoite.Caracteres.Delete(p);
              LaBoite.Etats.Delete(p);
              if LaBoite.Caracteres.Count=0 then
                begin
                  n:=Length(Boites);
                  For j:=i to n-2 do
                  Boites[j]:=Boites[j+1];
                  For j:=0 to n-2 do  //Retirer LaBoite des inclusions;
                    Boites[j].RetireDInclus(LaBoite,true);
                  For j:=0 to n-2 do  //Retirer LaBoite des inclusions;
                    if Boites[j].Parent=LaBoite then Boites[j].Parent:=LaBoite.Parent;
                  SetLength(Boites,n-1);
                  if LaBoite<>Nil then
                    begin
                      SupprimeSupport(Laboite.Support);
                      SupprimeBoite(LaBoite);
                    end;
                end
              else
                inc(i);
            end
          else
            inc(i);
        end;
    end;
  Redessine;
end;
{
Function TGrapheBoite.CreeEtPlaceBoites(LeCaractere:string;SesTaxons,SesEtats,SesnomsAffich:TStringList;Couleurs:Array of TColor32):Boolean;
Var
  i,j,k,n:integer;
  LesTaxons:TStringList;
  LesCaracteres:TStringList;
  LesnomsAffich:TStringList;
  LesEtats:TStringList;
  NumboitesParentes:Array of integer;
  NumBoitesIncluses:Array of TTableauDentiers;
  identiques:Array of Boolean;
  UneBoite,LaBoiteIncluse,SaBoiteParente:TBoiteLayer;
  modif:boolean;

begin
  LesCaracteres:=TStringList.Create;
  LesCaracteres.Add(LeCaractere);
  LesTaxons:=TStringList.Create;
  LesnomsAffich:=TStringList.Create;
  LesEtats:=TStringList.Create;
  SetLength(NumboitesParentes,SesEtats.Count);
  SetLength(NumBoitesIncluses,SesEtats.Count);
  SetLength(identiques,SesEtats.Count);
  Result:=True;
  For i:=0 to SesEtats.Count-1 do
    begin
      LesEtats.Clear;
      LesEtats.Add(SesEtats[i]);
      LesTaxons.Clear;
      LesTaxons.CommaText:=SesTaxons[i];
      LesNomsAffich.Clear;
      LesNomsAffich.CommaText:=SesNomsAffich[i];
      SetLength(NumBoitesIncluses[i],0);
      //************* Traiter aussi  le cas de plusieurs boites incluses; ****************
      if Not CherchePlaceBoite(LesTaxons,identiques[i],NumBoitesParentes[i],NumBoitesIncluses[i]) then
        begin
          Result:=False;
          //retirer les botes dj cres
          break;
        end;
    end;
      if Result then
        begin
          modif:=false;
          For i:=0 to SesEtats.Count-1 do
            begin
              if identiques[i] then
                begin
                //ajouter les caractres  la bote i
                  UneBoite:=Boites[NumBoitesParentes[i]];
                  if UneBoite<>Nil then
                    begin
                      UneBoite.Caracteres.Add(LeCaractere);
                      UneBoite.Etats.Add(SesEtats[i]);
                    end;
                end
              else
                begin
                  LesEtats.Clear;
                  LesEtats.Add(SesEtats[i]);
                  LesTaxons.Clear;
                  LesTaxons.CommaText:=SesTaxons[i];
                  LesNomsAffich.Clear;
                  LesNomsAffich.CommaText:=SesNomsAffich[i];
                  n:=CreeBoite(LesTaxons,LesCaracteres,LesEtats,LesnomsAffich,Couleurs[i]);
                  UneBoite:=Boites[n];
                  If UneBoite<>Nil then
                    begin
                      if Length(NumBoitesIncluses[i])>0 then
                        begin
                        //il faudra alors vrifier celles qui sont directement incluses
                          For j:=0 to Length(NumBoitesIncluses[i])-1 do
                            begin
                              if NumBoitesIncluses[i,j]>-1 then
                                begin
                                  LaBoiteIncluse:=Boites[NumBoitesIncluses[i,j]];
                                  if LaBoiteIncluse<>Nil then
                                    begin
                                      SaBoiteParente:=LaBoiteIncluse.Parent;
                                      if (SaBoiteParente<>Nil)and (SaBoiteParente.ListeComplete.Count>UneBoite.ListeComplete.Count) then
                                        begin
                                          SaBoiteParente.RetireDInclus(LaBoiteIncluse,false);
                                          UneBoite.AjouteInclus(LaBoiteIncluse);
                                          LaBoiteIncluse.Parent:=UneBoite;
                                          // supprimer les Taxons en double
                                          For k:=0 to LaBoiteIncluse.ListeEtiqComplete.Count-1 do
                                            begin
                                              n:=UneBoite.EtiqTaxons.IndexOf(LaBoiteIncluse.ListeEtiqComplete[k]);
                                              if n>-1 then UneBoite.EtiqTaxons.Delete(n);
                                            end;
                                        end
                                      else if SaBoiteParente=Nil then
                                        begin
                                          LaBoiteIncluse.Parent:=UneBoite;
                                          UneBoite.AjouteInclus(LaBoiteIncluse);
                                          For k:=0 to LaBoiteIncluse.ListeEtiqComplete.Count-1 do
                                            begin
                                              n:=UneBoite.EtiqTaxons.IndexOf(LaBoiteIncluse.ListeEtiqComplete[k]);
                                              if n>-1 then UneBoite.EtiqTaxons.Delete(n);
                                            end;
                                        end;
                                    end;
                                end;
                            end;
                        end;
                      If NumBoitesParentes[i]>-1 then
                        begin
                          UneBoite.Parent:=Boites[NumBoitesParentes[i]];
                          Boites[NumBoitesParentes[i]].AjouteInclus(UneBoite);
                          For k:=0 to UneBoite.ListeEtiqComplete.Count-1 do
                            begin
                              n:=Boites[NumBoitesParentes[i]].EtiqTaxons.IndexOf(UneBoite.ListeEtiqComplete[k]);
                              if n>-1 then Boites[NumBoitesParentes[i]].EtiqTaxons.Delete(n);
                            end;
                        end;
                    end;
                end;
            end;
        //Vrifier les embotements

        PositionneBoites;
      end;
      //PositionneBoites;
//    end;
  LesTaxons.Free;
  LesCaracteres.Free;
  LesnomsAffich.Free;
  LesEtats.Free;
end;
}
Function TGrapheBoite.CreeEtPlaceBoites(LeCaractere:string;SesTaxons,SesEtats,SesnomsAffich,SesGroupes:TStringList;Couleurs:Array of TColor32):Boolean;
Var
  i,j,k,n:integer;
  LesTaxons:TStringList;
  LesCaracteres:TStringList;
  LesnomsAffich:TStringList;
  LesEtats:TStringList;
  NumboitesParentes:Array of integer;
  NumBoitesIncluses:Array of TTableauDentiers;
  identiques:Array of Boolean;
  UneBoite,LaBoiteIncluse,SaBoiteParente:TBoiteLayer;
  modif:boolean;
begin
  LesCaracteres:=TStringList.Create;
  LesCaracteres.Add(LeCaractere);
  LesTaxons:=TStringList.Create;
  LesnomsAffich:=TStringList.Create;
  LesEtats:=TStringList.Create;
  SetLength(NumboitesParentes,SesEtats.Count);
  SetLength(NumBoitesIncluses,SesEtats.Count);
  SetLength(identiques,SesEtats.Count);
  Result:=True;
  For i:=0 to SesEtats.Count-1 do
    begin
      LesEtats.Clear;
      LesEtats.Add(SesEtats[i]);
      LesTaxons.Clear;
      LesTaxons.CommaText:=SesTaxons[i];
      LesNomsAffich.Clear;
      LesNomsAffich.CommaText:=SesNomsAffich[i];
      SetLength(NumBoitesIncluses[i],0);
      //************* Traiter aussi  le cas de plusieurs boites incluses; ****************
      if Not CherchePlaceBoite(LesTaxons,identiques[i],NumBoitesParentes[i],NumBoitesIncluses[i]) then
        begin
          Result:=False;
          PositionneBoites;
          RetireBoitesContenant(LeCaractere);
          PositionneBoites;
          break;
        end;
      if identiques[i] then
        begin
        //ajouter les caractres  la bote i
          UneBoite:=Boites[NumBoitesParentes[i]];
          if UneBoite<>Nil then
            begin
              UneBoite.Caracteres.Add(LeCaractere);
              UneBoite.Etats.Add(SesEtats[i]);
            end;
        end
      else
        begin
          LesEtats.Clear;
          LesEtats.Add(SesEtats[i]);
          LesTaxons.Clear;
          LesTaxons.CommaText:=SesTaxons[i];
          LesNomsAffich.Clear;
          LesNomsAffich.CommaText:=SesNomsAffich[i];
          n:=CreeBoite(LesTaxons,LesCaracteres,LesEtats,LesnomsAffich,Couleurs[i]);
          UneBoite:=Boites[n];
          If UneBoite<>Nil then
            begin
              UneBoite.NomGroupe:=SesGroupes[i];
              if Length(NumBoitesIncluses[i])>0 then
                begin
                //il faudra alors vrifier celles qui sont directement incluses
                  For j:=0 to Length(NumBoitesIncluses[i])-1 do
                    begin
                      if NumBoitesIncluses[i,j]>-1 then
                        begin
                          LaBoiteIncluse:=Boites[NumBoitesIncluses[i,j]];
                          if LaBoiteIncluse<>Nil then
                            begin
                              SaBoiteParente:=LaBoiteIncluse.Parent;
                              if (SaBoiteParente<>Nil)and (SaBoiteParente.ListeComplete.Count>UneBoite.ListeComplete.Count) then
                                begin
                                  SaBoiteParente.RetireDInclus(LaBoiteIncluse,false);
                                  UneBoite.AjouteInclus(LaBoiteIncluse);
                                  LaBoiteIncluse.Parent:=UneBoite;
                                  // supprimer les Taxons en double
                                  For k:=0 to LaBoiteIncluse.ListeEtiqComplete.Count-1 do
                                    begin
                                      n:=UneBoite.EtiqTaxons.IndexOf(LaBoiteIncluse.ListeEtiqComplete[k]);
                                      if n>-1 then UneBoite.EtiqTaxons.Delete(n);
                                    end;
                                end
                              else if SaBoiteParente=Nil then
                                begin
                                  LaBoiteIncluse.Parent:=UneBoite;
                                  UneBoite.AjouteInclus(LaBoiteIncluse);
                                  For k:=0 to LaBoiteIncluse.ListeEtiqComplete.Count-1 do
                                    begin
                                      n:=UneBoite.EtiqTaxons.IndexOf(LaBoiteIncluse.ListeEtiqComplete[k]);
                                      if n>-1 then UneBoite.EtiqTaxons.Delete(n);
                                    end;
                                end;
                            end;
                        end;
                    end;
                end;
              If NumBoitesParentes[i]>-1 then
                begin
                  UneBoite.Parent:=Boites[NumBoitesParentes[i]];
                  Boites[NumBoitesParentes[i]].AjouteInclus(UneBoite);
                  For k:=0 to UneBoite.ListeEtiqComplete.Count-1 do
                    begin
                      n:=Boites[NumBoitesParentes[i]].EtiqTaxons.IndexOf(UneBoite.ListeEtiqComplete[k]);
                      if n>-1 then Boites[NumBoitesParentes[i]].EtiqTaxons.Delete(n);
                    end;
                  {For j:=0 to Length(UneBoite.Inclus)-1 do
                    begin
                      UneBoite.Parent.RetireDInclus(UneBoite.Inclus[j],false);
                    end;}
                end;
            end;
        end;
      PositionneBoites;
    end;
  LesTaxons.Free;
  LesCaracteres.Free;
  LesnomsAffich.Free;
  LesEtats.Free;
end;
Function TGrapheBoite.CherchePlaceBoite(ListeTaxons:TStringList;var identique:boolean;var NumBoiteParente:integer;var NumBoiteIncluse:TTableauDentiers):boolean;
Var
  i,j,n:integer;
  UneBoite,BoiteTest:TBoiteLayer;
  nbTaxPar:integer;
  UnTaxonCommun:Boolean;
begin
  Result:=True;
  identique:=False;
  nbTaxPar:=1000;
  NumBoiteParente:=-1;
  SetLength(NumBoiteIncluse,0);
  For i:=0 to Length(Boites)-1 do
    begin
      UneBoite:=Boites[i];
      if UneBoite<>Nil then
        begin
          if ListeTaxons.Count=UneBoite.ListeComplete.Count then
            begin
              UnTaxonCommun:=False;                 //tester l'identit ou la sparation complte
              For j:=0 to ListeTaxons.Count-1 do
                begin
                  if UneBoite.ListeComplete.IndexOf(ListeTaxons[j])<0 then
                    begin
                      identique:=False;
                      if UnTaxonCommun then
                        begin
                          result:=False;
                          exit;
                        end;
                    end
                  else UnTaxonCommun:=True;
                end;
              If UnTaxonCommun then
                begin
                  identique:=True;
                  NumBoiteParente:=i;
                  SetLength(NumBoiteIncluse,0);
                  Result:=True;
                  exit;
                end;
            end
          else if ListeTaxons.Count>UneBoite.ListeComplete.Count then
            begin  // tester si elle inclut l'autre
              UnTaxonCommun:=False;
              For j:=0 to UneBoite.ListeComplete.Count-1 do
                begin
                  if ListeTaxons.IndexOf(UneBoite.ListeComplete[j])<0 then
                    begin
                      if UnTaxonCommun then
                        begin
                          Result:=False;
                          NumBoiteParente:=-1;
                          SetLength(NumBoiteIncluse,0);
                          exit;
                        end;
                    end
                  else UnTaxonCommun:=True;
                end;
              If UnTaxonCommun then
                begin
                  n:=Length(NumBoiteIncluse);
                  SetLength(NumBoiteIncluse,n+1);
                  NumBoiteIncluse[n]:=i;
                end;
            end
          else
            begin
              UnTaxonCommun:=False;
              For j:=0 to ListeTaxons.Count-1 do
                begin
                  if UneBoite.ListeComplete.IndexOf(ListeTaxons[j])<0 then
                    begin
                      if UnTaxonCommun then
                        begin
                          Result:=False;
                          NumBoiteParente:=-1;
                          SetLength(NumBoiteIncluse,0);
                          exit;
                        end;
                    end
                  else UnTaxonCommun:=True;
                end;
              If UnTaxonCommun then
                begin
                  if UneBoite.ListeComplete.Count<nbTaxPar then
                    begin      //choisir celle qui contient le moins de taxons
                      nbTaxPar:=UneBoite.ListeComplete.Count;
                      NumBoiteParente:=i;
                    end;
                end;
            end;
        end;
    end;
  //vrifier la non redondance des inclusions
  n:=Length(NumBoiteIncluse);
  For i:=0 to n-1 do
    begin
      UneBoite:=Boites[NumBoiteIncluse[i]];
      for j:=0 to n-1 do
        begin
          if (j<>i) and (NumBoiteIncluse[j]>-1) then
            begin
              BoiteTest:=Boites[NumBoiteIncluse[j]];
              if UneBoite.EstIncluDans(BoiteTest) then
                NumBoiteIncluse[i]:=-1;
            end;
        end;
    end;
end;
procedure TGrapheBoite.RazListesTaxonsExe;
Var
  i:integer;
  UneBoite:TBoiteLayer;
begin
  For i:=0 to Length(Boites)-1 do
    begin
      UneBoite:=Boites[i];
      if UneBoite<>Nil then UneBoite.ListeTaxonsExe.Clear;
    end;
end;
Procedure TGrapheBoite.ReclasseBoites(ListeCar:TStringList);
Var
  i,n,p:integer;
begin
  n:=0;
  Attente:=True;
  For i:=0 to ListeCar.Count-1 do
    begin
      p:=ExisteBoite(ListeCar[i]);
      if (p>-1) then
        begin
          if p>n then
            ChangeOrdreBoite(p,n);
          inc(n);
        end;
    end;
  PositionneBoites;
  Attente:=False;
end;
Function TGrapheBoite.StructArbre:String;
Var
  i:integer;
  UneBoite:TBoiteLayer;
begin
  For i:=0 to Length(Boites) do
    begin
      UneBoite:=Boites[i];
      if Length(UneBoite.Inclus)=0 then
        begin
        end;
    end;
end;
Function TGrapheBoite.StructBoite:String;
Var
  i:integer;
begin
  Result:='';
  For i:=0 to Length(Boites)-1 do
    if Boites[i].Parent=nil then Result:=Result+Boites[i].StructureB;
end;
Function TGrapheBoite.StructBoiteVide:String;
Var
  i:integer;
begin
  Result:='';
  For i:=0 to Length(Boites)-1 do
    if Boites[i].Parent=nil then Result:=Result+Boites[i].StructureBV;
end;
Function TGrapheBoite.StructBoiteComp:String;
Var
  i:integer;
begin
  Result:='';
  For i:=0 to Length(Boites)-1 do
    if Boites[i].Parent=nil then Result:=Result+Boites[i].StructureBComp;
end;
Procedure TGrapheBoite.SetAffichEtat(Etat:Boolean);
Var
  i:integer;
begin
  if FAffichEtat<>Etat then
    begin
      FAffichEtat:=Etat;
      PositionneBoites;
    end;
end;
Procedure TGrapheBoite.CreeBoitesDApresStructure(BoiteParente:TBoiteLayer;ChaineStruct:string;limG,limD:string);
Var
  i,valp,n,nbi:integer;
  lettre:string[1];
  chaine:string;
  LectStruc:boolean;
  DerniereBoite:TBoiteLayer;
begin
  i:=0;
  valp:=1;
  n:=2;
  LectStruc:=True;
  chaine:='';
  While n<=length(ChaineStruct) do
    begin
      lettre:=ChaineStruct[n];
      inc(n);
      if LectStruc then
        begin
          if (lettre<>limD) and (lettre<>limG) then
            chaine:=chaine+lettre
          else if trim(chaine)<>'' then
            begin
              DerniereBoite:=NouvelleBoiteDApresStructure(BoiteParente,chaine);
              chaine:='';
              if BoiteParente<>nil then
                begin
                  nbi:=Length(BoiteParente.Inclus);
                  SetLength(BoiteParente.Inclus,nbi+1);
                  BoiteParente.Inclus[nbi]:=DerniereBoite;
                end;
              if lettre=limG then
                begin
                  inc(valp);
                  chaine:=lettre;
                  LectStruc:=false;
                end
              else inc(n);
            end;
        end
      else
        begin
          chaine:=chaine+lettre;
          if lettre=limD then dec(valp)
          else if lettre=limG then inc(valp);
          if valp=0 then
            begin
              CreeBoitesDApresStructure(DerniereBoite,Chaine,limG,limD);
              DerniereBoite:=Nil;
              chaine:='';
              valp:=1;
              inc(n);
             LectStruc:=True;
            end;
        end;
    end;
end;
Function TGrapheBoite.NouvelleBoiteDApresStructure(BoiteParente:TBoiteLayer;ChaineStruct:string):TBoiteLayer;
Var
  StringListB:TStringList;
    //LesTaxons,LesCaracteres,LesEtats,LesNomsAffich:TStringList;
    //Couleur:TColor32;
  n:integer;
  LaBoite:TBoiteLayer;
begin
  StringListB:=TStringList.Create;
  StringListB.CommaText:=ChaineStruct;
  LaBoite:=TBoiteLayer.CreateBoite(Self);
  LaBoite.Parent:=BoiteParente;
  LaBoite.Nom:=StringListB[0];
  LaBoite.NomGroupe:=StringListB[1];
  LaBoite.ListeTaxonsExe.CommaText:=StringListB[2];
  LaBoite.EtiqTaxons.CommaText:=StringListB[3];
  LaBoite.ListeComplete.CommaText:=StringListB[4];
  LaBoite.Caracteres.CommaText:=StringListB[5];
  LaBoite.Etats.CommaText:=StringListB[6];
  LaBoite.ListeEtiqComplete.CommaText:=StringListB[7];
  LaBoite.Encadre:=True;
  n:=AjouteBoite(LaBoite);
  StringListB.Clear;
  Result:=LaBoite;
end;
Function TGrapheBoite.NombreNiveaux:integer;
Var
  n,i:integer;
  LaBoite:TBoiteLayer;
begin
  Result:=0;
  For i:=0 to Length(Boites)-1 do
    begin
      if (Boites[i]<>Nil) and (Boites[i].Parent=Nil) then
        begin
          n:=Boites[i].NombreNiveaux;
          if n>Result then
            Result:=n;
        end;
    end;
  if Length(Boites)>0 then inc(Result);
end;

Procedure TGrapheBoite.VerifieListesAffichees;
Var
  n,i,j,k,p:integer;
  UneBoite:TBoiteLayer;
begin
  For n:=0 to NombreNiveaux-1 do
    begin
      For i:=0 to Length(Boites)-1 do
        begin
          if (Boites[i]<>Nil) and (Boites[i].Niveau=n) then
            begin
              UneBoite:=Boites[i];
              UneBoite.EtiqTaxons.Clear;
              UneBoite.EtiqTaxons.AddStrings(UneBoite.ListeEtiqComplete);
              For j:=0 to Length(UneBoite.Inclus)-1 do
                if UneBoite.Inclus[j]<>Nil then
                  begin
                    for k:=0 to UneBoite.Inclus[j].ListeEtiqComplete.Count-1 do
                      begin
                        p:=UneBoite.EtiqTaxons.IndexOf(UneBoite.Inclus[j].ListeEtiqComplete[k]);
                        if p>-1 then
                          UneBoite.EtiqTaxons.Delete(p);
                      end;
                  end;
            end;
        end;
    end;
end;
procedure Register;
begin
  RegisterComponents('JFM', [TGrapheBoite]);
end;

end.
